SystemOrganization addCategory: #'Path-Core-Models'!
SystemOrganization addCategory: #'Path-Core-Morphic'!
SystemOrganization addCategory: #'Path-Core-Projects'!
SystemOrganization addCategory: #'Path-Core-Specs'!
SystemOrganization addCategory: #'Path-Core-Tools'!
SystemOrganization addCategory: #'Path-Core-Tools-Browser'!
SystemOrganization addCategory: #'Path-Core-Tools-Finder'!
SystemOrganization addCategory: #'Path-Core-Tools-Map'!
SystemOrganization addCategory: #'Path-Core-Tools-Projects'!
SystemOrganization addCategory: #'Path-Core-Tools-View'!
SystemOrganization addCategory: #'Path-Core-Tracer'!

PluggableTreeMorph subclass: #SPluggableTreeMorph
	instanceVariableNames: 'highlightItemSelector indentingListItemMorphClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/20/2010 17:55'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean 
	"Hook for highlighting currently expanded tree nodes"
	| result |
	result := super 
		addSubmorphsAfter: parentMorph
		fromCollection: aCollection
		allowSorting: sortBoolean.
	self highlightItemSelector ifNotNil:[
		self refreshHighlightingOf: parentMorph.
		result do: [:each | self refreshHighlightingOf: each]].
	^ result! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 4/14/2010 11:34'!
adjustSubmorphPositions

	super adjustSubmorphPositions.
	scroller submorphsDo: [ :each | 
		each isCodeExplorerIndentingListItemMorph 
			ifTrue: [each adjustCustomMorphs]].! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 7/7/2010 16:42:50.962'!
contentsOfNode: node
	"Overwritten for interchanging PluggableTreeItemNode"
	| children |
	self getChildrenSelector ifNil:[^#()].
	children := self model perform: self getChildrenSelector with: node item.
	^children collect:[:item | SPluggableTreeItemNode with: item model: self]! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/29/2010 10:34'!
expandAllOfSelectedNode
	
	selectedMorph ifNil: [^ self].
	selectedMorph isExpanded ifTrue: [self toggleExpandedState: selectedMorph].
	self expandAll.! !

!SPluggableTreeMorph methodsFor: 'geometry' stamp: 'mp 7/16/2013 11:14:06.862'!
extent: aPoint

	super extent: aPoint.
	"Required for collapse system window"
	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show].! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 1/20/2010 17:55'!
firstRootTreeEntry

	^ self scroller submorphs first! !

!SPluggableTreeMorph methodsFor: 'scrolling' stamp: 'mp 7/4/2011 15:31:16.39'!
hUnadjustedScrollRange
"Return the width of the widest item in the list"

	| max count |

	max := 0.
	count := 0.
	scroller submorphsDo: [ :each | | width right |
		width := each isCodeExplorerIndentingListItemMorph
			ifTrue: [each requiredWidth]
			ifFalse: [each font widthOfStringOrText: each contents].
		right := (each toggleRectangle right + width + 10).
		max := max max: right.
		
"NOTE: need to optimize this method by caching list item morph widths (can init that cache most efficiently in the #list: method before the item widths are reset to 9999).  For now, just punt on really long lists"
		((count := count + 1) > 200) ifTrue:[ ^max * 3].
	].

	^max! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:55'!
highlightItemSelector
	^ highlightItemSelector! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:55'!
highlightItemSelector: anObject
	highlightItemSelector := anObject! !

!SPluggableTreeMorph methodsFor: 'initialization' stamp: 'mp 4/14/2010 11:21'!
indentingItemClass
	
	^ self indentingListItemMorphClass! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:17'!
indentingListItemMorphClass
	"Answer the value of indentingListItemMorphClass"

	^ indentingListItemMorphClass ifNil: [indentingListItemMorphClass := IndentingListItemMorph]! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:17'!
indentingListItemMorphClass: anObject
	"Set the value of indentingListItemMorphClass"

	indentingListItemMorphClass := anObject! !

!SPluggableTreeMorph methodsFor: 'private' stamp: 'mp 1/20/2010 17:55'!
insertNewMorphs: morphList 
	"Hook for highlighting root nodes after init or refresh"
	self highlightItemSelector 
		ifNotNil: [morphList do: [ :each | self refreshHighlightingOf: each ]].
	super insertNewMorphs: morphList! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refresh: aBlock fromNode: aMorph
	aMorph withSiblingsDo: [:sib | 
		aBlock value: sib.
		sib firstChild ifNotNil: [self refresh: aBlock fromNode: sib firstChild]].! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 9/22/2010 14:01:56.496'!
refreshHighlighting
	self refresh: [:node | self refreshHighlightingOf: node] fromNode: self firstRootTreeEntry! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refreshHighlightingOf: aMorph 
	(self model perform: self highlightItemSelector	with: aMorph complexContents item) 
		ifTrue: [aMorph highlight]
		ifFalse: [aMorph unhighlight]! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 18:36'!
refreshIconOf: aMorph
	aMorph icon: (self model 
					perform: self getIconSelector 
					with: aMorph complexContents item).
	aMorph changed.! !

!SPluggableTreeMorph methodsFor: 'refreshing' stamp: 'mp 1/20/2010 17:55'!
refreshIcons
	self refresh: [:node | self refreshIconOf: node] fromNode: self firstRootTreeEntry.! !

!SPluggableTreeMorph methodsFor: 'node access' stamp: 'mp 1/20/2010 17:55'!
rootMorphs
	"Answer the receiver's roots"
	^ self scroller submorphs
		select: [:each | each indentLevel isZero]! !

!SPluggableTreeMorph methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:42:55.915'!
roots: anArray
	"Overwritten for interchanging PluggableTreeItemNode"
	roots := anArray collect:[:item| SPluggableTreeItemNode with: item model: self].
	self list: roots.! !

!SPluggableTreeMorph methodsFor: 'selection' stamp: 'mp 3/24/2011 17:26:09.673'!
setSelectedMorph: aMorph 
	| selected |
	selected := self selectedMorph.
	super setSelectedMorph: aMorph.
	(selected notNil and: [self highlightItemSelector notNil])
		ifTrue: [self refreshHighlightingOf: selected].
	(aMorph notNil and: [aMorph isCodeExplorerIndentingListItemMorph])
		ifTrue: [aMorph 
					highlightInPathMapIfPossible;
					toggleCodeView].! !

!SPluggableTreeMorph methodsFor: 'updating' stamp: 'mp 1/29/2010 10:32'!
update: what
	what ifNil:[^self].
	what == self highlightItemSelector ifTrue:[
		self refreshHighlighting.
		^self].
	what == self getIconSelector ifTrue:[
		self refreshIcons.
		^self].
	what == #expandAllOfSelectedNode ifTrue: [
		self expandAllOfSelectedNode.
		^ self].
	^super update: what! !

PluggablePanelSpec subclass: #SPluggableFlapSpec
	instanceVariableNames: 'icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Specs'!

!SPluggableFlapSpec methodsFor: 'building' stamp: 'mp 9/13/2010 14:57:47.442'!
buildWith: builder
	^ builder buildPluggableFlap: self.! !

!SPluggableFlapSpec methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:54:11.991'!
icon
	"Answer the value of icon"

	^ icon! !

!SPluggableFlapSpec methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:54:11.995'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !

!IndentingListItemMorph methodsFor: '*Path-Core-override' stamp: 'mp 4/16/2010 17:50'!
drawOn: aCanvas

	
	| tRect sRect columnScanner columnLeft |
	tRect := self toggleRectangle.

	sRect := self stringRectangle withLeft: tRect right + 4.
	self drawToggleOn: aCanvas in: tRect.
	self drawRectangleOn: aCanvas in: sRect.

	icon isNil ifFalse:[
		aCanvas
			translucentImage: icon
	
			at: sRect left @ (self top + (self height - icon height // 2)).
	

		sRect := sRect left: sRect left + icon width + 2.
	].

	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		sRect := sRect top: sRect top + sRect bottom - self fontToUse height // 2.
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: color.
	
	] ifFalse: [
		columnLeft := sRect left.
		columnScanner := ReadStream on: contents asString.
		container columns do: [ :width | | columnRect columnData |
			columnRect := columnLeft @ sRect top extent: width @ sRect height.
			columnData := columnScanner upTo: Character tab.
			columnData isEmpty ifFalse: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: color
.
			].
			columnLeft := columnRect right + 5.
		].
	]
! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 4/16/2010 17:50'!
drawRectangleOn: aCanvas in: aRectangle! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 12/8/2009 09:33'!
icon: anIcon

	icon := anIcon.! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 4/14/2010 11:33'!
isCodeExplorerIndentingListItemMorph

	^ false! !

!IndentingListItemMorph methodsFor: '*Path-Core' stamp: 'mp 4/14/2010 12:11'!
stringRectangle

	^ bounds ! !

IndentingListItemMorph subclass: #SCodeExplorerIndentingListItemMorph
	instanceVariableNames: 'isCodeExpanded codePane minWidthOfMorph previousSibling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 13:36'!
backgroundColorEven

	^ Color gray: 1.0! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 13:35'!
backgroundColorOdd

	^ Color gray: 0.9! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/16/2010 18:30'!
borderColor

	^ Color gray:0.5! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 14:27'!
borderOffset

	^  4! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 15:48'!
borderWidth
	
	^ 1! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 10:56'!
buttonSpace

	^ 3! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 20:40'!
indentingPixel

	^ 12! !

!SCodeExplorerIndentingListItemMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 21:49'!
itemHeight
	
	^ 15! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 15:45'!
adjustCustomMorphs

	codePane ifNotNil: [ "direct access to prevent lazy initialization"
		self codePane position: (self class indentingPixel * (indentLevel + 1)) 
							@ (self position y)].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 11:56'!
callNode

	^ self complexContents item! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 7/16/2013 17:09:25.784'!
callTreeModel

	^ self callNode callTreeModel! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:44:34.542'!
codePane
	"Answer the value of codePane"

	^ codePane ifNil: [codePane := SCodePaneMorph on: self callNode color: self getBackgroundColor].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 13:45'!
codePane: anObject
	"Set the value of codePane"

	codePane := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/16/2010 19:39'!
computeMaxWidthOfSiblings

	| max |
	max := 0.
	self withSiblingsDo: [:each |  max := each minWidth max: max].
	self withPreviousSiblingsDo: [:each |  max := each minWidth max: max].
	^ max! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:55'!
container

	^ container! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 15:48'!
drawRectangleOn: aCanvas in: aRectangle
	| rect |
	rect := Rectangle 
			origin: (aRectangle origin x - self class borderOffset) @ (aRectangle origin y)
			corner: (aRectangle origin x + self visibleWidth + self class borderOffset) @ (aRectangle corner y).
	aCanvas 
		frameAndFillRectangle: rect 
		fillColor: self getBackgroundColor 
		borderWidth: 0 
		borderColor: self class borderColor.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/17/2010 16:54'!
getBackgroundColor

	| bgColor |
	bgColor := self class backgroundColorOdd.
	self indentLevel even ifTrue: [bgColor := self class backgroundColorEven].
	^ bgColor! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'actions' stamp: 'mp 3/24/2011 17:27:21.627'!
highlightInPathMapIfPossible
	SPMPathMap allInstances do: [:each |
		[(each 
			getMethodMorph: self callNode clientClass 
			and: self callNode clientSelector) highlight] on: Error do: []].! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'initialization' stamp: 'mp 4/24/2010 14:16'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel

	super initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel.
	self 
		extent: self minWidth@self class itemHeight;
		isCodeExpanded: false;
		previousSibling: priorMorph.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:52'!
isCodeExpanded
	"Answer the value of isCodeExpanded"

	^ isCodeExpanded! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:52'!
isCodeExpanded: anObject
	"Set the value of isCodeExpanded"

	isCodeExpanded := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'testing' stamp: 'mp 4/14/2010 11:33'!
isCodeExplorerIndentingListItemMorph

	^ true! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:17'!
minWidthOfMorph
	"Answer the value of minWidthOfMorph"

	^ minWidthOfMorph ifNil: [minWidthOfMorph := self computeMaxWidthOfSiblings]! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
minWidthOfMorph: anObject
	"Set the value of minWidthOfMorph"

	minWidthOfMorph := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
previousSibling
	"Answer the value of previousSibling"

	^ previousSibling! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'accessing' stamp: 'mp 4/16/2010 19:38'!
previousSibling: anObject
	"Set the value of previousSibling"

	previousSibling := anObject! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'scrolling' stamp: 'mp 7/16/2013 17:12:49.616'!
requiredWidth
	self isCodeExpanded ifTrue: [
		^ self codePane width + 
			(self codePane objectExplorationMorphsStack size *
				SObjectExplorationMorph explorationMinWidth)].
	^ self font widthOfStringOrText: self contents! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 20:50'!
stringRectangle

	self isCodeExpanded ifFalse: [^ super stringRectangle].
	^ bounds origin corner: (bounds corner x @ (bounds origin y + self class itemHeight))! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'actions' stamp: 'mp 4/27/2010 15:47'!
toggleCodeView

	self isCodeExpanded
		ifTrue: [self 
				extent: self width@self class itemHeight;
				removeMorph: self codePane]
		ifFalse: [self 
				addMorph: self codePane;
				extent: self width@(self codePane height)].
	self isCodeExpanded: self isCodeExpanded not.
	self container adjustSubmorphPositions.! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'drawing' stamp: 'mp 4/15/2010 20:51'!
toggleRectangle

	self isCodeExpanded ifFalse: [^ super toggleRectangle].
	^(bounds left + (self class indentingPixel * indentLevel)) @ bounds top 
		extent: self class indentingPixel@self class itemHeight! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'morphic' stamp: 'mp 4/24/2010 14:20'!
visibleWidth

	^ self minWidthOfMorph! !

!SCodeExplorerIndentingListItemMorph methodsFor: 'siblings' stamp: 'mp 4/16/2010 19:39'!
withPreviousSiblingsDo: aBlock
	"Iterate also previous siblings"
	| node |
	node := self.
	[node isNil] whileFalse: [
		aBlock value: node.
		node := node previousSibling
	].! !

!MorphicToolBuilder methodsFor: '*Path-Core-override' stamp: 'mp 9/15/2010 14:40:10.3'!
buildPluggableCheckBox: aSpec
	| widget label state action enabled |
	label := aSpec label.
	state := aSpec state.
	action := aSpec action.
	widget := SPluggableCheckBoxMorph on: aSpec model
				getState: (state isSymbol ifTrue:[state])
				action: nil
				label: (label isSymbol ifTrue:[label]).
	self register: widget id: aSpec name.
	enabled := aSpec enabled.
	enabled isSymbol
		ifTrue:[widget getEnabledSelector: enabled]
		ifFalse:[widget enabled: enabled].
	widget action: action.
	widget getColorSelector: aSpec color.
	self buildHelpFor: widget spec: aSpec. 
	(label isSymbol or:[label == nil]) ifFalse:[widget label: label].
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 19:02:48.438'!
buildPluggableFlap: aSpec
	| widget children frame |
	widget := self flapClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	aSpec icon ifNotNil: [widget flapIcon: aSpec icon].
	
	widget clipSubmorphs: true.
	children := aSpec children.
	children isSymbol ifTrue: [
		widget getChildrenSelector: children.
		widget update: children.
		children := #()].
	self buildAll: children in: widget.
	
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	self setLayout: aSpec layout in: widget.
	widget 
		layoutInset: 3;
		borderWidth: 2;
		borderColor: #raised.
	widget submorphsDo: [:sm |
		(frame := sm layoutFrame) ifNotNil:[
			(frame rightFraction = 0 or:[frame rightFraction = 1]) 
				ifFalse:[frame rightOffset: 1].
			(frame bottomFraction = 0 or: [frame bottomFraction = 1]) 
				ifFalse:[frame bottomOffset: 1]]].
	widget color: (Color r: 0.672 g: 0.672 b: 0.672).
	widget layoutFrame leftOffset: 1.
	widget switchExpandState.
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core-override' stamp: 'mp 1/25/2010 11:28'!
buildPluggableTree: aSpec
	| widget |
	widget := (self pluggableTreeMorphClass: aSpec) new.
	self register: widget id: aSpec name.
	self setAdditionalTreeSpecs: aSpec on: widget.
	widget model: aSpec model.
	widget getSelectedPathSelector: aSpec getSelectedPath.
	widget setSelectedSelector: aSpec setSelected.
	widget getChildrenSelector: aSpec getChildren.
	widget hasChildrenSelector: aSpec hasChildren.
	widget getLabelSelector: aSpec label.
	widget getIconSelector: aSpec icon.
	widget getHelpSelector: aSpec help.
	widget getMenuSelector: aSpec menu.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getRootsSelector: aSpec roots.
	widget autoDeselect: aSpec autoDeselect.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec roots ifNotNil:[panes add: aSpec roots].
	].
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/23/2010 17:46:34.678'!
buildSPluggableMultiSelectionList: aSpec
	| widget listClass |
	aSpec getSelected ifNotNil:[^self error:'There is no PluggableListMorphOfManyByItem'].
	listClass := SPluggableListMorphOfMany.
	widget := listClass on: aSpec model
		list: aSpec list
		primarySelection: aSpec getIndex
		changePrimarySelection: aSpec setIndex
		listSelection: aSpec getSelectionList
		changeListSelection: aSpec setSelectionList
		menu: aSpec menu.
	widget setItemColorSelector: aSpec itemColor.
	self register: widget id: aSpec name.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	parent isSystemWindow
		ifFalse: [widget 
					borderWidth: 1; 
					borderColor: #inset;
					color: Color white].
	^widget! !

!MorphicToolBuilder methodsFor: '*Path-Core-override' stamp: 'mp 3/24/2011 12:15:07.882'!
codePaneClass
	^ SPluggableTextMorphPlus! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 15:05:41.639'!
flapClass

	^ SPluggableFlapMorph! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 7/7/2010 16:41:03.577'!
pluggableTreeMorphClass: aSpec

	(aSpec isKindOf: SPluggableTreeSpec) ifTrue: [^ SPluggableTreeMorph].
	^ PluggableTreeMorph! !

!MorphicToolBuilder methodsFor: '*Path-Core' stamp: 'mp 7/7/2010 16:41:07.354'!
setAdditionalTreeSpecs: aSpec on: aWidget

	(aSpec isKindOf: SPluggableTreeSpec) 
		ifTrue: [
			aWidget highlightItemSelector: aSpec highlightItem.
			aWidget indentingListItemMorphClass: aSpec indentingListItemMorph].! !

PluggableTextMorphPlus subclass: #SPluggableTextMorphPlus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTextMorphPlus methodsFor: 'private' stamp: 'mp 7/7/2010 16:40:31.48'!
textMorphClass
	"Answer the class used to create the receiver's textMorph"
	
	^ STextMorphForEditView! !

!Morph methodsFor: '*Path-Core-override' stamp: 'mp 1/20/2010 19:05'!
openModal: aSystemWindow
	"Open the given window locking the receiver until it is dismissed.
	Answer the system window.
	Restore the original keyboard focus when closed."

	|area mySysWin keyboardFocus|
	keyboardFocus := self activeHand keyboardFocus.
	mySysWin := self isSystemWindow ifTrue: [self] ifFalse: [self ownerThatIsA: SystemWindow].
	mySysWin ifNil: [mySysWin := self].
	mySysWin modalLockTo: aSystemWindow.
	area := RealEstateAgent maximumUsableArea.
	self class environment at: #Flaps ifPresent: [:cl |
		RealEstateAgent reduceByFlaps: area].
	aSystemWindow extent: aSystemWindow initialExtent.
	aSystemWindow position = (0@0)
		ifTrue: [aSystemWindow
				position: self activeHand position - (aSystemWindow extent // 2)].
	aSystemWindow
		bounds: (aSystemWindow bounds translatedToBeWithin: area).
	[ToolBuilder default runModal: aSystemWindow openAsIs]
		ensure: [mySysWin modalUnlockFrom: aSystemWindow.
				self activeHand newKeyboardFocus: keyboardFocus].
	^aSystemWindow! !

!Morph methodsFor: '*Path-Core-override' stamp: 'mp 1/25/2010 13:05'!
visible: aBoolean 
	"set the 'visible' attribute of the receiver to aBoolean"
	(extension isNil and:[aBoolean]) ifTrue: [^ self].
	self visible == aBoolean ifTrue: [^ self].
	self assureExtension visible: aBoolean.
	self changed.
	owner ifNotNil: [owner layoutChanged]. "Changed for 3.9 compatibility and forward events again after hiding"! !

!ToolBuilder methodsFor: '*Path-Core' stamp: 'mp 9/13/2010 14:44:42.133'!
pluggableFlapSpec
	^SPluggableFlapSpec! !

!Bitmap methodsFor: '*Path-Core' stamp: 'mp 7/9/2010 11:11:20.572'!
uncompressedBits
	| stream |
	stream := WriteStream on: OrderedCollection new.
	self writeUncompressedOn: stream.
	^ stream contents! !

!TestCase class methodsFor: '*Path-Core' stamp: 'mp 3/24/2011 10:54:24.775'!
inheritedTestSelectors
	^ self shouldInheritSelectors
		ifTrue: [self allTestSelectors]
		ifFalse: [self testSelectors ]! !

UiIcons subclass: #SPathToolsIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPathToolsIcons class methodsFor: 'accessing' stamp: 'mp 8/14/2013 09:33:56.835'!
collapseIcon
	"Auto-generated.
	
	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ Icons
		at: #fugueCollapse
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self collapseIconContents readStream) ].! !

!SPathToolsIcons class methodsFor: 'contents' stamp: 'mp 8/14/2013 09:33:56.828'!
collapseIconContents
	"Auto-generated.

	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ 'iVBORw0KGgoAAAANSUhEUgAAACgAAAAoCAYAAACM/rhtAAAE20lEQVR42s2YyU4rRxSGy2Dm
ecZwEVfMg3TfIEoUZZF3yAMgVtlmyTJPgMQ+z5BVNpGiZHs3zJMIl2ae58nkfG2X6SpXuw3X
wfxSgXs69fWpc05VdUylNTMz8yEWi/0qP3+U1qKKo2Npvz89Pf0yMTHxhRMx/kxPT38sLS39
LIAN0orElpLA0U6TyeSnycnJf2NTU1Pxjo6OPwTwWzmpHh4e/JuKIZwTj8dVSUmJenx8/HN3
d/cHAJsSicSeQMXv7++L6j2tsrIyYB+2t7fbAezs6uraxnNCnfPB29tbVVFR8VWd52NDRtP3
pOd5CQATAugByBC7xJDf3d2pnp4etbm5qcrLy1UwVvE8bx2UfS7KRlAMcRqwKwOo488W5+ls
ZGREVVdXq6urK7WwsJDpgGt1dXXq5ubGeK6yslKdn5/7kBouzIYtHYcGIEbsGASONjg46BvW
ooPFxUXfeH19verr61Ozs7PGs+Pj42ptbU2dnZ35gMPDw04bQNpKx6AJqIfFBhwdHfVjwhYd
7O/vq97eXv94bm7OuD42Nub/39jYUG1tbQacDWnHpA4NAxCXEsBB8dYuOJfCAKN0fX2t1tfX
jXMA4xwDEBA7jhobG5Vc+18BBUKdnJwY54hfKkoGUOThVhsQNTQ05AU5Pz9vHBMa+cCdnp5m
nQeQhM0AdnZ2ergVd7uEJ+UlCgooRTjLc1pVVVV+1ss9z4BQE7QukTwAEuyFACS5ALRrpxYJ
RT5kAGUu9mpqatTl5aUTjmuUklyirgVFzcslShD9uSDpD2ft7Ow8A9bW1qqLi4usm4nBqOF9
DSDCi64YhAX4DGB7e7tHwaXyvwcxM8Eiq5kUoMSWRyK8J0BmIAOwqanJP/kexGiS4Xt7eynA
1tZWr7m52elBgpWUjxIjEFRYCQmKedg1BeLBLMCWlhanB6UE+W8UpaWlJeN4aGgo8hn6k0Rw
evDo6IhylAIUOI8a58qofCFfChgGh6gch4eHz4AyvJ5kcmgMMi8CaQ9jUMvLy8YxS7QwMXzA
hS1EcMbBwQEtGhA4GnUt18rmJYDYo25iz2UzC1Ay2JNinQWYL9xLAaMgAWQ6lGE2Ae0sJnvz
XROurKwYxwMDA5HPAOlaVZPFBqDElkeM2YCslsMm9EIAIuZ6Vt2vAmQJ1t3d7W9gbLHawMMY
ywWITSZ/lw1WzVtbW1kreWxKDaTUpAAlrT0WBK7FAu63ITHIYpMOSC4Mrq6uGs/19/f7nQDo
sqHhXJMAiwUnICsI12ePYAdBOC0gMWh7ITgiQRu54NjN4XEDULLGB6Rz195YDzezDfUrbIMf
JWwQStiwh1WLPTH3AXh8fPwMyEzCRebeYn48Ym4mu5lJDECoWTAg3o6b3goUMEqZ3h8z5cKQ
AZR48bRrCVBufuvvhDgDp7BxIzYJtSDglgDGdFUHTnsv/UHR+TtoPJd37N/8D/utQQUwKXP2
Bx9QsuZvKcgf9UcbfaMNlgvUBRnsOAzMPtaAskdfkKryPYAdAveNlIHf5H8FMweQQagoUPtc
FEQuUIZW4u9K2k/y+x8AWUPVi/e+E7if5Ua2Y9nL3LfRpbzgZ5n+pgXuLzk+A5CVQKs0Uoid
eY20/L4YFV584mVzvi+NQnng+zUNWZeGLHm1+cIomYY7F67H/wB5ZbU0GMrRVwAAAABJRU5E
rkJggg=='! !

!SPathToolsIcons class methodsFor: 'accessing' stamp: 'mp 8/14/2013 09:33:57.279'!
dashboardIcon
	"Auto-generated.
	
	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ Icons
		at: #fugueDashboard
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self dashboardIconContents readStream) ].! !

!SPathToolsIcons class methodsFor: 'contents' stamp: 'mp 8/14/2013 09:33:57.271'!
dashboardIconContents
	"Auto-generated.

	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ 'iVBORw0KGgoAAAANSUhEUgAAACgAAAAoCAYAAACM/rhtAAAFLUlEQVR42s2YyU7kRhjHq6HZ
952GRvQBsUhoxAtEiaI5zDvkARCnXHPkmCdA4p5nyCmXSFFynQMSIIEQm9n3fWvy/apdpuwu
d/fQk3E+yWC7XK5f/etbqp1Svi0uLmZTqdSvcvpJjh6VjJ3J8fvr6+svs7OzO9xI8WdhYSFX
W1v7WQA75EiIrWACx3GRz+c/zM3NbaXm5+fTAwMDfwjg93JTPT8/64eSMMRJp9OqpqZGvby8
/HlwcPARwK5MJnMoUOmnp6dE1TNWV1cH7PPe3l4/gINDQ0N7KCfUSbNpk9XUSnqelwEwI4Ae
gCzx/8FYYh9wKAA0/vdew2/NBBmgmmAzfhgCZIAv9UEmZFyDFzY3N+v7t7e3GtYsFceXmO+D
YUAaKgUE6uHhQfX09Kiuri7V3t6uYWwD+vLyUp2dnamTkxPV0NBQMSiAWAgQBRi0nN3f36vW
1lY1OjqqB63EeO/m5qa6ubmpqA/PsAIhQBRg8HJwIyMjqq+vr6gNxeSF+lzeV6Qotr+/r59p
bGwsOQ7t/vsKgGIespYCpC2bzQZwvEDylPY9SfRKkqo6Pz/XbZ2dnfqe3W6Aj46O1O7ubkkl
AcSNAsDBwUGPDnd3d84OwPT29ip5LriHEhcXF/ocX+Sla2tr+npyclLD2u39/f1BXwBpB95l
TU1N6vHxkQm+ATIA0ecyXjQxMRG6d3V1pVZWVvQ5bQSKSfSoRYCsrq4GwG1tbaH+y8vLsQqS
DfDbAFCWwGtpadFO7FIPvzMALBsOjJqmZsctFyrwDCkD1XAjcadgAjs7O04VYUEs8dk3QCLz
+vraqd74+HjRsuJnDFbKSFtAMSnjn93d3donMbMCUYMFsQJA8Q8PhVi2qHV0dAQgyL60tKQV
GRsb06rGGRPZ2NhQMzMzWi38EzWnp6cDxVHQJQruAIsEXgFQItNDERcgKSPqPyy1K41E4VDe
VBdXH1Ql+l2ATCoESEXgZtTwPwbBn8zL4vJcHBzm6o8gJnfaxsoAf3h4WACUFOLhGy4Fbf8z
7cyQQaLGBNfX13VU23Bx/bnGP10KFgGSq+IUJC8RVSY12H4UNfzU1Wb3n5qa0hOIA0TB09NT
knoBUOA8KoSJUNuYKVH1XxgB4lpiApMNRgAoy+uR6V0KoizLj+Ho5DP+E9nlaqoxyiRK4XfD
w8OB/x4fH+vdjktB2uQoD8jyUoMx40ekGfwkmgdNqaSPbcDRjzRj6jS2tbXl3EEVAUoEe3Ry
AWK5XE4nXF5mlzcGpA9g0b0kzwPKYEzILnv4KKpub287x6MPmwpZ5jCgK4oxSo+tFqDMMG5z
4VoFNht28OAqcf1ZnRCgyO5RW+MAMdoJFj/DVwQWNUQwSVhSSOxz7wLEsU1+qsZMxSr1E5dx
mICkmgKghLXHErrqYhLGSjkB2UEk9dnDGAGFz4cAJWo0IM5fzW/jr2H88iOYAJQc+QZIJaGR
kpTkxyNKIP5JJQkBQm0qBkry0LcCBYwgNGmIkgtDAChR4xlpcVAe/tbfCREDUciNbM1wNRtw
VwBTgBk4o57/QdF5br+8lDrRc/7HnRtQAcxLSstqQImav6U05cxHG/NgFKwUqAvSHjgOLHpt
AKUUrkhW+RHAAYH7rr6+/jf530ANBdKGKgcavVcOohSo/93nVo6f5PwfADvlfruo94PA/SwP
Tsp1s0rGbmSCn2XjsSBwf8n1JYBsznrlIIT4rtEiR201o1Rh1D9+nB/JwT7sWOvqQ7b5kDXv
fv3XsbwPdyVcL/8CN+PoNMWbYjYAAAAASUVORK5CYII='! !

!SPathToolsIcons class methodsFor: 'license' stamp: 'mp 8/14/2013 09:30:24.953'!
license

	^ 'Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/'! !

!SPathToolsIcons class methodsFor: 'accessing' stamp: 'mp 8/14/2013 09:33:57.682'!
piramidIcon
	"Auto-generated.
	
	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ Icons
		at: #fuguePiramid
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self piramidIconContents readStream) ].! !

!SPathToolsIcons class methodsFor: 'contents' stamp: 'mp 8/14/2013 09:33:57.675'!
piramidIconContents
	"Auto-generated.

	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ 'iVBORw0KGgoAAAANSUhEUgAAACgAAAAoCAYAAACM/rhtAAAEHklEQVR42s2YzU4aURTHL4rf
H4AoiBpFo0kTY9+gadN00XfoAxhX3Xbpsk9g4r7P0FU3TZp26050oUkjg4JfgPgJ2PO7MOAA
wjCj0n9ydRjHOz/+95xzz4xHlbW5uTnj8Xi+yuFHGUHVGZ3J+H5/f/9ldXX1gBMefmxsbES7
u7u3BNAno0NsJQkcI10sFl+vra399ayvr3vD4fAPAXwrJ1U+n9cXdUKY4/V6VVdXlyoUCj+P
jo4+ABiIRCJJgfLe3d111D1TPT09wOYTiUQIwMmpqakEzgl1p9m0ZDW1k4ZhRACMCKABIEvs
VszBErkR/18GnKoAmvHnRoQIk+OAG5lxaAEkMdzG4MjIiPL7/Wp/f1/fxKnKMWgFNB1wKtxf
Xl7W7u3t7amrqyvltGQBiCyAWHpzc+NoQtwPBoNqcnJSf2ae3d1dx0vd19enY9kCyGTX19eO
JiT7V1ZWLOfi8bg6Pz935GJ/f7+eswIoMrDVCSBLOzc3p0ZHR+ugY7GYo4wGkHkrgLI0BrYS
N+1qcHBQAzZSOp3mJm3POTAwoG5vb5UU6iog1JeXl21P9hziSxPHFUDZi42hoSGVy+VsT0Ji
8IVa7T7ENqvTTtmBhbkPDw+rgMPDw+ri4sL2JCxBNBqti71aZTIZJZu+jim7CQMLZlUAQ6GQ
wY2y2axt9yYmJtT4+Lit63F5e3vbtosUfFjki5UA5WYGO4BdQDJ+YWHBttvo5OREHR8f2wYs
O18FDAQC+uT/IFaTGppMJkuAslTG2NhYSwdZWq5x0/UQX62WGgfrANmqWjnIXr24uKiz0ql2
dnZaJgsOnp6eqlQqVQIUOIOgp7A2E+k/PT3tGA5R3+h2mu0wPp9Px2wFUJbXkExu6eDS0pIr
OFMANus9cZCEktEe4EupDlAy2JBi/SggBdxtt91IJEOjlgxAWV6W2QrYKIuJmdnZWT3ZU4tu
p1FGcy8LoBRpg2azFpCywgTz8/NPDoe438HBQaWDbhsQ+2ml3D6lNZPst3U9AIBSAyk1JUBJ
a0Oa1raahecUxbwhIB1Ep157mKKIU28tgJI1GpCEeI5sbUfEPDsVgGdnZ1VAdhL+SKPYyZdH
dNO0Z+wkFkCoaRgQTnLRS4ECZnbeiC0XhgqgZI1hWkuAcvFLvyfEDEzhwY1unVB7CBgXQA9g
JpzpXvmFYsPjh5M3c6f2mN+PHZugAliUlmtGA0rW/JZiGTVf2pgX1oI1A20E+fDGj4HVfjYB
5Rk9JlXlPYBhgXvT29v7TX73UdWBfAjVCrT2XCuIZqAsrcTfpYxPcvwHQL+cHxX33gncZ7nw
lXwefNEArConX3BLGuMNgfslnzMA0k7weEYKTcgYkuHuBZ9z8ZDNw3lKBm+yjrWvZciRMuTz
bbz2VCzDZYWr8A+4td0lsaBYtQAAAABJRU5ErkJggg=='! !

!SPathToolsIcons class methodsFor: 'accessing' stamp: 'mp 8/14/2013 09:33:58.156'!
premiumIcon
	"Auto-generated.
	
	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ Icons
		at: #fuguePremium
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self premiumIconContents readStream) ].! !

!SPathToolsIcons class methodsFor: 'contents' stamp: 'mp 8/14/2013 09:33:58.149'!
premiumIconContents
	"Auto-generated.

	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ 'iVBORw0KGgoAAAANSUhEUgAAACgAAAAoCAYAAACM/rhtAAAE/ElEQVR42sWYyU7rSBRAHQjz
PBMmBZAYJPT+4Om1Wm/x/qE/ALHqbS9Z9hcgse9v6FVvWmp1b5+EQAgEiMnM8zyFvqfia+zg
OI6DXq5UccWp3Dp1pyo7YTkyPz8/kEgkfpfuN2kdVnnkTNqfr6+vv01PT+9wI8HH3NxcurKy
8rsAtkgrE1tWBI52kclkPs3MzGwlZmdnkz09PX8J4Be5aT0/P5tB5RCMk0wmrYqKCuvl5eXv
g4ODrwC2pVKpQ4FKPj09ldV6KlVVVcA+7+3tdQPY29fXt4flhLrcbEbEm8aStm2nAEwJoA0g
Li5F8ADuYYJSBB0OYJ8LqPFXitTV1Vk1NTXW2dmZVUqyaRz6AEmMUmKQxU1MTBjli4uLJVnR
iUE/ID+UAlhbW2uNjIyY/u7urnV+fh7bigAiPkBM+vDwEEshC8N6uBch2ZaWlmJbET2EnA8Q
Zff397EUEnvDw8O+e1jx4uIilj68wSJdQBEbs8YBxHrj4+Nm1SilVVdXu1YkJuMAEtMuYG9v
r80Ed3d3RSkisbzWOzo6MoplwT4rFhuL6Hx8fLSkUL8BQn17exv4B6xBTABEX6+ExdTUlGu9
tbU1cx0dHXWtuLCwYCYjxrVGAhxWL+vr600+uICyF9sNDQ3Wzc2Nb+D19bVRxh+AoNFHcXNz
s28s1js5OTH9lpYW14oqLJ5J9ap9FtvY2OgbCwu/7e/vvwEyCCCv4DrNzDBhsq2tLd9WWcx/
NzY2fPdgwVguYHd3t41Frq6ufAOx1NDQkG8i3EWcoRggVpovNLA2oYM76eu9sIUhTU1NhkVO
M1nArq4uu7W19R0ggnIvJDArKytm4qjBjxupEGNjYy6gwgXt/wBeXl76Adva2szNIAGyv7/f
VV4MZLFwCN5kJzo8PMwCdnZ22u3t7YEW9Ipku5scQK6urpqSECbAkNVeuO3t7dCTExZ8B9jR
0ZHXgvkgGS+BHDoevbSocGrB09NTKkMWUBTY4ubIW5MklUXMIrg6TCg3WITkCnOrVyhTlCwX
UNxrM2kUC6oVmZSdZ2dnx72vkxOzKrLPu3WNnSWKYMHj42NaPEDNaifTDBiwmjB8J4HYh7EG
upHl5eVIJ5x3gJLBthTrSIDUwMnJSdOXIGY7cqGpBAjJhrWABo4KgKyvr0d67gHQ2Zn8gIWy
GMEq6XTa9IkpslOSLHAs+phID7Kbm5uRDsWEjw9QAt4mrqIA4trBwcHA39iecC8TBAkZn7ud
fjggMUXGewVXUhb0uMbZkrqaC0ptI7aiABI+ojMLKJPalIMoqyOmdGIFy3fQ5ciF+7WYUwe9
WZ9POCwEAuKiQq89iD/GoCDqARdAEogru4+3DOUKlYCy5AOUrDGArLDQs7GeNOIIgOgPSxSS
kDgHUJ6v3wCJK37UQ2Q5RA/HlCJ2Eh8g1AQ2ome9HwUKGAVcj3RsuTC4gOI2W01LgOpzw48U
fc4hrvVQ7AXcFcAEYAqn1nNeKAb2vcrDrJPb55qvr6ACmJGyNGAAJWv+ldqV1pc2OjAXLAw0
CNI7cT6w3O8KKKVrWarKzwD2CNxnqVl/yLWGIgukF6oQaO69QhBhoM7zzq20X6T/H4Ac7JrF
ej8J3K8ycEK+11vlkRtZ4HcpQ3MC9498vwSQ8w+7PSnEHtYgrbQ3kPGFow4P50fSeJN1bOzq
QDY5kBWx1X+MZBy4K+F6+R90TNk0hwiixAAAAABJRU5ErkJggg=='! !

!SPathToolsIcons class methodsFor: 'accessing' stamp: 'mp 8/14/2013 09:33:58.672'!
radiobugIcon
	"Auto-generated.
	
	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ Icons
		at: #fugueRadiobug
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self radiobugIconContents readStream) ].! !

!SPathToolsIcons class methodsFor: 'contents' stamp: 'mp 8/14/2013 09:33:58.665'!
radiobugIconContents
	"Auto-generated.

	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ 'iVBORw0KGgoAAAANSUhEUgAAACgAAAAoCAYAAACM/rhtAAAFIUlEQVR42sWYyU4rRxSGy2Dm
ecZg4DIKhJQluyhRlEXeIQ+AWGWbJcs8ARL7PENW2USKciXE4i5AIGYu0MzzPJmcr+zTtH3b
Q4Pv9S81breLrq/+c05VdYdMQtPT09FQKPSHnP4iR5MpjE7l+Ovl5eX38fHxbS6E+DM1NfWh
uLj4kwDWyVEgtrgEjuM8Fot9NzEx8Tk0OTkZbmtr+1sAf5CL5unpyTYqhDAnHA6boqIi8/z8
/M/+/v7PADZEIpEDgQo/Pj4W1D1VSUkJsE+7u7utALZ3dHTs4pxQF5rNSqJpnXQcJwJgRAAd
AAlxUOnA+N+Kioq8ABLiBGCHC6j5l6tIh4eHB1NfX29qa2tNZWWl2draygug5mESIIWRSw4y
kLu7O9Pa2mra29tNWVmZ+9v8/HxeABM5mAyormQSoeQf+/r6rGMI2LOzM3Nzc2PP8wWIkgCx
9P7+PqNzaGRkxCYxMDINmMvLSzcP85WDRIX+kgC103QiBYaHhy0cju3s7Nj23KyhocHU1NSY
7W07+VtoxDXvea4qLy+3A3YBRQ62pgPEof7+fhvW8/NzC8K13t5eWyCqhYUF12X97j0PAsj9
XUBJdgcnbm9vfZ2rq6sznZ2ddgDr6+s2V0dHR62bnJ+cnNjfyEMv4MzMjBkbGwsMSKowQ8hE
/QoItXbgFbmgoQXu6urKdZNQHxwcuPMgoyaX6UCWz6Swzs7OmqqqqpwAuTf14ALKzRz++fr6
2nc0PT095uLiAstNaWmprWJGuLGxYcFwkeoGiBszCDrBdYVk8EtLSzZ82QQL7ff29l4Bq6ur
7Y1T1dzcbA/yjt9bWlpMU1MTo7P5SAqQHkCrTk9PbRFxfXBw0L1OCm1ubmYFhAWzXECZdB2S
XSvOKwqBjpaXl20ou7u7rTv6HUDNOa9wl7yMRqO2Q0RKrKysuN/TSatfprE4oLjisGT5AeaS
L11dXV9cJzdxEvdx/OjoyM6bAwMDdnA6GacDJKWSAJnLuPgW0SlF5BXrMnmEW8fHx3YmwE0t
NnI4nYhmogDjgDJKp7GxMbCD3ATRMesyFYxw7vDw0G1HkXnXbNxcW1uz50TOz8EvAAlDUAeH
hobs5+LionVGJ1iKgUMrWNv5icr2c5C5VQYZBxQ4h+qkKt/iIO7oVo3CoQOKSZe+VEBCPzc3
l9ZB0oG0cAElvA7bp6AOeqcQ7Vh3OYhi8GvnlbZJdZA0kCO/gOk6fzegVLDD0hQUUEPMNEOR
5ApIETEfIr8QA0iRSZiTAYNWMdNLJilEpnbaxiuKKwlQRuHgwFsmahVrNmtvNkCSHwcz6asA
otQdTCogGwk2HNkeb7kHK5FMNXFAKWtHNq2+m4WgotgUcnV11X6yPWPlYAORy6Mtq48vIDuI
fLz2INzqgjqSa3TYtrHdSgKUqrGAhCDIs/HXEM/ETPyJzcYrICsJPzLZFvLlERM9OZoopldA
qNkwIJzUvd63AmMt1w0FSy4MLqDkiKPWkqA0/tbvCTEDU9hkUFCkmhdwRwBDgCmcupd4oeh7
7r15JndSz/lMd66gAhiTlSpqAaVq/pMd7gd9aaMNU8EygfpBejtOB5b6XQHlcWFRZpWfAGwT
uO/lae1P+SxjKw6kFyobaOq1bBCZQAmt5N+NHL/K+UcAWa1rxb0fBe43aTgs3ytNYXQtA/wk
j7FTAvevfL8AkIeJZjkooRY5eLoufk8v7xBrIA/nPC/wJuvI+pqArElAFhUIThVLwF0K1/P/
uibZNPIRbykAAAAASUVORK5CYII='! !

!SPathToolsIcons class methodsFor: 'accessing' stamp: 'mp 8/14/2013 09:33:59.16'!
setupIcon
	"Auto-generated.
	
	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ Icons
		at: #fugueSetup
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self setupIconContents readStream) ].! !

!SPathToolsIcons class methodsFor: 'contents' stamp: 'mp 8/14/2013 09:33:59.153'!
setupIconContents
	"Auto-generated.

	Free Disabled Button Icons
	 2000-2013 Aha-Soft
	Website: http://www.aha-soft.com/support.htm
	License: http://creativecommons.org/licenses/by/3.0/us/"
	
	^ 'iVBORw0KGgoAAAANSUhEUgAAACgAAAAoCAYAAACM/rhtAAAFUUlEQVR42sWYR08zRxjH12B6
7xhewKJLSDlxjRJFOeQ75AMgTrnmyDGfAIl7PkNOuUSKEonTe0EU0UWW3nszeX5jz7Iz3nF7
i//SwHo9O/Obp814Y15GCwsLH2Kx2G9y+ZO0Dq88Opf2x9vb268zMzN73IjxZ35+PllZWflR
AFuklYktLYGjXaZSqW9mZ2d3Y3Nzc/Genp4/BfA7uem9vLyoTuUQxonH415FRYX3+vr61+Hh
4Y8AtiUSiSOBij8/P5fVelpVVVXAvuzv73cD2NvX17eP5YS65EFvb2+Nzw0NDSWPJd5UlvR9
PwFgQgB9AHFxqZqamjI+Ly0tlTwWLs4A9gWAOv5yidh8eHjwampq1CDFAPLs/f29ch8tl3Qc
GoAMkC8Gn56evJGREW93d1dNyCAsiuemp6eNvouLi151dbWajODn2YmJCe/g4MC7vr5W913K
xKAJyBcuQGD0BPX19SpWl5eXvbu7O6+zs1O15uZm4xn67O3teefn5yp0Jicn1bNoc3NTQbos
qe8bgFjj8fHRabnx8fFgAg2ACOh8YlzCIiwgcXlU3aUvizIAmYj4itLQ0NAnZaVL6+vravG2
amtrlQECQJGPWV2ArAjIQqxVqGRy7/LyMvI7AIntALC3t9cHApO7xEODg4ORkEx0dnYWLJA+
TU1NKjaj4ozYJAZdqqurU5aVQv0OCABB7xIJRJKEYwk3kNEuywPKohg7rLW1tZybArFO3AaA
shf7xJi9G9gWTCaTxr2tra0gsfjPqsl4SghWIAFIPhuSzJZ91jkXLBhLStI7YGNjo3dzc2N0
vLq6Cq4pE+FScnFxoWqahsOd4gllNQB2dnYCKCwCZFjUSS27RMGCsQLA7u5un052XADlEq7V
IdHS0uJJohnf89329naw4wwPD6vCHaWVlRXjM/ELi1g5DdjV1eW3trZmARJzLq2urgbXUqbU
oLaodbr4u/rYY2lAvGcAtrW1GS7NB8heq7er/v5+5RZbWFDHaDGAeJMQOjo6SgNK/Pjt7e1Z
FmT3cIkiq08/HR0dqoVFZhMGiJrGHm7vJlpktW3BLEAmsC0Ylp2JJycn3vHxcVAXxQseXkDU
Uxnc2DrtxdpQtgWpqzJ+GlDgfCZwVXb9EFlqu5kkcO0w+ohl7+N4Smqccy6S7vT09B1Q3OtL
Jue0IJPhpjAMxZYMxNVkaPiMSE2kDQwMqBIUFvUz19kTY+AhaYUBakuMjY0ZltCQ1EMGBIgF
MDlQJE9U3OmTjKvsZAFK7PhSrJ2ADDY6OpoFZwtY4i5fPw1JCbJP5hqQ+BY3m4CuDZwSUcik
xYoyFOVqstgAlCLtkwAuQNyEu+zVEntRFrCFpexTDXuxa76iAaMgKSPslwxGs2MNeEKGysA1
XtB9eDZXQjIefaTUpAElrX32UvuwYIugBpIAthdDhoe1sbFhfGZhPEsBzmUIxK4UCYhFSn3t
kQ+wUHFE47hlAErWKEAyMN9v4y8NyP5OKAAox7Z3QHYSvuSYVM6XR/pnLTuJAQg1BwaEJen0
tUABo8DrJCKxYAgAJWt8bVoClM5f+z0hxsAobArsSIRaGPA/AYwBpuG09TIvFCOvw4Pnso59
zX/XtQYVwJRk/AcFKFnzjxTSpH5pozvaYLlAoyDDE7vA7M8aUM6TK1JVfgCwR+C+lRr3u/yv
oeIDGYbKB2rfyweRCxTXSvzdSftZrv8FsFXuN4v1vhe4X6Qjv5Q+/8ZbmG5lgR9la5wXuL/l
8xWAHPA4sJFCXdJ4CfP53nEUJ37N8+P8WBrH8RNl1wxkUwYy/+7/ZZXKwF0L1+v/ldriNFXi
f6gAAAAASUVORK5CYII='! !

!ObjectExplorer methodsFor: '*Path-Core' stamp: 'mp 7/7/2010 16:39:58.474'!
explorerListMorphFor: anObject
	|  listMorph |
	rootObject := anObject.
	listMorph := SPluggableTreeMorph 
			on: self
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: #explorerKey:from:.
	listMorph setSelectedSelector: #noteNewSelection:.
	listMorph
		autoDeselect: false;
		color: Color white;
		alwaysShowScrollBars: false.
	^ listMorph! !

PluggablePanelMorph subclass: #SPluggableFlapMorph
	instanceVariableNames: 'flapIcon expandedFlap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableFlapMorph class methodsFor: 'constants' stamp: 'mp 8/13/2013 17:41:11.224'!
iconOffset
	^ 40! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/15/2010 13:23:31.387'!
closeAllOtherFlaps
	self owner ifNil: [^ self].
	self flag: #mpe. "Refactor the owner relationship to a more stable version, later on"
	"Add some kind of select flap selector..."
	self owner paneMorphs 
		select: [:each | (each isKindOf: self class) and: [(each == self) not]]
		thenDo: [:each | each closeFlap].! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/15/2010 09:59:34.425'!
closeFlap
	self expandedFlap: false.
	self submorphs do: [:each | each hide].
	self changed.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 8/13/2013 17:41:34.184'!
drawExpandedFlapOn: aCanvas
	"Icon Background"
	aCanvas 
		fillRectangle: self iconRectangle	
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.	
	"Draw Icon"
	aCanvas image: self flapIcon at: self iconRectangle origin.
	"Main Background"
	aCanvas 
		fillRectangle: (self bounds insetOriginBy: 0@0 cornerBy: self class iconOffset@0)  		
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.
	"Left Border to System Window"
	aCanvas 
		fillRectangle: (self bounds origin 
						corner: ((self bounds origin x + 2)@(self bounds corner y))) 
		color: self color.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 8/13/2013 17:40:57.812'!
drawNotExpandedFlapOn: aCanvas
	"Icon Background"
	aCanvas 
		fillRectangle: self fullBounds	
		fillStyle: self fillStyle 
		borderStyle: self borderStyle.
	aCanvas image: self flapIcon at: self fullBounds origin.! !

!SPluggableFlapMorph methodsFor: 'drawing' stamp: 'mp 9/15/2010 09:52:56.7'!
drawOn: aCanvas
	self isExpanded
		ifTrue: [self drawExpandedFlapOn: aCanvas]
		ifFalse: [self drawNotExpandedFlapOn: aCanvas].! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:17:44.835'!
expandedFlap
	"Answer the value of expandedFlap"

	^ expandedFlap ifNil: [expandedFlap := false]! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:11:44.341'!
expandedFlap: anObject
	"Set the value of expandedFlap"

	expandedFlap := anObject! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:57:33.686'!
flapIcon
	"Answer the value of flapIcon"

	^ flapIcon! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:57:33.691'!
flapIcon: anObject
	"Set the value of flapIcon"

	flapIcon := anObject! !

!SPluggableFlapMorph methodsFor: 'layout' stamp: 'mp 9/15/2010 09:53:37.669'!
fullBounds
	| b |
	self isExpanded
		ifTrue: [^ super fullBounds]
		ifFalse: [b := super fullBounds.
				^ b origin corner: (b origin x + self class iconOffset) @ 
						     		   (b origin y + self class iconOffset)]! !

!SPluggableFlapMorph methodsFor: 'event handling' stamp: 'mp 7/16/2013 11:13:57.35'!
handlesMouseDown: event
	self isExpanded
		ifTrue: [^ self iconRectangle containsPoint: event cursorPoint]
		ifFalse: [^ self fullBounds containsPoint: event cursorPoint]! !

!SPluggableFlapMorph methodsFor: 'accessing' stamp: 'mp 9/13/2010 18:05:09.219'!
iconRectangle
	^ (self bounds corner x - self class iconOffset)@(self bounds origin y)
			corner: ((self bounds corner x)@(self bounds origin y + self class iconOffset))! !

!SPluggableFlapMorph methodsFor: 'initialization' stamp: 'mp 9/13/2010 18:16:47.754'!
initialize
	super initialize.
	self switchExpandState.
! !

!SPluggableFlapMorph methodsFor: 'testing' stamp: 'mp 9/15/2010 09:52:09.29'!
isExpanded

	^ expandedFlap = true! !

!SPluggableFlapMorph methodsFor: 'testing' stamp: 'mp 9/15/2010 09:52:13.226'!
isNotExpanded

	^ expandedFlap = false! !

!SPluggableFlapMorph methodsFor: 'layout' stamp: 'mp 9/13/2010 19:03:35.28'!
layoutBounds
	^ super layoutBounds insetOriginBy: 0@0 cornerBy: self class iconOffset@0! !

!SPluggableFlapMorph methodsFor: 'event handling' stamp: 'mp 7/16/2013 11:14:02.774'!
mouseDown: event
	self switchExpandState.
! !

!SPluggableFlapMorph methodsFor: 'switching' stamp: 'mp 9/16/2010 11:08:45.688'!
switchExpandState
	self expandedFlap: self expandedFlap not.
	self isExpanded
		ifTrue: [self submorphs do: [:each | each show].
				self closeAllOtherFlaps]
		ifFalse: [self submorphs do: [:each | each hide]].
	self changed.
! !

!ContextPart methodsFor: '*Path-Core-override' stamp: 'eem 7/18/2010 19:25'!
cogTryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	| selector theMethod spec receiverClass |
	<primitive: 218 error: ec>
	ec ifNotNil:
		["If ec is an integer other than -1 there was a problem with primitive 218,
		  not with the external primitive itself.  -1 indicates a generic failure (where
		  ec should be nil) but ec = nil means primitive 218 is not implemented.  So
		  interpret -1 to mean the external primitive failed with a nil error code."
		 ec isInteger ifTrue:
			[ec = -1
				ifTrue: [ec := nil]
				ifFalse: [self primitiveFailed]].
		^{PrimitiveFailToken. ec}].
	"Assume a nil error code implies the primitive is not implemented and fall back on the old code."
	"Hack. Attempt to execute the named primitive from the given compiled method"
	arguments size > 8 ifTrue:
		[^{PrimitiveFailToken. nil}].
	selector := #(
		tryNamedPrimitive 
		tryNamedPrimitive: 
		tryNamedPrimitive:with: 
		tryNamedPrimitive:with:with: 
		tryNamedPrimitive:with:with:with:
		tryNamedPrimitive:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:with:) at: arguments size+1.
	receiverClass := self objectClass: aReceiver.
	theMethod := receiverClass lookupSelector: selector.
	theMethod == nil ifTrue:
		[^{PrimitiveFailToken. nil}].
	spec := theMethod literalAt: 1.
	spec replaceFrom: 1 to: spec size with: (aCompiledMethod literalAt: 1) startingAt: 1.
	Smalltalk unbindExternalPrimitives.
	^self object: aReceiver perform: selector withArguments: arguments inClass: receiverClass! !

!ContextPart methodsFor: '*Path-Core' stamp: 'mp 11/5/2010 13:52:09.08'!
runSimulatedMethodOnly: aBlock contextAtEachStep: block2
	| current |
	aBlock hasMethodReturn
		ifTrue: [self error: 'simulation of blocks with ^ can run loose'].
	current := aBlock asContext.
	current pushArgs: Array new from: self.
	[current == self]
		whileFalse:
			[(current sender receiver class inheritsFrom: MwMethodWrapper)
					ifTrue: [current := current step] "Ignore byte codes of method wrappers"
					ifFalse: [block2 value: current.
						 	current := current quickStep]].
	^self pop! !

!ContextPart methodsFor: '*Path-Core-override' stamp: 'eem 5/23/2010 14:13'!
tryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	"Hack. Attempt to execute the named primitive from the given compiled method"
	| selector theMethod spec |
	arguments size > 8 ifTrue:[^PrimitiveFailToken].
	selector := #(
		tryNamedPrimitive 
		tryNamedPrimitive: 
		tryNamedPrimitive:with: 
		tryNamedPrimitive:with:with: 
		tryNamedPrimitive:with:with:with:
		tryNamedPrimitive:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:with:) at: arguments size+1.
	theMethod := aReceiver class lookupSelector: selector.
	theMethod == nil ifTrue:[^PrimitiveFailToken].
	spec := theMethod literalAt: 1.
	spec replaceFrom: 1 to: spec size with: (aCompiledMethod literalAt: 1) startingAt: 1.
	theMethod flushCache.
	selector flushCache.
	^aReceiver perform: selector withArguments: arguments! !

PluggableTreeItemNode subclass: #SPluggableTreeItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTreeItemNode methodsFor: 'accessing' stamp: 'mp 1/25/2010 16:23'!
highlightingColor

	^ Color r: 110 / 256.0 g: 127 / 256.0 b: 223 / 256.0! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/23/2011 18:40:22.074'!
asMethodReference
	^ self methodReference! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 5/17/2013 15:16:17.41'!
authorFirstChange
	<description: 'Method creator'>
	| firstChange |
	firstChange := self firstChange.
	firstChange ifNil: [^ 'Unknown'].
	^ firstChange first! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 5/17/2013 15:16:21.268'!
authorLastChange
	<description: 'Last change'>
	| lastChange |
	lastChange := self lastChange.
	lastChange ifNil: [^ 'Unknown'].
	^ lastChange first! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/12/2011 14:10:21.364'!
authorMostChanges
	<description: 'Most changes'>
	| authorBag |
	authorBag := Bag new.
	self changes do: [:each | authorBag add: each first].
	^ authorBag sortedCounts first value! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 5/18/2013 20:54:15.082'!
authorRecentChanges
	<description: 'Frequency and recency of changes'>
	| uniqueChangesPerDay creatorOfMethod highscore bonusForCreator authors |
	self flag: #mpe. "ToDo: Needs refactoring"
	self changes size = 1
		ifTrue: [^ self authorFirstChange].
	uniqueChangesPerDay := (self changes 
						collect: [:each | {each first. each second asDate}]) asSet.
	uniqueChangesPerDay := uniqueChangesPerDay 
								asSortedCollection: [:a :b | a second > b second].
	creatorOfMethod := uniqueChangesPerDay last.
	highscore := uniqueChangesPerDay collect: [:each | 
							{each first. (each second - creatorOfMethod second) days}].
	bonusForCreator := (highscore at: highscore size) second. 
	highscore at: highscore size put: {highscore last first. bonusForCreator}.
	authors := (highscore collect: [:each | each first]) asSet.
	highscore := (authors collect: [:author | 
					{author. 
					(highscore 
						select: [:each | each first = author] 
						thenCollect: [:each | each second]) sum}]).
	highscore := highscore asSortedCollection: [:a :b | a second > b second].
	^ highscore first first! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 5/17/2013 15:17:07.185'!
changes
	| versions subStrings |
	versions := self versions.
	versions ifNil: [^ nil].
	^ versions changeList collect: [:each | 
		each stamp
			ifEmpty: [{'Unknown'. TimeStamp now}]
			ifNotEmpty: [subStrings := (each stamp subStrings: String space).
		{subStrings first. ((subStrings second, ' ', subStrings third) asTimeStamp)}]]! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/19/2010 16:46:54.024'!
complexity
	| type complexity |
	complexity := self startpcsToBlockExtents keys size.
	self initialPC to: self endPC 
		do: [:each | 
			type := (self at: each) // 16.
			(type = 10 or: [type = 9])
				ifTrue: [complexity := complexity + 1]].
	^ complexity! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/23/2011 18:40:39.133'!
coveringTests
	^ SProject current coveredTestsFor: self asMethodReference! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/9/2011 14:25:37.763'!
firstChange
	self changes ifNil: [^ nil].
	^ self changes last! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/20/2010 09:49:28.184'!
lastChange
	self changes ifNil: [^ nil].
	^ self changes first! !

!CompiledMethod methodsFor: '*Path-Core-override' stamp: 'tfel 1/27/2012 09:19:56.752'!
methodNode
	"Return the parse tree that represents self"
	| source |
	"Fix for debugging OMeta"
	(self methodClass inheritsFrom: (Smalltalk at: #OMeta2 ifAbsent: []))
		ifTrue: [^ self decompile].
	SBreakpointManager installedNodes at: self ifPresent: [:node | ^ node].
	^ (source := self getSourceFromFile)
			ifNil: [self decompile]
			ifNotNil: [self parserClass new
								parse: source
								class: (self methodClass ifNil: [self sourceClass])]
! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/20/2010 10:45:07.292'!
numberOfVariableAccess
	| access type offset skipNextByte |
	access := 0.
	skipNextByte := false.
	(self isQuick and: [self isReturnSpecial not]) ifTrue: [^ 1].
	self initialPC to: self endPC 
		do: [:each | 
			skipNextByte 
				ifTrue: [skipNextByte := false]
				ifFalse: [
			type := (self at: each) // 16.
			type = 0
				ifTrue: ["Read instance variable"
						access := access + 1].
			type = 1
				ifTrue: ["Read temporary variable"
						access := access + 1].	
			(type = 4 or: [type = 5])
				ifTrue: ["Read literal variable (class variable)"
						access := access + 1].	
			type = 6
				ifTrue: ["Pop receiver or temporary variable"
						access := access + 1].									
			type = 8
				ifTrue: ["Extended read/write for receiver, temporary and class variables"
						offset := (self at: each) \\ 16. 
						offset = 0
							ifTrue: ["read variables"
								access := access + 1].
						offset = 2
							ifTrue: ["write variables"
								access := access + 1].							
						].
			(type = 8 or: [type = 10])
				ifTrue: [skipNextByte := true]]].
	^ access! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/9/2011 14:43:06.761'!
setOfAuthors
	self changes ifNil: [^ nil].
	^ (self changes collect: [:each | each first]) asSet asSortedCollection! !

!CompiledMethod methodsFor: '*Path-Core' stamp: 'mp 9/19/2010 16:11:23.367'!
versions
	^ VersionsBrowser new
			scanVersionsOf: self 
			class: self methodClass 
			meta: self methodClass isMeta
			category: nil 
			selector: self selector.! !

RectangleMorph subclass: #SActionButtonMorph
	instanceVariableNames: 'actionModel actionSelector actionArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

SActionButtonMorph subclass: #SActionButtonIconMorph
	instanceVariableNames: 'iconForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SActionButtonIconMorph class methodsFor: 'constants' stamp: 'mp 8/12/2013 16:40:48.77'!
buttonExtension
	^ 3@3! !

!SActionButtonIconMorph class methodsFor: 'instance creation' stamp: 'mp 5/2/2010 19:39'!
on: aModel selector: aSymbol args: aCollection icon: anIconForm

	^ (self on: aModel selector: aSymbol args: aCollection)
		iconForm: anIconForm;
		extentToIcon;
		yourself! !

!SActionButtonIconMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:38'!
on: aModel selector: aSymbol icon: anIconForm

	^ (self on: aModel selector: aSymbol)
		iconForm: anIconForm;
		extentToIcon;
		yourself! !

!SActionButtonIconMorph methodsFor: 'initialization' stamp: 'mp 8/12/2013 16:35:10.492'!
defaultBorderWidth
	^ 0! !

!SActionButtonIconMorph methodsFor: 'drawing' stamp: 'mp 8/12/2013 16:39:18.533'!
drawOn: aCanvas
	super drawOn: aCanvas.
	aCanvas translucentImage: self iconForm at: bounds origin +
									self class buttonExtension.! !

!SActionButtonIconMorph methodsFor: 'geometry' stamp: 'mp 8/12/2013 16:39:48.529'!
extentToIcon

	self extent: (self iconForm width + (2 * self class buttonExtension x)) @ 
					(self iconForm height + (2 * self class buttonExtension y)).! !

!SActionButtonIconMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:17'!
iconForm
	"Answer the value of iconForm"

	^ iconForm! !

!SActionButtonIconMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:17'!
iconForm: anObject
	"Set the value of iconForm"

	iconForm := anObject! !

SActionButtonMorph subclass: #SActionButtonLabelMorph
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SActionButtonLabelMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 21:05'!
defaultExtensionFactor

	^ 1.5! !

!SActionButtonLabelMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:27'!
on: aModel selector: aSymbol args: aCollection name: aString

	^ (self on: aModel selector: aSymbol args: aCollection)
		createLabelMorph: aString! !

!SActionButtonLabelMorph class methodsFor: 'instance creation' stamp: 'mp 4/15/2010 21:07'!
on: aModel selector: aSymbol name: aString

	^ (self on: aModel selector: aSymbol)
		createLabelMorph: aString! !

!SActionButtonLabelMorph methodsFor: 'building' stamp: 'mp 4/20/2010 17:10'!
createLabelMorph: aString

	self labelMorph: (StringMorph contents: aString).
	self addMorph: self labelMorph.
	self extent: (self labelMorph fullBounds corner * self class defaultExtensionFactor).! !

!SActionButtonLabelMorph methodsFor: 'geometry' stamp: 'mp 4/24/2010 15:56'!
extent: aPoint

	| borderOffset |
	super extent: aPoint.
	self labelMorph position: self position.
	self labelMorph width < self width
		ifTrue: [self labelMorph position: 
				(self labelMorph position x + (self width / 2) - (self labelMorph width / 2)) @ 
					(self labelMorph position y + (self height / 2) - (self labelMorph height / 2))]
		ifFalse: [
			borderOffset := 5.
			self labelMorph position: 
				(self position x + borderOffset - 2) @ 
					(self labelMorph position y + (self height / 2) - (self labelMorph height / 2)).
			self labelMorph extent: (self width - borderOffset)@ self height.
			].! !

!SActionButtonLabelMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:05'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!SActionButtonLabelMorph methodsFor: 'accessing' stamp: 'mp 4/15/2010 21:05'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

SActionButtonLabelMorph subclass: #SDropDownActionButtonMorph
	instanceVariableNames: 'dropDownMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SDropDownActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:35'!
dropDownMorph
	^ dropDownMorph! !

!SDropDownActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:35'!
dropDownMorph: anObject
	dropDownMorph := anObject! !

!SDropDownActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 18:47'!
mouseUp: anEvent
	super mouseUp: anEvent.
	self dropDownMorph newSelectedEntry: self labelMorph contents.! !

SActionButtonLabelMorph subclass: #SDropDownMorph
	instanceVariableNames: 'menuEntries selectedEntry menuMorph entriesChangedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SDropDownMorph class methodsFor: 'constants' stamp: 'mp 1/15/2010 17:51'!
defaultHeight

	^ 25! !

!SDropDownMorph class methodsFor: 'instance creation' stamp: 'mp 2/3/2012 12:32:12.487'!
getLabelFrom: aCollection
	^ aCollection
		ifEmpty: ['No Menu Entry']
		ifNotEmpty: [aCollection first isCollection
						ifTrue: [aCollection first first]
						ifFalse: [aCollection first key]]! !

!SDropDownMorph class methodsFor: 'instance creation' stamp: 'mp 2/3/2012 12:32:26.616'!
on: aModel with: aCollection
	^ self new
		actionModel: aModel;
		menuEntries: aCollection;
		createLabelMorph: (self getLabelFrom: aCollection);
		createMenu;
		yourself! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 2/3/2012 12:37:00.403'!
createLabelMorph: aString

	super createLabelMorph: aString.
	self extentMorphToLargestString: aString.! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 9/22/2010 11:00:37.443'!
createMenu
	| entryMorphs |
	entryMorphs := self createMenuEntries.
	self menuMorph: (AlignmentMorph inAColumn: entryMorphs).
	self addMorph: self menuMorph.
	self menuMorph 
		borderWidth: 0;
		position: (self position x - 1) @ (self position y + self height - 1);
		hide.! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 9/9/2011 10:44:57.345'!
createMenuEntries
	self menuEntries ifEmpty: [^ #()].
	self menuEntries first isCollection
		ifTrue: [	"Collection with args for action selector"
			^ self menuEntries collect: [:each | 
								(SDropDownActionButtonMorph 
									on: self actionModel 
									selector: each second 
									args: each third 
									name: each first) 
										extent: self extent;
										dropDownMorph: self]]
		ifFalse: ["Associations"
			^ self menuEntries collect: [:each | 
				(SDropDownActionButtonMorph 
					on: self actionModel selector: each value name: each key) 
					extent: self extent;
					dropDownMorph: self]].! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 2/3/2012 12:13:35.843'!
entriesChangedSelector
	"Answer the value of entriesChangedSelector"

	^ entriesChangedSelector! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 2/3/2012 12:13:35.859'!
entriesChangedSelector: anObject
	"Set the value of entriesChangedSelector"

	entriesChangedSelector := anObject! !

!SDropDownMorph methodsFor: 'geometry' stamp: 'mp 7/16/2013 11:13:44.813'!
extent: aPoint

	| oldHeight |
	oldHeight := self height.
	super extent: aPoint.
	"Required for collapse system window"
	self flag: #mpe. "Creates a bug in PathMap Flap - Morph cannot be hided."
"	aPoint y = 0
		ifTrue: [self hide]
		ifFalse: [self show]."
	self menuMorph ifNotNil: [
	self menuMorph 
		position: (self menuMorph position x) @ 
					 (self menuMorph position y + self height - oldHeight).
	self menuMorph submorphs do: [:each | each extent: self extent]]! !

!SDropDownMorph methodsFor: 'building' stamp: 'mp 2/3/2012 12:37:31.053'!
extentMorphToLargestString: aString
	| largestString |
	largestString := aString.
	self menuEntries ifNotEmpty: [
		self menuEntries first isCollection
			ifTrue: [self menuEntries do: [:each | 
					(each first size > largestString size) 
						ifTrue: [largestString := each first]]]
			ifFalse: [self menuEntries do: [:each | 
					(each key size > largestString size) 
						ifTrue: [largestString := each key]]]].
	self extent: largestString asStringMorph fullBounds corner * 
					self class defaultExtensionFactor.! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:43'!
menuEntries
	^ menuEntries! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:43'!
menuEntries: anObject
	menuEntries := anObject! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:08'!
menuMorph
	^ menuMorph! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 18:08'!
menuMorph: anObject
	menuMorph := anObject! !

!SDropDownMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 18:34'!
mouseUp: anEvent

	self switchVisibilityOfMenu.! !

!SDropDownMorph methodsFor: 'private' stamp: 'mp 1/15/2010 18:39'!
newSelectedEntry: aString

	self switchVisibilityOfMenu.
	self selectedEntry: aString.
	self labelMorph contents: aString.
	self extent: self extent.! !

!SDropDownMorph methodsFor: 'updating' stamp: 'mp 2/3/2012 12:38:24.463'!
refreshMenuEntries: aCollection

	self menuEntries: aCollection.
	self extentMorphToLargestString: (self class getLabelFrom: aCollection).
	self createMenu.! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:45'!
selectedEntry
	^ selectedEntry! !

!SDropDownMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 17:45'!
selectedEntry: anObject
	selectedEntry := anObject! !

!SDropDownMorph methodsFor: 'private' stamp: 'mp 1/25/2010 13:04'!
switchVisibilityOfMenu

	self menuMorph visible: self menuMorph visible not.! !

!SDropDownMorph methodsFor: 'updating' stamp: 'mp 2/3/2012 12:18:09.321'!
update: what
	what == self entriesChangedSelector
		ifTrue: [	self refreshMenuEntries: (self actionModel 
											perform: self entriesChangedSelector)]! !

!SActionButtonMorph class methodsFor: 'constants' stamp: 'mp 1/15/2010 17:32'!
defaultColor

	^ Color white! !

!SActionButtonMorph class methodsFor: 'constants' stamp: 'mp 4/15/2010 20:59'!
highlightBrightness

	^ 0.16! !

!SActionButtonMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:25'!
on: aModel selector: aSymbol

	^ self on: aModel selector: aSymbol args: #()! !

!SActionButtonMorph class methodsFor: 'instance creation' stamp: 'mp 4/18/2010 20:25'!
on: aModel selector: aSymbol args: aCollection

	^ self new 
		actionModel: aModel;
		actionSelector: aSymbol;
		actionArgs: aCollection;
		yourself! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:24'!
actionArgs
	"Answer the value of actionArgs"

	^ actionArgs! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 20:24'!
actionArgs: anObject
	"Set the value of actionArgs"

	actionArgs := anObject! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionModel
	^ actionModel! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionModel: anObject
	actionModel := anObject! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionSelector
	^ actionSelector! !

!SActionButtonMorph methodsFor: 'accessing' stamp: 'mp 1/15/2010 16:40'!
actionSelector: anObject
	actionSelector := anObject! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:30.911'!
defaultBorderColor

	^ Color gray: 0.5! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 2/25/2010 16:32'!
defaultBorderWidth

	^ 1! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 7/16/2013 11:12:00.831'!
handlesMouseDown: event

	^ true! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 1/15/2010 17:29'!
handlesMouseOver: anEvent

	^ true! !

!SActionButtonMorph methodsFor: 'initialization' stamp: 'mp 1/15/2010 17:35'!
initialize
	super initialize.
	self color: self class defaultColor.! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/15/2010 21:00'!
mouseEnter: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness negated).! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/15/2010 21:00'!
mouseLeave: anEvent

	self color: (self color adjustBrightness: self class highlightBrightness).! !

!SActionButtonMorph methodsFor: 'event handling' stamp: 'mp 4/18/2010 20:26'!
mouseUp: anEvent
	
	self actionModel perform: self actionSelector withArguments: self actionArgs.! !

RectangleMorph subclass: #SCheckBoxMorph
	instanceVariableNames: 'checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:02:39.767'!
checked
	"Answer the value of checked"

	^ checked ifNil: [checked := false]! !

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:15:57.526'!
checked: anObject
	"Set the value of checked"
	checked := anObject.
	self changed.! !

!SCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 6/1/2011 12:52:13.554'!
drawOn: aCanvas
	aCanvas 
		frameRectangle: self bounds 
		color: Color black.
	self checked
		ifTrue: [aCanvas 
					fillRectangle: (self bounds expandBy: -2)
					color: Color black].
		! !

RectangleMorph subclass: #SCodePaneMorph
	instanceVariableNames: 'callNode definition objectExplorationMorphs objectExplorationMorphsStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

SCodePaneMorph class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

SCodePaneMorph class
	instanceVariableNames: 'loupeIcon documentIcon bugIcon treeIcon beforeIcon afterIcon pathfinderIcon closeIcon replayIcon infoIcon spiderIcon leftRightIcon worldIconLarge qualityIconLarge traceabilityIconLarge ladybugIconLarge stopwatchIconLarge'!

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/24/2010 14:42'!
borderOffset

	^ 2! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 8/13/2013 14:26:59.162'!
buttonHeight

	^ 22! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 8/13/2013 14:42:45.105'!
buttonWidth

	^ 22! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 17:16'!
codePaneHeight

	^ 125! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 8/13/2013 13:46:38.29'!
codePaneWidth

	^ 480 - 12! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 8/13/2013 13:21:24.738'!
controlWidth

	^ self codePaneWidth - self labelHeight - self definitionWidth! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:43:42.541'!
definitionHeight

	^ self codePaneHeight - (2 * self borderOffset)! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 11/8/2010 16:44:12.408'!
definitionWidth

	^ 400 - self labelHeight! !

!SCodePaneMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:32'!
labelHeight

	^ 15! !

!SCodePaneMorph class methodsFor: 'instance creation' stamp: 'mp 8/13/2013 13:49:46.231'!
on: aCallNode color: aColor

	^ self new
		callNode: aCallNode;
		color: aColor;
		createDefinitionMorph;
		createLabelMorph;
		createExclamationMark;
		createNodeButtons;
		createObjectExploreButtons;
		yourself! !

!SCodePaneMorph methodsFor: 'explore actions' stamp: 'mp 7/16/2013 17:13:06.705'!
addObjectExplorationMorph: aMorph

	(self objectExplorationMorphsStack includes: aMorph) 
		ifTrue: [self objectExplorationMorphsStack remove: aMorph].
	self objectExplorationMorphsStack addFirst: aMorph.
	self 
		addMorph: aMorph;
		adjustObjectExplorationMorphs.! !

!SCodePaneMorph methodsFor: 'explore actions' stamp: 'mp 7/16/2013 17:13:15.732'!
adjustObjectExplorationMorphs

	| posX |
	posX := self position x + self width.
	self objectExplorationMorphsStack do: [:each | 
		each position: posX @ self position y.
		posX := posX + each width].! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 8/13/2013 09:56:12.125'!
buttonSpec
	| spec |
	spec :=  {{#openCodeBrowser. 
				UiFugueIcons applicationIconIcon. 
				'Open the source code browser'}.
			    {#byteCodeCoverage. 
				UiFugueIcons magnifierZoomActualEqualIcon. 
				'Coverage per statements'}.
			    {#debugMethod. 
				UiFugueIcons bugIcon. 
				'Start symbolic debugger'}.
			    {#expandTree. 
				UiFugueIcons nodeIcon. 
				'Expand the complete subtree'}} asOrderedCollection.
	self isPathMapDataAvailable
		ifTrue: [	spec 
					add: {#showAdditionalInformation. 
							UiFugueIcons informationIcon. 
							'Show additional information'} 
					afterIndex: 1].
	^ spec! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 9/21/2011 11:53:51.587'!
byteCodeCoverage
	| byteCodes method map stream range |
	byteCodes := self tracer byteCodeCoverageAt: self callNode.
	method := self callNode compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	byteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each contextIsActiveContext: true.
					self definition text 
						addAttribute: TextEmphasis underlined
						from: range first 
						to: range last]].
			self definition changed.! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:03'!
callNode
	"Answer the value of callNode"

	^ callNode! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:03'!
callNode: anObject
	"Set the value of callNode"

	callNode := anObject! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 7/16/2013 17:08:48.256'!
callTreeModel

	^ self callNode callTreeModel! !

!SCodePaneMorph methodsFor: 'definition' stamp: 'mp 3/24/2011 12:15:48.158'!
codePaneClass
	^ SPluggableTextMorphPlus! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 8/13/2013 13:10:40.152'!
createButtonFromSelector: aSymbol icon: aForm
	
	| button |
	button := SActionButtonIconMorph on: self selector: aSymbol icon: aForm.
	self addMorph: button.
	^ button! !

!SCodePaneMorph methodsFor: 'definition' stamp: 'mp 3/24/2011 11:57:08.733'!
createDefinitionMorph

	| widget model |
	widget := self codePaneClass new.
	widget useDefaultStyler.
	model := SDefinitionModel new.
	model setClass: self callNode clientClass andSelector: self callNode clientSelector.
	widget on: model
				text: #contents
				accept: nil
				readSelection: nil 
				menu: nil.
	widget textMorph addDependent: self.
	widget 
		font: Preferences standardCodeFont;
		getColorSelector: nil;
		borderColor: Color lightGray;
		borderWidth: 0;
		color: Color white.
	self definition: widget.
	self addMorph: self definition.
	self definition extent: self class definitionWidth@self class definitionHeight.
	self definition position: (self definition position x + self class labelHeight)@ 
						(self definition position y + self class borderOffset)! !

!SCodePaneMorph methodsFor: 'label' stamp: 'mp 8/13/2013 11:10:51.868'!
createExclamationMark
	| violationMorph |
	self callNode hasViolations ifFalse: [^ self].
	violationMorph := SPMViolationMorph on: self callNode violations.
	self addMorph: violationMorph.
	"Place in center of lines of code"
	violationMorph position: (violationMorph position x + 19 )@
								(violationMorph position y + 2).! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:19:38.811'!
createExploreButtonsForArgumentsAt: aNumber
	| arguments |
	self callNode numArgsOfMethod isZero ifTrue: [^ aNumber].
	arguments := self getArgumentsFromSource: 
					self callNode methodReference sourceCode.
	self createMultipleArgumentsButton: arguments at: aNumber.
	^ aNumber - self class buttonHeight! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:20:21.492'!
createExploreButtonsForSelfAt: aNumber
	self setExploreBackgroundAt: aNumber.
	"Before button"
	self createObjectExploreIconButtonWith: {#selfBefore. 'before'. 1} 
		icon: UiFugueIcons applicationDockIcon 
		at: self getXPosForControlPanel@(aNumber + self class borderOffset)
		with: 'Explore the receiver object before the method is executed'.
	"After Button"
	self createObjectExploreIconButtonWith: {#selfAfter. 'after'. 1} 
		icon: UiFugueIcons applicationSidebarExpandIcon
		at: (self class codePaneWidth - self class buttonWidth - 1)@
			(aNumber + self class borderOffset)
		with: 'Explore the receiver object after the method was executed'.	
	self setExploreLabel: 'self' at: aNumber.
	^ aNumber - self class buttonHeight! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 14:28:33.683'!
createExploreButtonsFromSpecAt: aNumber
	| button yPos |
	yPos := aNumber.
	self createObjectExploreButtonSpec do: [:each |
		button := self createObjectExploreButtonWith: each first 
						name: each second atYPos: yPos.
		each size > 2
			ifTrue: [	button 
						setBalloonText: each third
						maxLineLength: 50].
		yPos := yPos - self class buttonHeight].
	^ yPos! !

!SCodePaneMorph methodsFor: 'label' stamp: 'mp 7/16/2013 17:08:59.978'!
createLabelMorph
	| stringMorph offsetPosX offsetPosY labelMorph |
	stringMorph := StringMorph contents: (self callNode views at: #receiver) asString.

	labelMorph := RectangleMorph new.
	labelMorph 
		extent: self class codePaneHeight @ self class labelHeight;
		color: self color;
		borderWidth: 1;
		borderColor: Color gray;
		addMorph: stringMorph.
		
	labelMorph width < self height
		ifTrue: [labelMorph width: self height].
	stringMorph width > (labelMorph width - 10)
		ifTrue: [stringMorph extent: (labelMorph width - 10) @ self class labelHeight.].
	
	offsetPosX := ((labelMorph width - stringMorph width) / 2) rounded.
	offsetPosY := ((labelMorph height - stringMorph height) / 2) rounded.
	stringMorph position: (stringMorph position x + offsetPosX)@(stringMorph position y + offsetPosY).	
	self addMorph: labelMorph.
	labelMorph heading: -90.
	labelMorph owner position: (self position x - 2) @ (self position y - 2).
	"Get color information from PathMap if available"
	(self callTreeModel getColorFromMap: self callNode)
		ifNotNil: [:color | labelMorph color: color].
	^ labelMorph! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:27:13.183'!
createMultipleArgumentsButton: aCollection at: aNumber
	| button |
	button := SActionButtonLabelMorph 
				on: self 
				selector: #showChooseArgumentMenu:
				args: (Array with: aCollection)
				name: 'Args...'.
	self addMorph: button.
	button 
		extent: (self class controlWidth - self class borderOffset)@self class buttonHeight;
		position: (self definition position x + 
					self definition width + self class borderOffset - 1)@
					(self definition position y + aNumber);
		borderWidth: 0.
	button 
		setBalloonText: 'Choose an argument for exploration' 
		maxLineLength: 50.! !

!SCodePaneMorph methodsFor: 'buttons' stamp: 'mp 8/13/2013 13:46:33.588'!
createNodeButtons
	| button x y startX |
	startX := self definition position x + self definition width + self class borderOffset - 1.
	x := startX.
	y := self position y + 1.
	self buttonSpec withIndexDo: [:each :index | 
		button := self createButtonFromSelector: each first icon: each second.
		index - 1 \\ 3 = 0
			ifTrue: [y := self position y + 1 + (index // 3 * button height).
					x := startX].
		button position: x@y.
		button borderWidth: 0.
		each size > 2
			ifTrue: [button setBalloonText: each third maxLineLength: 50].
		x := x + button width].! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 14:28:57.213'!
createObjectExploreButtonSpec

	^ {
		{{#return. 'return'. 1}. '   return'. 'Explore the returned object'}
	}! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:08:41.31'!
createObjectExploreButtonWith: aCollection name: aString atYPos: aNumber
	| button |
	button := SActionButtonLabelMorph 
				on: self 
				selector: #showObjectExploration:title:objectIndex:
				args: aCollection
				name: aString.
	self addMorph: button.
	button 
		extent: (self class controlWidth - self class borderOffset)@
					self class buttonHeight;
		position: (self definition position x + self definition width + 
					self class borderOffset - 1)@
						(self definition position y + aNumber);
		borderWidth: 0.
	button labelMorph position: (button position x + 2)@(button labelMorph position y).
	^ button! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:08:26.21'!
createObjectExploreButtons
	| yPos |
	yPos := self position y + self class borderOffset + 
				self class codePaneHeight - self class buttonHeight - 5.
	yPos := self createExploreButtonsFromSpecAt: yPos.
	yPos := self createExploreButtonsForSelfAt: yPos.
	yPos := self createExploreButtonsForArgumentsAt: yPos.
! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 7/16/2013 17:14:32.228'!
createObjectExploreIconButtonWith: aCollection icon: anIconForm
	| button |
	button := SActionButtonIconMorph 
				on: self 
				selector: #showObjectExploration:title:objectIndex:
				args: aCollection
				icon: anIconForm.
	self addMorph: button.
	button borderWidth: 0.
	^ button! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:15:33.842'!
createObjectExploreIconButtonWith: aCollection icon: anIconForm at: aPoint with: aString
	| button |
	button := SActionButtonIconMorph 
				on: self 
				selector: #showObjectExploration:title:objectIndex:
				args: aCollection
				icon: anIconForm.
	self addMorph: button.
	button borderWidth: 0.
	button position: aPoint.
	button setBalloonText: aString maxLineLength: 50.
	^ button! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 4/24/2010 14:22'!
debugMethod

	self tracer debugAt: self callNode.! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:48.984'!
defaultBorderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:45.332'!
defaultBorderWidth

	^ SCodeExplorerIndentingListItemMorph borderWidth! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:14'!
definition
	"Answer the value of definition"

	^ definition! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/14/2010 14:14'!
definition: anObject
	"Set the value of definition"

	definition := anObject! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 7/16/2013 16:21:06.869'!
expandTree

	self callNode callTreeModel expandNode: self callNode.! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 4/24/2010 15:26'!
getArgumentsFromSource: aText

	| signature tokens index |
	signature := aText string lineCorrespondingToIndex: 1.
	tokens := signature findBetweenSubStrs: ' :'.
	index := 0.
	^ tokens select: [:each |
		index := index + 1.
		index even. ].
	! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:00:10.413'!
getXPosForControlPanel
	^ self definition position x + self definition width + self class borderOffset - 1! !

!SCodePaneMorph methodsFor: 'initialization' stamp: 'mp 4/27/2010 14:51'!
initialize

	super initialize.
	self 
		color: Color white;
		extent: self class codePaneWidth@self class codePaneHeight.! !

!SCodePaneMorph methodsFor: 'testing' stamp: 'mp 3/25/2011 15:55:13.126'!
isPathMapDataAvailable
	^ self pathFinder notNil and: [self pathFinder coverageTracer notNil]! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 5/30/2013 14:28:00.963'!
methodTypesLabelFor: aWord
	| method temps index type |
	self flag: #mpe. "Redundant code compare to implementors"
	method := self callNode compiledMethod.
	temps := method methodNode arguments.
	temps ifNotEmpty: [
		temps := temps collect: [:each | each name].
		index := temps indexOf: aWord.
		index = 0
			ifFalse: [SProject current typesBucket 
						ifNil: [^ 'Run type harvester first'].
				type := ((SProject current typesBucket argumentsFor: method) at: index).
				type 
					ifNil: [^ 'No type available']
					ifNotNil: [^ type asString]]].
	(self callNode clientSelector asString beginsWith: aWord)
		ifTrue: [SProject current typesBucket 
					ifNil: [^ 'Run type harvester first'].
			type := (SProject current typesBucket 	returnFor: method).
			type 
				ifNil: [^ '^ No type available']
				ifNotNil: [^ '^ ', type asString]].
	^ ''
! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:44'!
objectExplorationMorphs
	"Answer the value of objectExplorationMorphs"

	^ objectExplorationMorphs ifNil: [objectExplorationMorphs := Dictionary new]! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:18'!
objectExplorationMorphs: anObject
	"Set the value of objectExplorationMorphs"

	objectExplorationMorphs := anObject! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 7/16/2013 17:12:21.147'!
objectExplorationMorphsStack

	^ objectExplorationMorphsStack 
		ifNil: [objectExplorationMorphsStack := OrderedCollection new]! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 7/16/2013 17:11:33.56'!
objectExplorationMorphsStack: anObject

	objectExplorationMorphsStack := anObject! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 8/8/2013 14:37:54.248'!
openCodeBrowser
	| browser colors |
	browser := Browser fullOnClass: self callNode clientClass selector: self callNode clientSelector.
	colors := self callTreeModel collectAllColorsFromNodes.
	colors
		ifNotEmpty: [browser methodColors: colors].! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:21:11.132'!
pathFinder

	^ self callNode callTreeModel pathFinder! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 7/4/2011 15:51:57.444'!
refreshScrollbars

	self owner container setScrollDeltas.! !

!SCodePaneMorph methodsFor: 'explore actions' stamp: 'mp 7/16/2013 17:13:21.865'!
removeObjectExplorationMorph: aMorph

	self objectExplorationMorphsStack remove: aMorph.
	self 
		removeMorph: aMorph;
		adjustObjectExplorationMorphs.! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:02:13.038'!
setExploreBackgroundAt: aNumber
	| background |
	background := RectangleMorph new.
	self addMorph: background.
	background
		color: Color white;
		borderWidth: 0;
		extent: (self class controlWidth - self class borderOffset)@
					self class buttonHeight;
		position: self getXPosForControlPanel@(aNumber + self class borderOffset).
! !

!SCodePaneMorph methodsFor: 'explore buttons' stamp: 'mp 8/13/2013 15:05:06.734'!
setExploreLabel: aString at: aNumber
	| label |
	label := StringMorph contents: aString.
	self addMorph: label.
	label position:  (self getXPosForControlPanel - self class borderOffset + 
						(self class controlWidth / 2) - (label width / 2))@
					(aNumber + self class borderOffset + 
						(self class buttonHeight / 2) - (label height / 2)).! !

!SCodePaneMorph methodsFor: 'button actions' stamp: 'mp 7/16/2013 17:09:02.721'!
showAdditionalInformation
	| info |
	info := self callTreeModel getAdditionalInformationFromMap: self callNode.
	info ifNil: [^ self].
	info isString
		ifTrue: [^ self inform: info].
	info explore.! !

!SCodePaneMorph methodsFor: 'explore actions' stamp: 'mp 4/24/2010 17:09'!
showChooseArgumentMenu: aCollection

	| choice |
	choice := UIManager default 
				chooseFrom: aCollection 
					values: (1 to: aCollection size) 
					lines: #() 
					title: 'Choose argument'.
	choice ifNotNil: [self showObjectExploration: #arguments title: (aCollection at: choice) objectIndex: choice].! !

!SCodePaneMorph methodsFor: 'explore actions' stamp: 'mp 7/4/2011 15:50:57.431'!
showObjectExploration: aSymbol title: aString objectIndex: aNumber

	| morph |
	morph := self objectExplorationMorphs 
				at: (aSymbol asString, aNumber asString) asSymbol
				ifAbsentPut: [SObjectExplorationMorph 
								on: self 
								title: aString 
								kindOfObjects: aSymbol 
								objectIndex: aNumber
								callNode: self callNode 
								color: self color].
	self 
		addObjectExplorationMorph: morph;
		refreshScrollbars.! !

!SCodePaneMorph methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:21:21.859'!
tracer

	^ self callNode callTreeModel tracer! !

!SCodePaneMorph methodsFor: 'updating' stamp: 'mp 3/24/2011 12:01:48.954'!
update: aWord with: aTextMorph
	aTextMorph labelMorph createLabelMorph: (self methodTypesLabelFor: aWord).
! !

RectangleMorph subclass: #SColorLegendMorph
	instanceVariableNames: 'labelMorph optionsModel verticalColors horizontalColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SColorLegendMorph class methodsFor: 'constants' stamp: 'mp 9/16/2010 10:27:11.875'!
labelOffset
	^ 10@10! !

!SColorLegendMorph class methodsFor: 'instance creation' stamp: 'mp 9/16/2010 18:55:06.251'!
on: anOptionsModel

	^ self new
		optionsModel: anOptionsModel;
		yourself! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 13:43:32.438'!
convertToRelativePosition: aPoint
	| local |
	local := (self bounds topLeft - aPoint) * -1.
	^ (local x / self width) asFloat @ (local y / self height) asFloat.! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 22:32:04.587'!
defaultBorderColor

	^ Color gray: 0.5! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 22:31:58.354'!
defaultBorderWidth

	^ 1! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/16/2010 09:42:34.501'!
drawBordersOn: aCanvas
	aCanvas 
		frameRectangle: self bounds 
		width: self defaultBorderWidth 
		color: self defaultBorderColor.! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 7/16/2013 17:17:04.522'!
drawColorHorizontalOn: aCanvas
	| lastHorizontal insetRect fillStyle |
	lastHorizontal := 0.0.
	self horizontalColors do: [:each | 
		insetRect := self bounds 
						insetOriginBy: ((self bounds width * lastHorizontal) asInteger@0)
						cornerBy: ((self bounds width - (self bounds width * each key)) asInteger@0).
		lastHorizontal := each key.
		fillStyle := GradientFillStyle colors: each value.
		fillStyle origin: insetRect topLeft.
		fillStyle direction: insetRect width@0.
		aCanvas fillRectangle: insetRect fillStyle: fillStyle].
! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/20/2010 18:29:27.279'!
drawColorVerticalOn: aCanvas
	| lastVertical insetRect fillStyle |
	lastVertical := 0.0.
	self verticalColors do: [:each | 
		insetRect := self bounds 
						insetOriginBy: (0@(self bounds height * lastVertical) asInteger)
						cornerBy: (0@(self bounds height - 	(self bounds height * each key)) asInteger).
		lastVertical := each key.
		fillStyle := GradientFillStyle colors: each value.
		fillStyle origin: insetRect topLeft.
		fillStyle direction: 0@insetRect height.
		aCanvas fillRectangle: insetRect fillStyle: fillStyle].
! !

!SColorLegendMorph methodsFor: 'drawing' stamp: 'mp 9/17/2010 17:03:16.045'!
drawOn: aCanvas
	self 
		drawColorHorizontalOn: aCanvas;
		drawColorVerticalOn: aCanvas;
		drawBordersOn: aCanvas.
! !

!SColorLegendMorph methodsFor: 'events-processing' stamp: 'mp 9/16/2010 09:56:16.082'!
handleMouseMove: anEvent
	anEvent wasHandled: true.
	self mouseMove: anEvent.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 7/16/2013 17:17:11.462'!
handlesMouseOver: anEvent

	^ true! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/17/2010 17:03:45.694'!
horizontalColors
	"Answer the value of horizontalColors"

	^ horizontalColors! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/17/2010 17:03:45.699'!
horizontalColors: anObject
	"Set the value of horizontalColors"

	horizontalColors := anObject! !

!SColorLegendMorph methodsFor: 'initialization' stamp: 'mp 9/16/2010 10:01:13.69'!
initialize
	super initialize.
	self extent: 150@150.
	self labelMorph: (SLabelMorph label: 'ToDo').! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:00:46.979'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 10:00:46.984'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:54:55.868'!
mouseEnter: anEvent
	self flag: #mpe. "owner owner works but is very fragile"
	"Required to allow large labels to be shown outside the color legend"
	self owner owner addMorph: self labelMorph.
	self labelMorph position: anEvent cursorPoint + self class labelOffset.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:53:39.978'!
mouseLeave: anEvent
	self flag: #mpe. "owner owner works but is very fragile"
	self owner owner removeMorph: self labelMorph.! !

!SColorLegendMorph methodsFor: 'event handling' stamp: 'mp 9/17/2010 14:26:12.973'!
mouseMove: anEvent
	| labelString relativePosition |
	relativePosition := self convertToRelativePosition: anEvent position.
	labelString := self optionsModel
		ifNil: [(relativePosition x printShowingDecimalPlaces: 2), '@',
								(relativePosition y printShowingDecimalPlaces: 2)]
		ifNotNil: [self optionsModel getLabelString: relativePosition].
	self labelMorph createLabelMorph: labelString.
	self labelMorph position: anEvent cursorPoint + self class labelOffset.! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:54:45.479'!
optionsModel
	"Answer the value of optionsModel"

	^ optionsModel! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 18:54:45.483'!
optionsModel: anObject
	"Set the value of optionsModel"

	optionsModel := anObject! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 19:03:38.679'!
verticalColors
	"Answer the value of verticalColors"

	^ verticalColors! !

!SColorLegendMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 19:03:38.685'!
verticalColors: anObject
	"Set the value of verticalColors"

	verticalColors := anObject! !

RectangleMorph subclass: #SLabelMorph
	instanceVariableNames: 'labelMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SLabelMorph class methodsFor: 'constants' stamp: 'mp 9/15/2010 17:45:00.918'!
defaultColor

	^ Color white! !

!SLabelMorph class methodsFor: 'constants' stamp: 'mp 9/15/2010 18:44:58.329'!
defaultExtensionFactor

	^ 1.3! !

!SLabelMorph class methodsFor: 'instance creation' stamp: 'mp 9/15/2010 17:41:34.967'!
label: aString

	^ self new
		createLabelMorph: aString;
		yourself! !

!SLabelMorph methodsFor: 'building' stamp: 'mp 9/8/2011 18:09:33.29'!
createLabelMorph: aString
	| morph corner |
	self labelMorphs ifNotNil: [
		self labelMorphs do: [:each | 
			self removeMorph: each. 
			each delete].
		self labelMorphs: OrderedCollection new.].
	aString lines do: [:each | 
		morph := StringMorph contents: each.
		self labelMorphs add: morph.
		self addMorph: morph].
	corner := self labelMorphs 
		ifEmpty: [1@1]
		ifNotEmpty: [ (self labelMorphs collect: [:each | each fullBounds corner x]) max
					@ ((self labelMorphs collect: [:each | each  fullBounds corner y]) sum)].
	self extent: (corner * self class defaultExtensionFactor).! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:35.443'!
defaultBorderColor

	^ Color gray: 0.5! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:41.885'!
defaultBorderWidth

	^ 1! !

!SLabelMorph methodsFor: 'geometry' stamp: 'mp 9/9/2011 09:37:03.35'!
extent: aPoint
	| borderOffset heightOffset |
	super extent: aPoint.
	self labelMorphs withIndexDo: [:each :index | 
		each position: self position x @ (self position y + ((index - 1) * each height))].
	heightOffset := (self height - (self height / self class defaultExtensionFactor)) / 2.
	self labelMorphs withIndexDo: [:each :index | 
		each width < self width
			ifTrue: [each position: 
					(each position x + (self width / 2) - (each width / 2)) @ 
					(each position y + heightOffset)]
			ifFalse: [
				borderOffset := 5.
				each position: 
					(self position x + borderOffset - 2) @ 
					(each position y + heightOffset).
				each extent: (self width - borderOffset) @ self height]].! !

!SLabelMorph methodsFor: 'initialization' stamp: 'mp 9/15/2010 17:44:51.141'!
initialize
	super initialize.
	self color: self class defaultColor.! !

!SLabelMorph methodsFor: 'accessing' stamp: 'mp 9/8/2011 16:57:08.097'!
labelMorphs
	"Answer the value of labelMorphs"

	^ labelMorphs ifNil: [labelMorphs := OrderedCollection new]! !

!SLabelMorph methodsFor: 'accessing' stamp: 'mp 9/8/2011 16:56:29.288'!
labelMorphs: anObject
	"Set the value of labelMorphs"

	labelMorphs := anObject! !

RectangleMorph subclass: #SObjectExplorationMorph
	instanceVariableNames: 'codePane title callNode kindOfObject objectIndex objectToExplore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/7/2010 16:43:57.664'!
borderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/20/2010 15:57'!
borderOffset

	^ 2! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:57'!
buttonWidth

	^ 15! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/7/2010 16:44:42.262'!
explorationHeight

	^ SCodePaneMorph codePaneHeight! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 7/4/2011 13:42:49.89'!
explorationMinWidth

	^ 225! !

!SObjectExplorationMorph class methodsFor: 'instance creation' stamp: 'mp 4/24/2010 16:16'!
on: aCodePane title: aString kindOfObjects: aSymbol objectIndex: aNumber callNode: aCallNode color: aColor

	^ self new
		codePane: aCodePane;
		title: aString;
		callNode: aCallNode;
		kindOfObject: aSymbol;
		objectIndex: aNumber;
		color: aColor;
		createMorphs;
		yourself! !

!SObjectExplorationMorph class methodsFor: 'instance creation' stamp: 'mp 4/27/2010 19:52'!
on: aCodePane title: aString object: anObject color: aColor

	^ self new
		codePane: aCodePane;
		title: aString;
		objectToExplore: anObject;
		color: aColor;
		createMorphs;
		yourself! !

!SObjectExplorationMorph class methodsFor: 'constants' stamp: 'mp 4/27/2010 16:53'!
titleBorderWidth

	^ 1! !

!SObjectExplorationMorph methodsFor: 'actions' stamp: 'mp 4/20/2010 16:36'!
browseClass: aClass

	Browser fullOnClass: aClass! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
callNode
	"Answer the value of callNode"

	^ callNode! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
callNode: anObject
	"Set the value of callNode"

	callNode := anObject! !

!SObjectExplorationMorph methodsFor: 'actions' stamp: 'mp 7/4/2011 15:51:24.064'!
close

	self codePane removeObjectExplorationMorph: self.
	self codePane refreshScrollbars.! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:44'!
codePane
	"Answer the value of codePane"

	^ codePane! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 18:44'!
codePane: anObject
	"Set the value of codePane"

	codePane := anObject! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 7/7/2010 16:39:45.521'!
createCloseButton

	| closeButton |
	closeButton := SActionButtonLabelMorph on: self selector: #close name: 'X'.
	self addMorph: closeButton.
	closeButton 
		extent: (self class buttonWidth -1)@self class buttonWidth;
		position: (self position x + self width - closeButton width) @ (self position y);
		color: self color.
	! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 16:55'!
createMorphs

	| exploredObject |
	exploredObject := self getObjectToExplore.
	self 
		createObjectExplorerOn: exploredObject;
		createCloseButton.
! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 7/7/2010 17:07:53.172'!
createObjectExplorerOn: anObject
	| listMorph |
	listMorph := (SObjectExplorer on: self codePane) explorerListMorphFor: anObject.
	self addMorph: listMorph.
	listMorph 
		borderWidth: 0;
		position: self position x @ (self position y + self class buttonWidth);
		extent: (self width - 1)@(self height - self class buttonWidth - 1).
! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:54.844'!
defaultBorderColor

	^ SCodeExplorerIndentingListItemMorph borderColor! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 7/7/2010 16:43:52.227'!
defaultBorderWidth

	^ SCodeExplorerIndentingListItemMorph borderWidth! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 16:52'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self title ifNil: [^ self].
	self 
		drawTitleRectangleOn: aCanvas;
		drawTitleOn: aCanvas.! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 3/30/2012 15:25:23.951'!
drawTitleOn: aCanvas

	| string object |
	object := self getObjectToExplore.
	string := self title, ': ',  object class asString, ' (',  object asString, ')'.
	aCanvas 
		drawString: string
		in: ((self position x + 2@self position y) 
			corner: ((self position x + self width - 2 - self class buttonWidth) @ 
				(self position y + self class buttonWidth))).! !

!SObjectExplorationMorph methodsFor: 'drawing' stamp: 'mp 4/27/2010 16:59'!
drawTitleRectangleOn: aCanvas

	| rect |
	rect := ((self position x - 1) @ self position y) 
			corner: ((self position x + self width) @ 
					(self position y + self class buttonWidth)).
	aCanvas 
		frameAndFillRectangle: rect 
		fillColor: self color 
		borderWidth: self class titleBorderWidth 
		borderColor: self class borderColor.! !

!SObjectExplorationMorph methodsFor: 'morphic' stamp: 'mp 4/27/2010 19:53'!
getObjectToExplore

	| objects |
	self objectToExplore ifNotNil: [^ self objectToExplore].
	objects := self callNode explore: self kindOfObject.
	objects size = 1 ifTrue: [
		self kindOfObject == #arguments
			ifTrue: [^ objects first at: self objectIndex].
		^ objects first].
	^ objects! !

!SObjectExplorationMorph methodsFor: 'initialization' stamp: 'mp 4/20/2010 17:01'!
initialize

	super initialize.
	self extent: self class explorationMinWidth @ self class explorationHeight.
	! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
kindOfObject
	"Answer the value of kindOfObject"

	^ kindOfObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/19/2010 20:12'!
kindOfObject: anObject
	"Set the value of kindOfObject"

	kindOfObject := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 16:16'!
objectIndex
	"Answer the value of objectIndex"

	^ objectIndex! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/24/2010 16:16'!
objectIndex: anObject
	"Set the value of objectIndex"

	objectIndex := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:52'!
objectToExplore
	"Answer the value of objectToExplore"

	^ objectToExplore! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/27/2010 19:52'!
objectToExplore: anObject
	"Set the value of objectToExplore"

	objectToExplore := anObject! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:56'!
title
	"Answer the value of title"

	^ title! !

!SObjectExplorationMorph methodsFor: 'accessing' stamp: 'mp 4/18/2010 19:56'!
title: anObject
	"Set the value of title"

	title := anObject! !

!Behavior methodsFor: '*Path-Core' stamp: 'mp 1/25/2010 10:26'!
classAndMethodFor: aSymbol do: binaryBlock ifAbsent: absentBlock
	"Looks up the selector aSymbol in the class chain. If it is found, binaryBlock is evaluated
	with the class that defines the selector and the associated method. Otherwise
	absentBlock is evaluated."

	| method |
	self withAllSuperclassesDo: [:class |
		method := class compiledMethodAt: aSymbol ifAbsent: [nil].
		method ifNotNil: [^ binaryBlock value: class value: method].
	].
	^ absentBlock value.! !

!SystemWindow methodsFor: '*Path-Core-override' stamp: 'mp 9/13/2010 17:30:44.37'!
addPaneHSplitters
	"reject flap morphs, too"
	| remaining targetY sameY |
	remaining := paneMorphs copy reject: [:each | each layoutFrame bottomFraction = 1 
													or: [each isKindOf: SPluggableFlapMorph]].
	[remaining notEmpty] whileTrue:
		[targetY := remaining first layoutFrame bottomFraction.
		sameY := paneMorphs select: [:each | each layoutFrame bottomFraction = targetY].
		self addPaneHSplitterBetween: remaining first and: sameY.
		remaining := remaining copyWithoutAll: sameY]! !

!SystemWindow methodsFor: '*Path-Core-override' stamp: 'mp 9/13/2010 17:30:50.57'!
addPaneVSplitters
	"reject flap morphs, too"
	| remaining targetX sameX |
	remaining := paneMorphs copy reject: [:each | each layoutFrame rightFraction = 1 
													or: [each isKindOf: SPluggableFlapMorph]].
	[remaining notEmpty] whileTrue:
		[targetX := remaining first layoutFrame rightFraction.
		sameX := paneMorphs select: [:each | each layoutFrame rightFraction = targetX].
		self addPaneVSplitterBetween: remaining first and: sameX.
		remaining := remaining copyWithoutAll: sameX]! !

PluggableMultiSelectionListSpec subclass: #SPluggableMultiSelectionListSpec
	instanceVariableNames: 'itemColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Specs'!

!SPluggableMultiSelectionListSpec methodsFor: 'building' stamp: 'mp 9/23/2010 16:45:03.24'!
buildWith: builder
	^builder buildSPluggableMultiSelectionList: self! !

!SPluggableMultiSelectionListSpec methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:44:47.093'!
itemColor
	"Answer the value of itemColor"

	^ itemColor! !

!SPluggableMultiSelectionListSpec methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:44:47.098'!
itemColor: anObject
	"Set the value of itemColor"

	itemColor := anObject! !

!ObjectExplorerWrapper methodsFor: '*Path-Core' stamp: 'mp 4/27/2010 18:37'!
item

	^ item! !

!LazyListMorph methodsFor: '*Path-Core-override' stamp: 'mp 9/22/2010 14:15:44.513'!
drawBackgroundForMulti: row on: aCanvas 
	"shade the background paler, if this row is selected, but not the current selected row"
	| selectionDrawBounds thisColor |
	thisColor := selectedRow = row
		ifTrue: [ self class listSelectionColor ]
		ifFalse: [ self class listSelectionColor lighter ].
	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas
		fillRectangle: selectionDrawBounds
		color: thisColor! !

LazyListMorph subclass: #SLazyListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SLazyListMorph methodsFor: 'drawing' stamp: 'mp 9/23/2010 17:56:34.888'!
colorForRow: row
	| itemColor |
	itemColor := listSource itemColorAt: row.
	itemColor == false
		ifFalse: [^ itemColor].	
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ self class listSelectionTextColor ]
		ifFalse: [ self color ].
		! !

PluggableButtonMorphPlus subclass: #SPluggableCheckBoxMorph
	instanceVariableNames: 'checkBoxMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:08:08.041'!
checkBoxMorph
	"Answer the value of checkBoxMorph"

	^ checkBoxMorph! !

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/15/2010 15:08:08.046'!
checkBoxMorph: anObject
	"Set the value of checkBoxMorph"

	checkBoxMorph := anObject! !

!SPluggableCheckBoxMorph methodsFor: 'initialize-release' stamp: 'mp 9/16/2010 11:26:13.693'!
initialize
	super initialize.
	onColor := Color white.
	offColor := Color lightGray.! !

!SPluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'mp 9/16/2010 11:26:49.093'!
label: aStringOrTextOrMorph font: aFont
	"Label this button with the given string or morph."
	| r |
	self removeAllMorphs.
	"nest label in a row for centering"
	r := AlignmentMorph newRow
		borderWidth: 0;
		layoutInset: 0;
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		wrapCentering: #center; cellPositioning: #leftCenter.
	aStringOrTextOrMorph isMorph
		ifTrue: [
			label := aStringOrTextOrMorph.
			r addMorph: aStringOrTextOrMorph]
		ifFalse: [
			label := aStringOrTextOrMorph asString.
			r addMorph: (StringMorph contents: label font: aFont)].
	"space placeholder"
	r addMorph: ((Morph new extent: (aFont pointSize - 3)@(aFont pointSize - 3)) 
					color: Color transparent).
	self checkBoxMorph: (SCheckBoxMorph new 
							extent: (aFont pointSize)@(aFont pointSize)).
	self checkBoxMorph checked: self getModelState.
	r addMorph: self checkBoxMorph.
	self addMorph: r.! !

!SPluggableCheckBoxMorph methodsFor: 'updating' stamp: 'mp 9/15/2010 15:11:01.907'!
update: what
	| state |
	what ifNil:[^self].
	what == getLabelSelector ifTrue: [
		self label: (model perform: getLabelSelector)].
	what == getEnabledSelector ifTrue:[^self enabled: (model perform: getEnabledSelector)].

	getColorSelector ifNotNil: [ | cc |
		color = (cc := model perform: getColorSelector) ifFalse:[
			color := cc.
			self onColor: color offColor: color.
			self changed.
		].
	].
	state := self getModelState.
	self checkBoxMorph checked: state.
	state
		ifTrue: [self color: onColor]
		ifFalse: [self color: offColor].	
	getEnabledSelector ifNotNil:[
		self enabled: (model perform: getEnabledSelector).
	].
! !

!PluggableListMorphOfMany methodsFor: '*Path-Core-override' stamp: 'mp 9/22/2010 13:52:22.471'!
update: aSymbol 
	aSymbol == #allSelections ifTrue:
		[self selectionIndex: self getCurrentSelectionIndex.
		^ self changed].
	aSymbol == getSelectionListSelector
		ifTrue: [self changed].
	^ super update: aSymbol! !

PluggableListMorphOfMany subclass: #SPluggableListMorphOfMany
	instanceVariableNames: 'itemColorSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableListMorphOfMany methodsFor: 'drawing' stamp: 'mp 9/23/2010 17:47:45.121'!
itemColorAt: index
	itemColorSelector ifNil: [^ false].
	^ model perform: itemColorSelector with: index! !

!SPluggableListMorphOfMany methodsFor: 'as yet unclassified' stamp: 'mp 9/23/2010 17:49:25.498'!
listMorphClass
	^SLazyListMorph! !

!SPluggableListMorphOfMany methodsFor: 'accessing' stamp: 'mp 9/23/2010 17:46:22.699'!
setItemColorSelector: aSymbol
	"Set the value of iconSelector"

	itemColorSelector := aSymbol! !

PluggableTreeSpec subclass: #SPluggableTreeSpec
	instanceVariableNames: 'highlightItem indentingListItemMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:51'!
highlightItem
	^ highlightItem! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:51'!
highlightItem: anObject
	highlightItem := anObject! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:18'!
indentingListItemMorph
	"Answer the value of indentingListItemMorph"

	^ indentingListItemMorph! !

!SPluggableTreeSpec methodsFor: 'accessing' stamp: 'mp 4/14/2010 11:18'!
indentingListItemMorph: anObject
	"Set the value of indentingListItemMorph"

	indentingListItemMorph := anObject! !

Browser subclass: #SBrowser
	instanceVariableNames: 'currentSelectedMethod cacheCoverage cacheConcerns refreshRequired previousMethod filterProjectCategories codeSource testMode methodColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Browser'!

!SBrowser class methodsFor: 'constants' stamp: 'mp 5/3/2010 23:17'!
defaultExtent

	^ 750@390! !

!SBrowser class methodsFor: 'instance creation' stamp: 'mp 5/28/2013 16:43:16.242'!
fullOnClass: aClass selector: aSelector
	"Open a new full browser set to class."
	| browser |
	browser := self new.
	browser setClass: aClass selector: aSelector.
	^ self 
		openBrowserView: (browser openEditString: nil)
		label: browser labelString! !

!SBrowser class methodsFor: 'class initialization' stamp: 'mp 3/7/2011 22:27:40.148'!
initialize

	self registerInAppRegistry.
	TheWorldMenu registerOpenCommand: {'PathBrowser'. {self. #open}}.! !

!SBrowser class methodsFor: 'instance creation' stamp: 'mp 8/14/2013 13:33:41.759'!
openBrowserView: aBrowserView label: aString 
	"Schedule aBrowserView, labeling the view aString."
	| morph |
	(aBrowserView isKindOf: ToolBuilderSpec) ifTrue:[
		morph := ToolBuilder open: aBrowserView label: aString.
		morph extent: self defaultExtent.
	] ifFalse:[
		aBrowserView isMorph
			ifTrue:  [(aBrowserView setLabel: aString) openInWorld]
			ifFalse: [aBrowserView label: aString.
					aBrowserView minimumSize: 300 @ 200.
					aBrowserView subViews do: [:each | each controller].
					aBrowserView controller open].
	].
	"Dependency required for label control within source code"
	(aBrowserView model dependents 
		detect: [:each | each isKindOf: SPluggableTextMorphPlus] ifNone: [nil])
		ifNotNil: [:each | 	each textMorph addDependent: aBrowserView model].
	aBrowserView model class = self
		ifTrue: [aBrowserView model refreshAdditionalLists].
	^ aBrowserView model
! !

!SBrowser class methodsFor: 'window color' stamp: 'mp 8/14/2013 15:17:31.242'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'PathBrowser' 
		brightColor:  #white
		pastelColor: #white
		helpMessage: 'Connection of Source Code and Hidden Test Knowledge'! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 16:14:15.581'!
aboutToStyle: aStyler
	"Added invariants to syntax highlighting"
	self invariantsShown ifTrue: 
		[aStyler classOrMetaClass: (self selectedClassOrMetaClass). 
		^ true].
	^ super aboutToStyle: aStyler! !

!SBrowser methodsFor: 'state exploration' stamp: 'mp 8/9/2013 11:55:12.103'!
askForStateOf: aClass

	^ (UIManager default 
		chooseFrom: {'self'}, aClass instVarNames 
		values: {nil}, aClass instVarNames 
		lines: #() 
		title: 'Choose state to explore')! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 8/9/2013 13:51:33.382'!
browsePath
	| tests |
	tests := self coveredTestsSortedFor: self selectedMethodReference.
	tests 
		ifEmpty: [self inform: 'The method is not covered by an entry point.', 
							  String cr, 
							  'Run PathMap first.']
		ifNotEmpty:[
			(self chooseTest: tests asOrderedCollection)
				ifNotNil: [:choice | self openPathFinderOn: choice asMethodReference]].	! !

!SBrowser methodsFor: 'start tools' stamp: 'tfel 6/5/2012 19:01:59.181'!
browseWithPathView
	| views labels lines open projectsPathViews |
	self selectedClass ifNil: [^ self].  
	views := OrderedCollection newFrom: {#new}.
	labels := OrderedCollection newFrom: {'New ...' translated}.
	lines := OrderedCollection newFrom: #(1).
	projectsPathViews := ((self selectedClass theMetaClass organization
								listAtCategoryNamed: SClassDiagramMorph diagramCodeCategory)
								collect: #asString) collect: #allButLast.
	projectsPathViews ifNotEmpty: [
		views addAll: (projectsPathViews collect: [:name |
						(SProject allProjects detect: [:p | p views includes: name]) -> name]).
		labels addAll: (projectsPathViews collect: [:name |
						(SProject allProjects detect: [:p | p views includes: name]) projectName, ' - ', name])].
	views ifEmpty: [^ self createPathView].
	open := SMultipleChoiceRequest
				prompt: 'Open view...'
				labels: labels
				values: views
				lines: lines.
	open ifNotNil: [
		open = #new ifTrue: [^ self createPathView].
		SProject setCurrentProject: open key.
		SPathView openSaved: open value].! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 8/8/2013 16:11:16.903'!
buildClassListWith: builder
	| listSpec |
	listSpec := super buildClassListWith: builder.
	listSpec icon: #iconForClass:.
	^ listSpec! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 7/16/2013 11:19:05.352'!
buildCodePaneWith: builder
	| textSpec top buttonSpec annotationSpec |
	textSpec := builder pluggableCodePaneSpec new.
	textSpec 
		model: self;
		name: #codePane;
		getText: #contents; 
		setText: #contents:notifying:; 
		selection: #contentsSelection; 
		menu: #codePaneMenu:shifted:.
	self wantsAnnotationPane ifTrue:[
		top ifNil:[
			top := builder pluggablePanelSpec new.
			top children: OrderedCollection new.
		].
		annotationSpec := builder pluggableInputFieldSpec new.
		annotationSpec model: self; getText: #annotation. 
		annotationSpec frame: (0@0.88 corner: 1@1).
		top children add: annotationSpec.
	].
	top ifNotNil:[
		textSpec frame: (0 @ (buttonSpec ifNil:[0] ifNotNil:[0.12])
			corner: 1 @ (annotationSpec ifNil:[1] ifNotNil:[0.88])).
		top children add: textSpec.
	].
	^top ifNil:[textSpec]! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 3/23/2011 12:17:17.797'!
buildConcernTreeWith: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #concernTree;
		roots: #rootsConcerns;
		hasChildren: #hasChildrenConcerns:;
		getChildren: #getChildrenConcerns:;
		label: #labelConcern:;
		setSelected: #selectedConcernItem:;
		icon: #iconForConcernItem:.
	^ treeSpec! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:23:41.954'!
buildContractSwitchesWith: builder
	"Build the switches to view parts of contracts"
	| panelSpec buttonSpec |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'pre'; 
			state: #preconditionsShown; 
			action: #togglePreconditions;
			color: #conditionButtonColor;
			enabled: #hasConditions;
			frame: (0@0 corner: 0.39@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'post'; 
			state: #classMessagesIndicated; 
			action: #togglePostconditions;
			color: #conditionButtonColor;
			enabled: #hasConditions;
			frame: (0.61@0 corner: 1@1).
	panelSpec children addLast: buttonSpec.

	^ panelSpec! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 8/8/2013 16:12:17.204'!
buildMessageListWith: builder
	| listSpec |
	listSpec := super buildMessageListWith: builder.
	listSpec icon: #iconForMessage:.
	^listSpec
! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 15:54:49.524'!
buildSwitchesWith: builder
	"Build the instance/comment/invariant/class switches"
	| panelSpec buttonSpec |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'inst'; 
			state: #instanceMessagesIndicated; 
			action: #indicateInstanceMessages;
			frame: (0@0 corner: 0.31@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: '?'; 
			state: #classCommentIndicated; 
			action: #plusButtonHit;
			frame: (0.33@0 corner: 0.47@1).
	panelSpec children addLast: buttonSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'inv'; 
			state: #invariantsShown; 
			action: #toggleInvariants;
			color: #invariantsButtonColor;
			enabled: #hasInvariants;
			frame: (0.49@0 corner: 0.65@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'class'; 
			state: #classMessagesIndicated; 
			action: #indicateClassMessages;
			frame: (0.67@0 corner: 1@1).
	panelSpec children addLast: buttonSpec.

	^ panelSpec! !

!SBrowser methodsFor: 'toolbuilder' stamp: 'mp 3/26/2013 13:32:35.902'!
buildTestCoverageListWith: builder
	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		name: #testCoverage;
		list: #coverageList;
		setIndex: #coverageListIndex:.
	^listSpec! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/23/2011 11:40:43.571'!
cacheConcerns
	"Answer the value of cacheConcerns"

	^ cacheConcerns ifNil: [IdentityDictionary new]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/23/2011 11:26:58.331'!
cacheConcerns: anObject
	"Set the value of cacheConcerns"

	cacheConcerns := anObject! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/21/2011 15:06:25.408'!
cacheCoverage
	"Answer the value of cacheCoverage"

	^ cacheCoverage ifNil: [{}]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/21/2011 15:05:36.58'!
cacheCoverage: anObject
	"Set the value of cacheCoverage"

	cacheCoverage := anObject! !

!SBrowser methodsFor: 'state exploration' stamp: 'mp 8/9/2013 13:54:41.528'!
chooseResult: aCollection
	^ (UIManager default 
		chooseFrom: aCollection 
		values: aCollection 
		lines: #() 
		title: 'Choose state to explore with PathFinder')! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 8/9/2013 13:51:29.906'!
chooseTest: aCollectionOfTests

	^ UIManager default 
				chooseFrom: (aCollectionOfTests collect: [:each | each asStringOrText]) 
				values: aCollectionOfTests 
				lines: #() 
				title: 'Choose entry point'.! !

!SBrowser methodsFor: 'state exploration' stamp: 'mp 8/9/2013 14:06:37.389'!
chooseTestFrom: aDictionary and: aString
	| tests |
	tests := aDictionary keys select: [:each | (aDictionary at: each) includes: aString].
	^ (UIManager default 
		chooseFrom: tests 
		values: tests 
		lines: #() 
		title: 'Choose test for state in PathFinder')! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/14/2012 16:33:12.007'!
classListIndex: anInteger 
	self codeSource: nil.
	super classListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each getClassMorph: self selectedClass) highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 8/9/2013 11:13:53.897'!
classListMenu: aMenu shifted: shifted
	"Set up the menu to apply to the receiver's class list, honoring the #shifted boolean"
	self 
		menuHook: aMenu 
		named: #classListMenu 
		shifted: shifted.
	Preferences useOnlyServicesInMenu ifTrue:[^aMenu].
	shifted ifTrue:[^ self shiftedClassListMenu: aMenu].
	aMenu addList: #(
		('browse full (b)'			browseMethodFull)
		('browse hierarchy (h)'		spawnHierarchy)
		('browse protocol (p)'		browseFullProtocol)
		('browse with PathView'	browseWithPathView)
		-
		('printOut'					printOutClass)
		('fileOut'					fileOutClass)
		-
		('show hierarchy'			hierarchy)
		('show definition'			editClass)
		('show comment'			editComment)
		-
		('references... (r)'			browseVariableReferences)
		('assignments... (a)'			browseVariableAssignments)
		('explore state...'			exploreStatesFromTests)
		('class refs (N)'				browseClassRefs)
		-
		('rename class ...'			renameClass)
		('copy class'				copyClass)
		('remove class (x)'			removeClass)
		-
		('check spelling'			spellCheckClass)
		-
		('find method...'				findMethod)
		-
		('more...'					offerShiftedClassListMenu)).
	^ aMenu
! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 6/1/2011 13:21:02.012'!
codePane
	^ self dependents detect: [:each | each knownName = 'codePane']! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 15:59:25.337'!
codeSource
	"Answer the value of codeSource"

	^ codeSource! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 15:59:25.348'!
codeSource: anObject
	"Set the value of codeSource"

	codeSource := anObject! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:57:47.019'!
computeOchiaiFor: aDictionary with: aTracer

	^ ((self mergeByteCodes: aDictionary) 
		collect: [:each | self ochiaiForByteCode: each from: aDictionary with: aTracer]) 
		sorted: [:a :b | a value first < b value first]! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:55:49.883'!
concernColors
	^ SProject current concerns colors! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:22:33.975'!
concernGroups
	^ SProject current concerns groups! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:25:05.84'!
concernMapping
	^ SProject current concerns mapping! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 5/14/2013 14:58:11.381'!
conditionButtonColor
	"If conditions are shown currently, highlight the buttons"
	| method |
	method := currentCompiledMethod.
	((method isKindOf: SContractWrapper) and: [Preferences decorateBrowserButtons])
		ifFalse: [^ Color gray].
	(self preconditionsShown or: [self postconditionsShown]) ifTrue: 
		[^ Color yellow muchLighter lighter].
	^ Color transparent
! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 17:01:03.416'!
contents
	"Depending on browser state display different source code"
	| source |
	self invariantsShown ifTrue: [
			source := (self selectedClassOrMetaClass organization invariantMethod
				getSourceFor: #invariants 
				in: (self selectedClassOrMetaClass))].
	
	[self postconditionsShown ifTrue: [
		source := (currentCompiledMethod afterMethod 
				getSourceFor: (currentCompiledMethod selector) 
				in: (self selectedClassOrMetaClass))].
	
	self preconditionsShown ifTrue: [
		source := (currentCompiledMethod beforeMethod 
				getSourceFor: (currentCompiledMethod selector) 
				in: (self selectedClassOrMetaClass))]] 
		on: Error do: ["After removing contracts browser inconsistency are possible"].
	
	source ifNotNil: [^ self editContentsWithDefault: 
		[source copy asText makeSelectorBoldIn: self selectedClassOrMetaClass]].
	^ super contents! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/14/2012 16:34:42.747'!
contents: input notifying: aController 
	"Provide a hook to save code of invariants"
	| aString methodNode |
	self invariantsShown ifFalse: [^ super contents: input notifying: aController].
	self selectedClassOrMetaClass organization invariantMethod ifNil: 
		[self error: 'Cannot create new method in invariant mode!!'].
	
	self changed: #annotation.
	aString := input asString.
	methodNode := self methodNodeFrom: aString notifying: nil.
	self selectedClassOrMetaClass organization invariantMethod: (methodNode method).
	^ true! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 5/12/2011 14:14:45.654'!
coverageList
	| coveredTests method |
	self refreshRequired ifFalse: [^ self cacheCoverage].
	method := self selectedMethodReference.
	method 
		ifNotNil: [coveredTests := self coveredTestsSortedFor: method.
				 self cacheCoverage: coveredTests].
	^ self cacheCoverage! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 3/28/2013 15:52:46.075'!
coverageListIndex: anInteger
	| testReference choice |
	anInteger <= 0 ifTrue: [^ self].
	testReference := self cacheCoverage at: anInteger.
	choice := testMode 
		ifNil: [(UIManager default 
				chooseFrom: {'PathFinder'. 'Debugger'. 'Browser'} 
				values: {#openPathFinderOn:. #openDebuggerOn:. #openBrowserOn:} 
				lines: #() 
				title: 'Choose tool')]
		ifNotNil: [testMode].		
	choice
		ifNotNil: [^ self perform: choice with: testReference asMethodReference].
	! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 3/21/2011 16:52:32.908'!
coveredTestsSortedFor: aMethodReference
	^ (SProject current coveredTestsFor: aMethodReference)
		asSortedCollection: [:a :b | a asMethodReference <= b asMethodReference]! !

!SBrowser methodsFor: 'start tools' stamp: 'tfel 7/7/2011 12:09:59.695'!
createPathView
	| project |
	project := SMultipleChoiceRequest
		prompt: 'Create a view in which project?'
		labels: SProject allProjectNames
		values: SProject allProjects.
	project ifNil: [^ self].
	SProject setCurrentProject: project.
	SPathView openOn: self selectedClass.
! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 17:46'!
currentSelectedMethod
	"Answer the value of currentSelectedMethod"

	^ currentSelectedMethod! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 17:46'!
currentSelectedMethod: anObject
	"Set the value of currentSelectedMethod"

	currentSelectedMethod := anObject! !

!SBrowser methodsFor: 'initialize-release' stamp: 'mp 3/7/2011 21:41:49.34'!
defaultBrowserTitle

	^ 'PathBrowser'! !

!SBrowser methodsFor: 'message functions' stamp: 'mp 5/14/2013 14:58:13.485'!
defineMessageFrom: aString notifying: aController
	"If contracts exist for the compiled method, store the code at the right place"
	| methodNode |
	currentCompiledMethod class = SContractWrapper ifFalse: 
		[^ super defineMessageFrom: aString notifying: aController].
	
	methodNode := self methodNodeFrom: aString notifying: aController.
	self preconditionsShown 
		ifTrue: [currentCompiledMethod beforeMethod: methodNode method]
		ifFalse: 
			[self postconditionsShown 
				ifTrue:  [currentCompiledMethod afterMethod: methodNode method.]
				ifFalse: [currentCompiledMethod clientMethod: methodNode method]].
	contents := aString copy.
	^ methodNode selector.! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 8/9/2013 14:10:24.98'!
exploreStatesFromTests
	| coveredTests stateSymbol result testcase tracer |
	self selectedClass ifNil: [^ self inform: 'Please select a class first.'].  
	(SProject current isClassInProject: self selectedClass theNonMetaClass)
		ifFalse: [^ self inform: 'Class is not in current Path project.'].
	coveredTests := SProject current coveredTestsForClass: self selectedClass.
	coveredTests ifEmpty: [^ self inform: 'No covering test found.'].
	stateSymbol := self askForStateOf: self selectedClass.
	tracer := (SStateViewTracer 
				onClass: self selectedClass instVarName: stateSymbol) 
					run.
	result := self chooseResult: tracer valuesAsSet.
	result ifNil: [^ nil].
	testcase := self chooseTestFrom: tracer valueDict and: result.
	testcase ifNil: [^ nil].
	SPathFinder openOn: testcase asMethodReference.! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:59:34.78'!
faultLocalizationAtStatements: aTracer
	| byteCodes |
	self flag: #mpe. "ToDo: Redundancy to SDebuggerCodePane (and following methods)"
	self selectedMethodReference ifNil: [^ self inform: 'Select a method first.'].
	byteCodes := self getCoveredByteCodes.
	byteCodes := self computeOchiaiFor: byteCodes with: aTracer.
	self highlightAnomaliesAtStatements: byteCodes.! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 18:26'!
filterProjectCategories
	"Answer the value of filterProjectCategories"

	^ filterProjectCategories ifNil: [filterProjectCategories := false]! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 18:26'!
filterProjectCategories: anObject
	"Set the value of filterProjectCategories"

	filterProjectCategories := anObject! !

!SBrowser methodsFor: 'class functions' stamp: 'mp 8/8/2013 16:25:50.075'!
getAllMethodColorsFor: aClassSymbol
	| methods |
	methods := self methodColors keys 
					select: [:each | each actualClass = (Smalltalk at: aClassSymbol)].
	methods ifEmpty: [^ {}].
	^ methods collect: [:each | self methodColors at: each]! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:48:58.792'!
getChildrenConcerns: anObject
	^ (self cacheConcerns at: anObject) asSortedCollection! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 5/2/2013 11:36:07.171'!
getCoveredByteCodes
	| wrapper |
	self flag: #mpe. "ToDo: Needs Refactoring - quite similar to SDebuggerCodePane"
	[wrapper := SMethodByteCodeCoverageForAllTestsWrapper 
					on: self selectedMethodReference.
	wrapper install.
	self coverageList
		do: [:each | wrapper currentTest: each.
				     each execute] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', 
			self coverageList size asString, ' Entry Points.']]
	ensure: [wrapper uninstall].
	^ wrapper coveredByteCodes
! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:48:11.743'!
hasChildrenConcerns: anObject
	^ self cacheConcerns includesKey: anObject! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:21:33.251'!
hasConditions
	^ (currentCompiledMethod isContractWrapper)! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 15:55:44.128'!
hasInvariants
	^ (self selectedClassOrMetaClass notNil and: 
		   [self selectedClassOrMetaClass organization invariantMethod notNil])! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 7/16/2013 11:19:33.05'!
highlightAnomaliesAtStatements: suspiciousByteCodes
	| method map stream range |
	method := self selectedMethodReference compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	suspiciousByteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each key.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each key contextIsActiveContext: true.
					self codePane text 
						addAttribute: (TextColor 
										color: (Color 
												h: 120 * (1.0 - each value first) 
												s: each value second
												v: 1.0)) 
						from: range first 
						to: range last;
						addAttribute: TextEmphasis underlined
						from: range first 
						to: range last]].
			self codePane selectAll; changed.! !

!SBrowser methodsFor: 'class functions' stamp: 'mp 8/8/2013 17:22:09.916'!
iconForClass: anInteger
	| klass icon colors |
	self methodColors ifNil: [^ nil].
	klass := self classList at: anInteger.
	klass ifNil: [^ nil].
	colors := self getAllMethodColorsFor: klass.
	colors ifEmpty: [^ nil].
	icon := Form extent: 15@15 depth: 32.
	icon fillColor: (SPMHighestColorStrategy forColors: colors).
	^ icon! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:56:03.104'!
iconForConcernItem: anObject
	| icon |
	(self concernColors includesKey: anObject)
		ifTrue: [
			icon := Form extent: 15@15 depth: 32.
			icon fillColor: (self concernColors at: anObject).
			^ icon].
	^ nil! !

!SBrowser methodsFor: 'message functions' stamp: 'mp 8/8/2013 14:23:53.466'!
iconForMessage: anInteger
	| icon reference |
	self methodColors ifNil: [^ nil].
	reference := MethodReference 
		class: self selectedClassOrMetaClass 
		selector: (self messageList at: anInteger ifAbsent: [nil]).
	reference ifNil: [^ nil].
	icon := Form extent: 15@15 depth: 32.
	icon fillColor: (self methodColors at: reference ifAbsent: [^ nil]).
	^ icon! !

!SBrowser methodsFor: 'controls' stamp: 'mp 7/16/2013 17:19:05.632'!
indicateClassMessages
	"If browser is toggled to class code, clear pane from any contract-source code"
	self codeSource: nil.
	^ super indicateClassMessages! !

!SBrowser methodsFor: 'controls' stamp: 'mp 7/16/2013 17:19:11.394'!
indicateInstanceMessages
	"If browser is toggled to instance code, clear pane from any contract-source code"
	self codeSource: nil.
	^ super indicateInstanceMessages! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 5/8/2013 14:55:57.312'!
instVarTypeLabelFor: aWord
	| index type |
	index := self selectedClassOrMetaClass allInstVarNames indexOf: aWord.
	index = 0
		ifFalse: [
			SProject current typesBucket ifNil: [^ 'Run type harvester first'].
			type := ((SProject current typesBucket 
						membersFor: self selectedClassOrMetaClass) at: index).
			type 
				ifNil: [^ 'No type available']
				ifNotNil: [^ type asString]].
	^ ''! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 7/16/2013 11:19:57.257'!
invariantsButtonColor
	"Highlight invariant button, if invariants are currently shown"
	(self selectedClassOrMetaClass isNil or: 
	[self selectedClassOrMetaClass organization invariantMethod isNil]) 
		ifTrue: [^ Color gray].
	self invariantsShown ifTrue: [^ Color yellow muchLighter lighter].
	^ Color transparent! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 15:58:26.193'!
invariantsShown
	^ self codeSource = #invariants or: [self editSelection = #editInvariants]! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:00:01.39'!
involvedConcerns
	| tests concerns projectConcerns |
	tests := self coveredTestsSortedFor: self selectedMethodReference.
	concerns := IdentityDictionary new. 
	tests 
		ifNotEmpty: [
			projectConcerns := SProject current concerns.
			projectConcerns groups keysDo: [:group |
				concerns at: group put: IdentitySet new.
				tests do: [:test | 
					concerns 
						at: group 
						put: ((concerns at: group),
							(projectConcerns 
								concernsOfGroup: group 
								andTest: test asMethodReference))]]].
		^ concerns! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 11:51:20.355'!
labelConcern: anObject

	^ anObject asString! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:26:20.1'!
mergeByteCodes: aDictionary
	^ aDictionary values inject: Set new into: [:set :each | set := set, each]! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/24/2011 17:16:12.377'!
messageCategoryListIndex: anInteger
	super messageCategoryListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each 
						getMethodCategoryMorph: self selectedClassOrMetaClass 
						and: self selectedMessageCategoryName)
							highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/14/2012 16:41:44.054'!
messageListIndex: anInteger
	| ref |
	super messageListIndex: anInteger.
	anInteger = 0 "Deselect"
		ifTrue: [self 
					currentSelectedMethod: nil;
					resetCaches].
	self selectedMessageName 
		ifNil: [
			(self cacheCoverage size = 0 and: [self cacheConcerns isEmpty]) 
				ifTrue: [^ self].
			self resetCaches]
		ifNotNil: [
			ref := MethodReference 
					class: self selectedClassOrMetaClass 
					selector: self selectedMessageName.
			(self currentSelectedMethod isNil or: 
				[(self currentSelectedMethod = ref) not])
					ifTrue: [self refreshAdditionalLists].
			self currentSelectedMethod: ref].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each 
						getMethodMorph: self selectedClassOrMetaClass 
						and: self selectedMessageName) highlight] on: Error do: []]].
	"Force refresh for pre- and postconditions to show up"
	((self preconditionsShown) or: [self postconditionsShown]) 
		ifTrue: [	self selectedMessage.
				self changed: #contents]! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 8/9/2013 11:05:26.295'!
messageListMenu: aMenu shifted: shifted 
	"Answer the message-list menu"
	self 
		menuHook: aMenu 
		named: #messageListMenu 
		shifted: shifted.
	Preferences useOnlyServicesInMenu ifTrue:[^aMenu].
	shifted ifTrue: [^ self shiftedMessageListMenu: aMenu].
	aMenu addList: #(
			('what to show...'			offerWhatToShowMenu)
			('toggle break on entry'		toggleBreakOnEntry)
			-
			('browse full (b)' 			browseMethodFull)
			('browse hierarchy (h)'			classHierarchy)
			('browse method (O)'			openSingleMessageBrowser)
			('browse protocol (p)'			browseFullProtocol)
			('browse path' 			browsePath)
			-
			('fileOut'					fileOutMessage)
			('printOut'					printOutMessage)
			('copy selector (c)'			copySelector)
			('copy reference (C)'		copyReference)
			-
			('senders of... (n)'			browseSendersOfMessages)
			('implementors of... (m)'		browseMessages)
			('inheritance (i)'			methodHierarchy)
			('versions (v)'				browseVersions)
			-
			('references... (r)'			browseVariableReferences)
			('assignments... (a)'			browseVariableAssignments)
			('class refs (N)'			browseClassRefs)
			-
			('remove method (x)'			removeMessage)
			('explore method'			exploreMethod)
			('inspect method'			inspectMethod)
			-
			('check spelling'		spellCheckMethod)
			-
			('more...'				shiftedYellowButtonActivity)).
	^ aMenu! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 8/8/2013 13:46:31.356'!
methodColors

	^ methodColors! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 8/8/2013 13:46:31.365'!
methodColors: anObject

	methodColors := anObject! !

!SBrowser methodsFor: 'message functions' stamp: 'mp 3/14/2012 16:43:58.946'!
methodNodeFrom: aString notifying: aController
	"Compile the string storing the source code"
	| methodNode |
	methodNode := (self selectedClassOrMetaClass 
		compile:  aString
		classified: self selectedMessageCategoryName
		notifying: aController
		trailer: Object defaultMethodTrailer
		ifFail: [^ nil]).
	methodNode == nil ifTrue: [^ nil].
	methodNode method putSource: aString fromParseNode: methodNode node inFile: 2
			withPreamble: [:f | f cr; nextPut: $!!; nextChunkPut: 'Contract method'; cr].
	^ methodNode! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 5/30/2013 14:10:22.671'!
methodTypesLabelFor: aWord
	| method temps index type |
	(SProject current allClasses includes: self selectedClassOrMetaClass instanceSide)
		ifTrue: [
			method := self selectedClassOrMetaClass >> self selectedMessageName.
			temps := method methodNode arguments.
			temps ifNotEmpty: [
				temps := temps collect: [:each | each name].
				index := temps indexOf: aWord.
				index = 0
					ifFalse: [SProject current typesBucket 
								ifNil: [^ 'Run type harvester first'].
						type := ((SProject current typesBucket 
									argumentsFor: method) at: index).
						type 
							ifNil: [^ 'No type available']
							ifNotNil: [^ type asString]]].
			(self selectedMessageName asString beginsWith: aWord)
				ifTrue: [SProject current typesBucket 
							ifNil: [^ 'Run type harvester first'].
					type := (SProject current typesBucket 
								returnFor: method).
					type 
						ifNil: [^ '^ No type available']
						ifNotNil: [^ '^ ', type asString]]].
	^ ''! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:03:13.299'!
methodsCoveredBy: aCollection
	| key |
	^ aCollection inject: Set new into: [:set :each | 
		key := SProject current coverage keys 
							detect: [:test | test asMethodReference = each] ifNone: [nil].
		key ifNotNil: [set addAll: (SProject current coverage at: key) keys].
		set yourself]! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 9/21/2011 13:58:24.593'!
ochiaiForByteCode: aByteCode from: aDictionary with: aTracer
	| coveredTests failuresAtByteCode passedAtByteCode allFailures suspiciousness confidence |
	allFailures := aTracer allFailures.
	coveredTests := aDictionary keys 
							select: [:test | (aDictionary at: test) includes: aByteCode].
	failuresAtByteCode := aTracer failuresFrom: coveredTests.		
	passedAtByteCode := coveredTests size - failuresAtByteCode.
	(allFailures = 0 or: [failuresAtByteCode = 0]) 
		ifTrue: [suspiciousness := 0.0. 
			     confidence := 1.0]
		ifFalse: [suspiciousness := (failuresAtByteCode / 
				((allFailures * (failuresAtByteCode + passedAtByteCode)) sqrt)). 
				confidence := (failuresAtByteCode / allFailures).].
	^ aByteCode -> {suspiciousness. confidence}! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 5/28/2013 17:00:13.633'!
openBrowserOn: chosenTest
	^ SBrowser 
		fullOnClass: chosenTest actualClass 
		selector: chosenTest methodSymbol
	! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:29:04.11'!
openDebuggerOn: aMethodReference
	| method |
	method := self selectedMethodReference.
	[SBreakpointManager 
		installInClass: method actualClass selector: method methodSymbol.
	aMethodReference actualClass run: aMethodReference methodSymbol] 
		ensure: [SBreakpointManager unInstall: method compiledMethod].! !

!SBrowser methodsFor: 'initialize-release' stamp: 'mp 3/14/2012 16:25:51.253'!
openEditString: aString
        "Create a pluggable version of all the views for a Browser, including views and controllers."
	"Example: 
		Browser fullOnClass: Browser.
	"
	| builder max |
	builder := ToolBuilder default.
	max := self wantsOptionalButtons ifTrue:[0.42] ifFalse:[0.5].
	^self buildWindowWith: builder specs: {
		(0@0 corner: 0.2@max) -> [self buildSystemCategoryListWith: builder].
		(0.2@0 corner: 0.4@(max-0.08)) -> [self buildClassListWith: builder].
		(0.2@(max-0.08) corner: 0.4@max) -> [self buildSwitchesWith: builder].
		(0.4@0 corner: 0.6@max) -> [self buildMessageCategoryListWith: builder].
		(0.6@0 corner: 0.8@(max-0.08)) -> [self buildMessageListWith: builder].
		(0.6@(max-0.08) corner: 0.8@max) -> [self buildContractSwitchesWith: builder].
		(0.8@0 corner: 1.0@max) -> [self buildTestCoverageListWith: builder].
		(0.8@0.5 corner: 1.0@1.0) -> [self buildConcernTreeWith: builder].
		(0@max corner: 1@0.5) -> [self buildOptionalButtonsWith: builder].
		(0@0.5 corner: 0.8@1) -> [self buildCodePaneWith: builder].
	}! !

!SBrowser methodsFor: 'start tools' stamp: 'mp 3/21/2011 16:25:17.585'!
openPathFinderOn: chosenTest

	^ SPathFinder openOn: chosenTest and: self selectedMethodReference! !

!SBrowser methodsFor: 'controls' stamp: 'tfel 7/8/2011 09:14:38.98'!
optionalButtonPairs
	^ super optionalButtonPairs asOrderedCollection
			addLast: #('coverage' statementCoverage
				'Compute statement coverage provided by tests covering this method');
			addLast: #('path views' browseWithPathView
				'open PathViews with this class');
			yourself! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:07:53.461'!
postconditionsShown
	^ self codeSource = #postconditions! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:08:08.661'!
preconditionsShown
	^ self codeSource = #preconditions! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 11:39'!
previousMethod
	"Answer the value of previousMethod"

	^ previousMethod! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2010 11:39'!
previousMethod: anObject
	"Set the value of previousMethod"

	previousMethod := anObject! !

!SBrowser methodsFor: 'updating' stamp: 'mp 3/23/2011 12:02:25.824'!
refreshAdditionalLists
	self 
		refreshRequired: true;
		changed: #coverageList;
		changed: #rootsConcerns;
		refreshRequired: false.! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 19:09'!
refreshRequired
	"Answer the value of refreshRequired"

	^ refreshRequired ifNil: [refreshRequired := false]! !

!SBrowser methodsFor: 'accessing' stamp: 'abc 5/10/2010 19:07'!
refreshRequired: anObject
	"Set the value of refreshRequired"

	refreshRequired := anObject! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/23/2011 11:28:21.757'!
resetCaches
	self 
		cacheCoverage: nil;
		cacheConcerns: nil;
		refreshAdditionalLists.! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:03:43.35'!
rootsConcerns
	(self refreshRequired and: [self selectedMethodReference notNil]) 
		ifTrue: [self cacheConcerns: self involvedConcerns].
	^ (self cacheConcerns keys 
		reject: [:each | (self cacheConcerns at: each) isEmpty]) asSortedCollection! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 7/7/2010 16:51:21.96'!
selectedCategories
	
	^ SProject current categories! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 1/4/2012 20:34:28.423'!
selectedClassInPartialTrace
	^ SProject current allClasses includes: self selectedClassOrMetaClass instanceSide! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 14:27:44.78'!
selectedConcernItem: anObject
	| tests group label |
	anObject ifNil: [^ self].
	group := self cacheConcerns includesKey: anObject.
	tests := group
				ifTrue: [self testsForConcerns: (self concernGroups at: anObject)]
				ifFalse: [self testsForConcerns: {anObject}].
	label := 'Methods of ', anObject asString, ' concern'.
	group ifTrue: [label := label, ' group'].
	SystemNavigation default
		browseMessageList: (self methodsCoveredBy: tests) asSortedCollection
		name: label
! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 5/12/2011 14:13:34.318'!
selectedMethodReference
	(self selectedClassOrMetaClass isNil or: [self selectedMessageName isNil])
		ifTrue: [^ nil].
	^ MethodReference 
		class: self selectedClassOrMetaClass selector: self selectedMessageName.! !

!SBrowser methodsFor: 'updating' stamp: 'mp 7/16/2013 11:20:21.48'!
setMethodRefAndRefreshSendersSelection: aMethodRef

	| previousRef |
	previousRef := self selectedMethodReference.
	self setClass: aMethodRef actualClass selector: aMethodRef methodSymbol.
	self setSelectionInSendersFrom: previousRef! !

!SBrowser methodsFor: 'updating' stamp: 'mp 5/12/2010 11:48'!
setSelectionInImplementorsFrom: aMethodReference

		self previousMethod: aMethodReference.
		self changed: #implementorsListIndex.
		self previousMethod: nil.
		self changed: #senderListIndex! !

!SBrowser methodsFor: 'updating' stamp: 'mp 5/12/2010 11:47'!
setSelectionInSendersFrom: aMethodReference

		self previousMethod: aMethodReference.
		self changed: #senderListIndex.
		self previousMethod: nil.
		self changed: #implementorsListIndex! !

!SBrowser methodsFor: 'coverage list' stamp: 'mp 5/2/2013 11:33:57.322'!
statementCoverage
	| byteCodes method map stream range |
	self flag: #mpe. "ToDo: Needs Refactoring - quite similar to 
						SCodePane>>#byteCodeCoverage"
	self selectedMethodReference ifNil: [^ self inform: 'Select a method first.'].
	byteCodes := self mergeByteCodes: self getCoveredByteCodes.
	method := self selectedMethodReference compiledMethod.
	map := (DebuggerMethodMap forMethod: method).
	byteCodes do: [:each | 
		stream := (InstructionStream on: method).
		stream pc: each.
		(stream willReallySend or: [stream willReturn])
			ifTrue: [range := map rangeForPC: each contextIsActiveContext: true.
					self codePane text
						addAttribute: TextEmphasis underlined
						from: range first 
						to: range last]].
	self codePane changed.! !

!SBrowser methodsFor: 'list reset' stamp: 'mp 3/14/2012 16:42:10.605'!
systemCategoryListIndex: anInteger 
	self codeSource: nil.
	super systemCategoryListIndex: anInteger.
	self selectedMethodReference ifNil: [self resetCaches].
	anInteger = 0
		ifFalse: [SPMPathMap allInstances do: [:each |
					[(each getCategoryMorph: self selectedSystemCategoryName)
						 highlight] on: Error do: []]].! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/28/2013 15:51:51.447'!
testMode
	"Answer the value of testMode"

	^ testMode! !

!SBrowser methodsFor: 'accessing' stamp: 'mp 3/28/2013 15:51:54.771'!
testMode: anObject
	"Set the value of testMode"

	testMode := anObject! !

!SBrowser methodsFor: 'concerns' stamp: 'mp 3/23/2011 12:53:32.926'!
testsForConcerns: aCollection
	| set |
	set := Set new.
	aCollection do: [:concern | 
		set addAll: (self concernMapping at: concern)].
	^ set! !

!SBrowser methodsFor: 'controls-inavariants' stamp: 'mp 3/14/2012 16:04:58.508'!
toggleInvariants
	"Toggle code pane between displaying invariants and regular class / instance code"
	self selectedClassOrMetaClass ifNil: [^ self].
	self codeSource: nil.
	((self editSelection = #editInvariants) or: 
	 [self selectedClassOrMetaClass organization invariantMethod isNil])
		ifTrue: [currentCompiledMethod := nil.
			"automatically sets editSelection to message"
			self messageCategoryListIndex: 0]
		ifFalse: [self metaClassIndicated 
			ifTrue:  
				[currentCompiledMethod := self selectedClassOrMetaClass class organization invariantMethod]
			ifFalse: 
				[currentCompiledMethod := self selectedClassOrMetaClass organization invariantMethod].
			self messageCategoryListIndex: 0;
				contentsSymbol: #source;
				editSelection: #editInvariants].
	self 
		changed: #classSelectionChanged;
		changed: #messageCategoryList;
		changed: #messageList;
		decorateButtons;
		contentsChanged! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:27:26.196'!
togglePostconditions
	"Toggle code pane between displaying postconditions and method source"
	((self codeSource = #postconditions) or: 
	[currentCompiledMethod isContractWrapper not]) 
		ifTrue: [self codeSource: nil]
		ifFalse: [self codeSource: #postconditions].

	contents := nil.
	self contentsChanged! !

!SBrowser methodsFor: 'controls-prepost' stamp: 'mp 3/14/2012 16:26:35.729'!
togglePreconditions
	"Toggle code pane between displaying preconditions and method source"
	((self codeSource = #preconditions) or: 
	[currentCompiledMethod isContractWrapper not])
		ifTrue: [self codeSource: nil]
		ifFalse: [self codeSource: #preconditions.].
	
	contents := nil.
	self contentsChanged! !

!SBrowser methodsFor: 'types harvester' stamp: 'mp 5/3/2011 16:07:31.034'!
update: aWord with: aTextMorph
	| label |	
	label := ''.
	self selectedClassOrMetaClass
		ifNotNil: [self selectedClassInPartialTrace
					ifTrue: [label := self selectedMessageName
										ifNil: [self instVarTypeLabelFor: aWord]
										ifNotNil: [self methodTypesLabelFor: aWord]]].
	aTextMorph labelMorph createLabelMorph: label.! !

TextMorphForEditView subclass: #STextMorphForEditView
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Morphic'!

!STextMorphForEditView class methodsFor: 'preferences' stamp: 'mp 3/10/2010 11:52'!
requiredSpaceForTwoCodeDigits

	^ Preferences standardCodeFont widthOfString: '00'! !

!STextMorphForEditView class methodsFor: 'constants' stamp: 'mp 3/10/2010 11:48'!
scaleFactorLeftMargin

	^ 1.5! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 12:48'!
drawLineNumber: aNumber on: aCanvas

	| str line |
	str := self getStringFor: aNumber.
	line := self paragraph lines at: aNumber.
	aCanvas
		drawString: str
		from: 1
		to: str size
		at: (self position x @ (line top + 2))
		font: Preferences standardCodeFont
		color: Color gray.! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 11:58'!
drawLineNumbersBorderOn: aCanvas

	| xOffset |
	xOffset := 4.
	aCanvas
		line: (self margins left - xOffset) @ aCanvas clipRect top
		to: (self margins left - xOffset) @ aCanvas clipRect bottom
		width: 1
		color: Color gray.! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 12:19'!
drawLineNumbersOn: aCanvas

	1 to: self paragraph numberOfLines do: [:lineNumber | 
		self drawLineNumber: lineNumber on: aCanvas].! !

!STextMorphForEditView methodsFor: 'drawing' stamp: 'mp 3/10/2010 14:37'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self
		drawLineNumbersBorderOn: aCanvas;
		drawLineNumbersOn: aCanvas.! !

!STextMorphForEditView methodsFor: 'private' stamp: 'mp 3/10/2010 12:08'!
getStringFor: aNumber

	| twoDigits |
	twoDigits := aNumber \\ 100.
	^ (twoDigits < 10 ifTrue: ['  '] ifFalse: ['']), twoDigits asString.! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:52:07.713'!
handlesMouseOver: anEvent
	^ true! !

!STextMorphForEditView methodsFor: 'initialization' stamp: 'mp 3/10/2010 11:50'!
initialize

	| leftOffset |
	super initialize.
	leftOffset := (self class requiredSpaceForTwoCodeDigits * self class scaleFactorLeftMargin) rounded.
	self margins: ((leftOffset@0) corner: 0@0).! !

!STextMorphForEditView methodsFor: 'accessing' stamp: 'mp 3/18/2011 21:38:23.288'!
labelMorph
	"Answer the value of labelMorph"

	^ labelMorph ifNil: [labelMorph := SLabelMorph label: '']! !

!STextMorphForEditView methodsFor: 'accessing' stamp: 'mp 3/18/2011 21:34:16.236'!
labelMorph: anObject
	"Set the value of labelMorph"

	labelMorph := anObject! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 7/16/2013 11:14:12.977'!
mouseLeave: event
	super mouseLeave: event.
	self removeMorph: self labelMorph.! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 7/16/2013 11:14:20.805'!
mouseMove: event
	| index word |
	super mouseMove: event.
	index := (self paragraph characterBlockAtPoint: event position) stringIndex.
	(self text notNil and: [index between: 1 and: self text size])
		ifTrue: [
			word := self wordAt: index.
			word isAllSeparators
				ifTrue: [self removeMorph: self labelMorph]
				ifFalse: [
					self changed: word with: self.
					(self labelMorph labelMorphs isEmpty or:
						[self labelMorph labelMorphs first contents = ''])
							ifTrue: [self removeMorph: self labelMorph]
							ifFalse: [self addMorph: self labelMorph.
									self labelMorph position: event position + self position]]].! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:33:08.326'!
trimWord: aString
	^ aString select: [:each | each isLetter or: [each isDigit]]! !

!STextMorphForEditView methodsFor: 'type labels' stamp: 'mp 3/18/2011 21:22:47.069'!
wordAt: anIndex
	| start stop |
	start := anIndex.
	stop := anIndex.
	[stop <= self text size and: [(self text at: stop) isSeparator not]]
		whileTrue: [stop := stop + 1].
	[start >= 1 and: [(self text at: start) isSeparator not]]
		whileTrue: [start := start - 1].
	^self trimWord: (self text copyFrom: start to: stop) asString ! !

Object subclass: #SConcernsRepository
	instanceVariableNames: 'groups colors mapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Projects'!

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.463'!
colors
	"Answer the value of colors"

	^ colors! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.466'!
colors: anObject
	"Set the value of colors"

	colors := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 15:06:58.411'!
concernsOfGroup: aGroupString andTest: aMethodRef
	^ ((self groups at: aGroupString) 
		select: [:each | (self mapping at: each ifAbsent: [#()]) includes: aMethodRef]) 		
			asSortedCollection! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:01:05.578'!
concernsOfTest: aMethodRef
	| concerns |
	concerns := IdentitySet new.
	self mapping keysAndValuesDo: [:key :value | 
		(value includes: aMethodRef) ifTrue: [concerns add: key]].
	^ concerns! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:12:42.325'!
groupOfConcern: concern
	self groups keysAndValuesDo: [:key :value | 
		(value detect: [:each | each == concern] ifNone: [nil])
			ifNotNil: [^ key]].! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.454'!
groups
	"Answer the value of groups"

	^ groups! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:22:30.459'!
groups: anObject
	"Set the value of groups"

	groups := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 15:05:04.788'!
groupsOfConcerns: aCollection
	| groups |
	groups := IdentitySet new.
	aCollection do: [:concern | groups add: (self groupOfConcern: concern)].
	^ groups asSortedCollection! !

!SConcernsRepository methodsFor: 'initialize-release' stamp: 'mp 9/2/2010 10:01:46.174'!
initialize
	self groups: IdentityDictionary new.
	self mapping: IdentityDictionary new.
	self colors: IdentityDictionary new.! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/2/2010 10:05:01.002'!
mapping
	"Answer the value of mappings"

	^ mapping ifNil: [mapping := IdentityDictionary new]! !

!SConcernsRepository methodsFor: 'accessing' stamp: 'mp 9/2/2010 10:01:36.495'!
mapping: anObject
	"Set the value of mappings"

	mapping := anObject! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 16:56:34.549'!
mappingExisting: aConcern and: aMethodRef
	(self mapping includesKey: aConcern) ifFalse: [^ false].
	^ (self mapping at: aConcern) includes: aMethodRef! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 13:34:52.482'!
testClassesOfConcern: aConcern
	| testClasses map |
	testClasses := IdentitySet new.
	map := self mapping at: aConcern.
	map do: [:each | testClasses add: each actualClass].
	^ testClasses asSortedCollection: [:a :b | a asString <= b asString]! !

!SConcernsRepository methodsFor: 'public api' stamp: 'mp 9/2/2010 14:56:18.818'!
testSelectorsOfClass: aClass andConcern: aConcern
	^ ((self mapping at: aConcern) 
		select: [:each | each actualClass == aClass] 
		thenCollect: [:each | each methodSymbol]) asSortedCollection! !

Object subclass: #SDefinitionModel
	instanceVariableNames: 'defClass defSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

!SDefinitionModel methodsFor: '-- all --' stamp: 'mp 1/25/2010 17:10'!
aboutToStyle: aStyler

	aStyler classOrMetaClass: self classOrMetaClass.
	^ true! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
classOrMetaClass

	(self defClass notNil and: [self defSelector notNil]) 
		ifTrue: [^ self defClass].
	^ nil! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'pt 6/6/2012 14:15:42.83'!
compileMethod: newSource

	^ defClass compile: newSource classified: (
		defClass organization categoryOfElement: defSelector).
! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
contents

	| sourceString |
	self defClass ifNil: [^ ''].
	self defSelector ifNil: [^ self defClass definition].
	sourceString := self defClass sourceCodeAt: self defSelector ifAbsent: [^'error'].
	^ sourceString copy asText! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'pt 6/6/2012 14:18:55.095'!
contents: newSource
	| newSelector | 
	newSelector := self compileMethod: newSource.
	newSelector ifNil: [^ false]. 
	
	^ true! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defClass
	^ defClass! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defClass: anObject
	defClass := anObject! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defSelector
	^ defSelector! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
defSelector: anObject
	defSelector := anObject! !

!SDefinitionModel methodsFor: 'accessing' stamp: 'mp 1/4/2010 14:21'!
setClass: aClass andSelector: aSelector

	^ self 
		defClass: aClass;
		defSelector: aSelector;
		changed: #contents;
		yourself! !

Object subclass: #SEntryPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!SEntryPoint methodsFor: 'execution' stamp: 'mp 7/12/2010 13:24:46.524'!
execute

	self subclassResponsibility.! !

!SEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:26:36.151'!
isCode

	^ false! !

!SEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:26:42.525'!
isTestCase

	^ false! !

!SEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:26:45.826'!
isUserStory

	^ false! !

SEntryPoint subclass: #SSourceCodeEntryPoint
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!SSourceCodeEntryPoint class methodsFor: 'instance creation' stamp: 'mp 7/12/2010 13:25:55.81'!
onCode: aString

	^ self new
		code: aString;
		yourself.! !

!SSourceCodeEntryPoint methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:26:15.125'!
code
	"Answer the value of code"

	^ code! !

!SSourceCodeEntryPoint methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:26:15.13'!
code: anObject
	"Set the value of code"

	code := anObject! !

!SSourceCodeEntryPoint methodsFor: 'execution' stamp: 'mp 7/12/2010 13:26:56.369'!
execute
	^ Compiler evaluate: self code! !

!SSourceCodeEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:27:30.903'!
isCode

	^ true! !

!SSourceCodeEntryPoint methodsFor: 'printing' stamp: 'mp 7/12/2010 14:16:05.892'!
printString

	^ 'Source code entry point'! !

SEntryPoint subclass: #STestCaseEntryPoint
	instanceVariableNames: 'testClass selector lastResult withoutTimeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/17/2010 12:43:32.121'!
class: aClass selector: aSelector
	^ self new
		testClass: aClass;
		selector: aSelector;
		yourself! !

!STestCaseEntryPoint class methodsFor: 'converting' stamp: 'mp 4/4/2011 17:12:55.425'!
convertTestSuite: aTestSuite

	^ aTestSuite tests collect: [ :each | 
		STestCaseEntryPoint class: each class selector: each selector ]! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/17/2010 12:42:12.429'!
onTestCase: aTestCase

	^ self class: aTestCase class selector: aTestCase selector! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/20/2010 14:52:04.177'!
onTestMethodReference: aMethodReference

	^ self class: aMethodReference actualClass selector: aMethodReference methodSymbol! !

!STestCaseEntryPoint class methodsFor: 'instance creation' stamp: 'bs 7/20/2010 14:52:07.313'!
testMethod: aCompiledMethod

	^ self class: aCompiledMethod methodClass selector: aCompiledMethod selector! !

!STestCaseEntryPoint methodsFor: 'comparing' stamp: 'mp 7/14/2010 09:29:14.346'!
= other
	self class == other class
		ifFalse: [^ false].
	^ self asMethodReference = other asMethodReference! !

!STestCaseEntryPoint methodsFor: 'converting' stamp: 'tfel 7/8/2011 09:42:46.062'!
asCompiledMethod

	^ self asMethodReference compiledMethod! !

!STestCaseEntryPoint methodsFor: 'converting' stamp: 'bs 7/20/2010 14:54:47.724'!
asMethodReference

	^ MethodReference class: self testClass selector: self selector! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 12/8/2011 13:33:08.421'!
compiledMethod
	^ (self testClass whichClassIncludesSelector: self selector) >> self selector! !

!STestCaseEntryPoint methodsFor: 'execution' stamp: 'mp 6/26/2011 18:51:15.326'!
debug
	(self testClass selector: self selector) debug! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 5/9/2011 09:53:02.273'!
disableTimeout
	self withoutTimeout: true.! !

!STestCaseEntryPoint methodsFor: 'execution' stamp: 'mp 4/19/2013 10:44:29.229'!
execute
	| createdTestResources | 
	createdTestResources := OrderedCollection new.
	self testClass resources do: [ :each |
		each isInitialized
			ifFalse: [each isAvailable ifFalse: [each signalInitializationError].
					createdTestResources add: each]].
	[self withoutTimeout
		ifTrue: [	self lastResult: (self testClass selector: self selector)
					runWithoutTimeout]
		ifFalse: [self lastResult: (self testClass selector: self selector) run]] 
			ensure: [createdTestResources do: [:each | each reset]].
	^ self lastResult! !

!STestCaseEntryPoint methodsFor: 'comparing' stamp: 'mp 7/14/2010 09:28:50.007'!
hash

	^ self asMethodReference hash! !

!STestCaseEntryPoint methodsFor: 'testing' stamp: 'mp 9/29/2010 13:49:43.777'!
isInheritedTest
	^ (self testClass testSelectors includes: self selector) not! !

!STestCaseEntryPoint methodsFor: 'testing' stamp: 'mp 4/1/2011 13:27:47.667'!
isTestCase

	^ true! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:52:00.283'!
lastResult
	"Answer the value of lastResult"

	^ lastResult! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 7/13/2010 14:52:00.287'!
lastResult: anObject
	"Set the value of lastResult"

	lastResult := anObject! !

!STestCaseEntryPoint methodsFor: 'printing' stamp: 'mp 9/29/2010 13:48:34.75'!
printString
	self isInheritedTest 
		ifTrue: [^ self testClass asString, ' >> ', self selector asString, ' (inherited)'].
	^ (self testClass >> self selector) qualifiedName! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:02.943'!
selector
	^ selector! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:02.95'!
selector: anObject
	selector := anObject! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:18.191'!
testClass
	^ testClass! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'bs 7/17/2010 12:38:18.197'!
testClass: anObject
	testClass := anObject! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 5/9/2011 09:53:19.674'!
withoutTimeout
	"Answer the value of withoutTimeout"

	^ withoutTimeout ifNil: [withoutTimeout := false]! !

!STestCaseEntryPoint methodsFor: 'accessing' stamp: 'mp 5/9/2011 09:52:39.289'!
withoutTimeout: anObject
	"Set the value of withoutTimeout"

	withoutTimeout := anObject! !

Object subclass: #SNullWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

!SNullWrapper commentStamp: 'mp 7/13/2010 16:10:38.579' prior: 0!
A SNullWrapper is a null object that is required if you want to use the tracer without tracing (execute entry points only).

Instance Variables
!

!SNullWrapper class methodsFor: 'instance creation' stamp: 'mp 7/13/2010 16:06:23.225'!
on: aSymbol inClass: aClass with: aTracer

	^ self new! !

!SNullWrapper methodsFor: 'installation' stamp: 'mp 7/13/2010 16:07:31.93'!
install! !

!SNullWrapper methodsFor: 'installation' stamp: 'mp 7/13/2010 16:07:43.356'!
uninstall! !

Object subclass: #SProject
	instanceVariableNames: 'projectName categories classesCache concerns coverage harvestedBuckets hasContracts'
	classVariableNames: 'CurrentProject ProjectRegistry'
	poolDictionaries: ''
	category: 'Path-Core-Projects'!

!SProject class methodsFor: 'class initialization' stamp: 'mp 3/20/2013 13:01:29.512'!
addPredefinedProjects
	self 
		addProject: self nullProject;
		addProject: self monticelloProject;
		addProject: self sunitProject;
		addProject: self systemBrowserProject;
		addProject: self sandboxProject;
		addProject: self observerExampleProject;
		addProject: self pathProjects.! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:20'!
addProject: aProject

	self projectAt: aProject projectName put: aProject.! !

!SProject class methodsFor: 'system events' stamp: 'mp 3/8/2011 20:14:22.804'!
addSystemChangeNotifierForAddedClasses
	"self addSystemChangeNotifierForAddedClasses"
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofEvents: {'classAddedEvent:'. 'classModifiedEvent:'. 'classRecategorizedEvent:'. 'classRemovedEvent:'. 'classRenamedEvent:'. 'classReorganizedEvent:'. 'classModifiedEvent:'. 'classModifiedEvent:'} 
		using: #systemClassChanged:
	! !

!SProject class methodsFor: 'system events' stamp: 'mp 1/1/2012 15:48:01.58'!
addSystemChangeNotifierForSourceCodeChanges
	"self addSystemChangeNotifierForSourceCodeChanges"
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofEvents: SystemChangeNotifier uniqueInstance allSystemEvents
		using: #sourceCodeChanged:
	! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:04'!
allProjectNames

	^ ProjectRegistry keys! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:04'!
allProjects

	^ ProjectRegistry values! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 09:27:21.988'!
allProjectsWithoutNull

	^ ProjectRegistry values select: [:each | (each projectName == #null) not]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 18:28'!
current

	^ CurrentProject! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 4/29/2013 11:24:39.372'!
harvesterSandboxProject

	^ self 
		name: #harvesterSandbox 
		categories: #(#'Path-Tests-Harvester-Sandbox')! !

!SProject class methodsFor: 'class initialization' stamp: 'mp 3/25/2013 15:27:04.155'!
initialize
	"self initialize"
	super initialize.
	self
		reset;
		addPredefinedProjects;
		addSystemChangeNotifierForAddedClasses;
		addSystemChangeNotifierForSourceCodeChanges;
		setNullProjectAsCurrent.! !

!SProject class methodsFor: 'testing' stamp: 'mp 3/7/2012 09:42:03.341'!
isNullProjectSelected
	^ SProject current projectName = SProject nullProject projectName! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:10'!
monticelloProject

	^ self 
		name: #monticello 
		categories: #(#'Monticello-Base' #'Monticello-Chunk Format' #'Monticello-Loading' #'Monticello-Merging' #'Monticello-Modeling' #'Monticello-Patching' #'Monticello-Repositories' #'Monticello-Storing' #'Monticello-UI' #'Monticello-Versioning' #'Tests-Monticello' #'Tests-Monticello-Mocks')! !

!SProject class methodsFor: 'instance creation' stamp: 'mp 6/11/2010 15:07'!
name: aSymbol categories: aCollection

	^ self new
		projectName: aSymbol;
		categories: aCollection;
		yourself! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 7/7/2010 09:11:08.894'!
nullProject

	^ self 
		name: #null
		categories: #()! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 3/22/2013 11:33:34.369'!
observerExampleProject

	^ self 
		name: #observerExample
		categories: #(#'Path-Dev-Example-Observer' 					#'Path-Dev-Example-Observer-Tests')! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 8/7/2013 14:55:31.402'!
pathProjects

	^ self 
		name: #path
		categories:  #(
		#'Path-Contracts-Builder' 
		#'Path-Contracts-Core' 
		#'Path-Contracts-Exceptions' 
		#'Path-Contracts-Kernel' 
		"------------------------------------"
		#'Path-Core-Models' 
		#'Path-Core-Morphic' 
		#'Path-Core-Projects' 
		#'Path-Core-Specs' 
		#'Path-Core-Tools' 
		#'Path-Core-Tools-Browser' 
		#'Path-Core-Tools-Finder' 
		#'Path-Core-Tools-Map' 
		#'Path-Core-Tools-Projects' 
		#'Path-Core-Tracer' 
		"------------------------------------"
		#'Path-Finder-CallTree' 
		#'Path-Finder-Debugger' 
		#'Path-Finder-TestChooser' 
		#'Path-Finder-Tracer' 
		"------------------------------------"
		#'Path-Harvester' 
		#'Path-Harvester-Types' 
		#'Path-Harvester-ValueRanges' 
		"------------------------------------"
		#'Path-Map-Base' 
		#'Path-Map-Coloring' 
		#'Path-Map-Metrics' 
		#'Path-Map-Morphic' 
		#'Path-Map-Options' 
		#'Path-Map-Tracer' 
		#'Path-Map-Wrapper' 
		"------------------------------------"		
		#'Path-Tests-CallTree' 
		#'Path-Tests-Contracts' 
		#'Path-Tests-Harvester' 
		#'Path-Tests-Harvester-Sandbox' 
		#'Path-Tests-Harvester-Types' 
		#'Path-Tests-Harvester-ValueRanges' 
		#'Path-Tests-Idioms' 
		#'Path-Tests-MethodWrappers' 
		#'Path-Tests-PathBrowser-Core' 
		#'Path-Tests-PathBrowser-Contracts'
		#'Path-Tests-PathBrowser-Coverage'
		#'Path-Tests-PathFinder' 
		#'Path-Tests-PathMap' 
		#'Path-Tests-Projects' 
		#'Path-Tests-Resources' 
		#'Path-Tests-Tracer')! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:14'!
projectAt: aSymbol

	^ self projectRegistry
		at: aSymbol ifAbsent: [nil]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:14'!
projectAt: aSymbol put: aProject

	^ self projectRegistry 
		at: aSymbol 
		put: aProject! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:13'!
projectRegistry

	^ ProjectRegistry ifNil: [ProjectRegistry := Dictionary new]! !

!SProject class methodsFor: 'projects' stamp: 'mp 6/11/2010 15:24'!
projectRegistry: aProjectRegistry
	"Mostly required for testing purposes"
	ProjectRegistry := aProjectRegistry.! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 12:01:56.049'!
removeProjectAt: aSymbol

	CurrentProject == (self projectAt: aSymbol)
		ifTrue: [CurrentProject := self projectAt: #null].
	^ self projectRegistry
		removeKey: aSymbol! !

!SProject class methodsFor: 'class initialization' stamp: 'mp 6/11/2010 18:31'!
reset
	
	ProjectRegistry := nil.
	CurrentProject := nil.! !

!SProject class methodsFor: 'predefined projects' stamp: 'tfel 3/6/2012 15:23:40.278'!
sandboxProject

	^ self 
		name: #sandbox 
		categories: #(#'Path-Tests-Sandbox')! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/12/2013 10:26:37.269'!
setCurrent: aSymbol
	self setCurrentProject: (self projectAt: aSymbol).! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/12/2013 13:29:07.292'!
setCurrentProject: aProject
	CurrentProject := aProject.
	CurrentProject ifNotNil: [CurrentProject resetClassesCache].
	SwaTestExceptionRegistry reset.! !

!SProject class methodsFor: 'projects' stamp: 'mp 7/7/2010 09:18:13.796'!
setNullProjectAsCurrent

	self setCurrent: #null.! !

!SProject class methodsFor: 'system events' stamp: 'mp 1/1/2012 15:58:39.811'!
sourceCodeChanged: anEvent
	self allProjects do: [:each | each changed: anEvent].! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:11'!
sunitProject

	^ self 
		name: #sunit 
		categories: #(#'SUnit-Extensions' #'SUnit-Kernel' #'SUnit-Tests')! !

!SProject class methodsFor: 'predefined projects' stamp: 'mp 6/11/2010 15:12'!
systemBrowserProject

	^ self 
		name: #systemBrowser 
		categories: #(#'ToolBuilder-Kernel' #'ToolBuilder-Morphic' #'Tools-Base' #'Tools-Browser' #'ToolsTests-Browser')! !

!SProject class methodsFor: 'system events' stamp: 'mp 3/8/2011 20:28:34.845'!
systemClassChanged: anEvent
	self current resetClassesCache.! !

!SProject methodsFor: 'classes' stamp: 'mp 1/2/2012 13:56:13.098'!
allClasses

	^ classesCache ifNil: [classesCache := (Smalltalk allClasses select: [:each | 
										self categories includes: each category]) asArray].! !

!SProject methodsFor: 'classes' stamp: 'mp 11/29/2012 15:08:43.508'!
allClassesWithoutTests
	^ self allClasses reject: [:each | each inheritsFrom: TestCase]! !

!SProject methodsFor: 'classes' stamp: 'mp 8/9/2013 11:42:13.538'!
allMethodReferencesOf: aClass
	^ (aClass selectors 
		collect: [:each | MethodReference class: aClass selector: each]),
	 (aClass class selectors 
		collect: [:each | MethodReference class: aClass class selector: each])! !

!SProject methodsFor: 'methods' stamp: 'mp 3/20/2013 11:20:19.289'!
allMethods
	^ self allClasses inject: OrderedCollection new into: [:collection :klass | 
		klass methodDict keys 	do: [:selector | 
				collection add: (MethodReference class: klass selector: selector)].
		klass class methodDict keys do: [:selector | 
			collection add: (MethodReference class: klass class selector: selector)].
		collection]! !

!SProject methodsFor: 'methods' stamp: 'mp 3/24/2011 10:55:27.37'!
allTests
	| tests |
	tests := OrderedCollection new.
	self testClasses do: [:testClass | 
		testClass isAbstract 
			ifFalse: [testClass inheritedTestSelectors 
						do: [:selector | tests add: (MethodReference 
													class: testClass selector: selector)]]].
	^ tests! !

!SProject methodsFor: 'methods' stamp: 'mp 1/24/2011 17:07:40.738'!
allTestsAsEntryPoints
	^ self allTests collect: [:each | STestCaseEntryPoint onTestMethodReference: each]! !

!SProject methodsFor: 'methods' stamp: 'mp 6/23/2010 16:49'!
allTestsWithoutLongRunning
	^ self allTests reject: [:each | each actualClass inheritsFrom: LongTestCase]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:52'!
categories
	"Answer the value of categories"

	^ categories ifNil: [categories := #()]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
categories: anObject
	"Set the value of categories"

	categories := anObject! !

!SProject methodsFor: 'categories' stamp: 'mp 6/11/2010 16:43'!
categoriesOrderedByTestsFirst
	| testCategories allOtherCategories |
	testCategories := self categoriesWithTests asSortedCollection asOrderedCollection.
	allOtherCategories := self categories asSortedCollection asOrderedCollection
					 reject: [:each | testCategories includes: each].
	^ (testCategories, allOtherCategories) asArray! !

!SProject methodsFor: 'categories' stamp: 'mp 6/11/2010 16:43'!
categoriesWithTests

	^ (self testClasses inject: Set new into: [:sum :each | 
		sum 
			add: each category; 
			yourself]) asArray! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.676'!
classesCache
	"Answer the value of classesCache"

	^ classesCache! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.681'!
classesCache: anObject
	"Set the value of classesCache"

	classesCache := anObject! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:53'!
classesOfCategory: aCategory

	^ self allClasses select: [:each | each category = aCategory]! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:21:43.434'!
concerns
	"Answer the value of concerns"

	^ concerns ifNil: [concerns := SConcernsRepository new]! !

!SProject methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:20:18.688'!
concerns: anObject
	"Set the value of concerns"

	concerns := anObject! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/21/2011 14:40:04.827'!
coverage
	"Answer the value of coverage"

	^ coverage ifNil: [coverage := Dictionary new]! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/21/2011 14:39:49.332'!
coverage: anObject
	"Set the value of coverage"

	coverage := anObject! !

!SProject methodsFor: 'coverage' stamp: 'mp 5/12/2011 14:20:23.837'!
coveredTestsFor: aMethodReference
	| coveringTests |
	(self isClassInProject: (Smalltalk at: aMethodReference classSymbol))
		ifTrue: [
				coveringTests := Set new.
				self coverage keysAndValuesDo: [:test :coveredMethods |
					(coveredMethods includesKey: aMethodReference)
						ifTrue: [coveringTests add: test]].
				^ coveringTests asOrderedCollection]
		ifFalse: [^ {}].! !

!SProject methodsFor: 'coverage' stamp: 'mp 8/9/2013 11:44:34.811'!
coveredTestsForClass: aClass
	| methodReferences coveringTests |
	(self isClassInProject: aClass)
		ifTrue: [
				methodReferences := self allMethodReferencesOf: aClass.
				coveringTests := Set new.
				methodReferences do: [:each | 
					coveringTests := coveringTests, (self coveredTestsFor: each)].
				^ coveringTests asOrderedCollection]
		ifFalse: [^ {}].! !

!SProject methodsFor: 'buckets' stamp: 'mp 1/31/2012 13:56:52.435'!
harvestedBuckets
	"Answer the value of harvestedBuckets"

	^ harvestedBuckets ifNil: [harvestedBuckets := Dictionary new]! !

!SProject methodsFor: 'buckets' stamp: 'mp 1/31/2012 13:56:32.082'!
harvestedBuckets: anObject
	"Set the value of harvestedBuckets"

	harvestedBuckets := anObject! !

!SProject methodsFor: 'testing' stamp: 'mp 6/1/2011 13:42:28.081'!
hasConcernsDefined
	^ self concerns groups notEmpty! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/14/2012 17:31:41.981'!
hasContracts
	"Answer the value of hasContracts"

	^ hasContracts ifNil: [hasContracts := false]! !

!SProject methodsFor: 'accessing' stamp: 'mp 3/14/2012 17:31:10.987'!
hasContracts: anObject
	"Set the value of hasContracts"

	hasContracts := anObject! !

!SProject methodsFor: 'testing' stamp: 'mp 4/25/2013 15:40:04.813'!
includesTests
	^ self testClasses notEmpty! !

!SProject methodsFor: 'testing' stamp: 'mp 3/21/2011 15:13:35.189'!
isClassInProject: aClass
	^ self allClasses includes: aClass! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 14:47:08.576'!
linesOfCode
	^ self allClasses inject: 0 into: [:sum :each | sum + each linesOfCode]! !

!SProject methodsFor: 'method categories' stamp: 'mp 5/10/2013 17:04:43.571'!
methodCategories: aClass withQuick: aBoolean
	| categories |
	categories := #().
	aClass organization elementArray ifNotEmpty: [
		categories := (aClass organization categories select: [:each | 
							(aClass organization isEmptyCategoryNamed: each) not]).
	aBoolean 
		ifFalse: [categories := categories 
						select: [:each | (aClass organization listAtCategoryNamed: each)
							anySatisfy: [:symbol | | method |
								method := (aClass >> symbol).
								method isQuick not and: [method isAbstract not]]]]].
	aClass isMeta
		ifTrue: [categories := categories collect: [:each | (each, ' (class)') asSymbol]].					
	^ categories! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:08:56.934'!
methodCategoriesOfClass: aClass
	^ self methodCategoriesOfClass: aClass withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 14:34:13.497'!
methodCategoriesOfClass: aClass withQuick: aBoolean
	^ (self methodCategories: aClass withQuick: aBoolean), 
		(self methodCategories: aClass class withQuick: aBoolean)! !

!SProject methodsFor: 'classes' stamp: 'mp 9/28/2010 19:20:29.26'!
methodsPerClass: aClass 
	^ self methodsPerClass: aClass withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 9/28/2010 13:52:52.311'!
methodsPerClass: aClass andMethodCategory: aCategory
	^ self methodsPerClass: aClass andMethodCategory: aCategory withQuick: true! !

!SProject methodsFor: 'method categories' stamp: 'mp 5/21/2013 16:50:16.816'!
methodsPerClass: aClass andMethodCategory: aCategory withQuick: aBoolean
	| categoryName symbols |
	(aCategory includesSubString: ' (class)')
		ifTrue: [
			"without  (class)"
			categoryName := (aCategory copyFrom: 1 to: aCategory size - 8) asSymbol. 
			symbols := aClass class organization listAtCategoryNamed: categoryName.
			aBoolean 
				ifFalse: [^ symbols select: [:each | | method |
								method := (aClass class >> each).
								method isQuick not and: [method isAbstract not]]]]
		ifFalse: [symbols := aClass organization listAtCategoryNamed: aCategory.
			aBoolean 
				ifFalse: [^ symbols select: [:each | | method |
								method := (aClass >> each).
								method isQuick not and: [method isAbstract not]]]].
		^ symbols! !

!SProject methodsFor: 'classes' stamp: 'mp 5/10/2013 17:01:49.989'!
methodsPerClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [^ (aClass methodDict keys 
							select: [:each | | method |
								method := (aClass >> each).
								method isQuick not and: [method isAbstract not]])
									sorted].
	^ aClass methodDict keys sorted! !

!SProject methodsFor: 'printing' stamp: 'mp 7/16/2013 14:52:39.736'!
metricsOverviewString
	| result |
	result := ''.
	^ UIManager default
		displayProgress: 'Computing project metrics' 
		at: World center 
		from: 0 to: 3 
		during: [:progress |
			result := result, self numberOfPackages asString, ' Categories, '.
			progress value: 1.
			result := result, self numberOfClasses asString, ' Classes, and '.
			progress value: 2.
			result := result, self numberOfMethods asString, 
				' Methods (', self linesOfCode asString, ' LoC)'.
			progress value: 3.
			result].! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 14:48:30.996'!
numberOfClasses
	^ self allClasses size! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 14:56:00.532'!
numberOfMethods
	^ self categories 
		inject: 0 
		into: [:sum :each | sum := sum + (self numberOfMethodsOfCategory: each)]! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 14:57:31.232'!
numberOfMethodsOfCategory: aCategory

	^ self numberOfMethodsOfCategory: aCategory withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 15:01:28.673'!
numberOfMethodsOfCategory: aCategory withQuick: aBoolean

	^ (self classesOfCategory: aCategory) 
		inject: 0 
		into: [:sum :each | 
			sum := sum + (self numberOfMethodsOfClass: each withQuick: aBoolean)].! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 15:01:32.843'!
numberOfMethodsOfClass: aClass
	^ self numberOfMethodsOfClass: aClass withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 14:59:55.021'!
numberOfMethodsOfClass: aClass methodCategory: aCategory

	^ self numberOfMethodsOfClass: aClass methodCategory: aCategory withQuick: true! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 14:59:38.543'!
numberOfMethodsOfClass: aClass methodCategory: aCategory withQuick: aBoolean

	^ (self 
		methodsPerClass: aClass 
		andMethodCategory: aCategory 
		withQuick: aBoolean) size! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 15:01:00.977'!
numberOfMethodsOfClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [
		^ (aClass methodDict keys select: [:each | | method |
								method := (aClass >> each).
								method isQuick not and: [method isAbstract not]]) size +
	(aClass class methodDict keys select: [:each | | method |
								method := (aClass class >> each).
								method isQuick not and: [method isAbstract not]]) size].
	^ aClass methodDict size + aClass class methodDict size! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 15:02:17.108'!
numberOfMethodsOfOneSideClass: aClass withQuick: aBoolean
	aBoolean ifFalse: [^ (aClass methodDict keys 
							select: [:each | | method |
								method := (aClass >> each).
								method isQuick not and: [method isAbstract not]]) size].
	^ aClass methodDict size! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 15:03:40.699'!
numberOfMethodsWithoutLowComplexity
	"Number of Methods with a complexity > 1"
	^ (self allMethods select: [:each | each compiledMethod complexity > 1]) size! !

!SProject methodsFor: 'metrics' stamp: 'mp 7/16/2013 14:52:31.126'!
numberOfPackages
	"Here: Categories"
	^ self categories size! !

!SProject methodsFor: 'printing' stamp: 'mp 1/31/2012 14:21:21.78'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' <', self projectName, '>'.! !

!SProject methodsFor: 'printing' stamp: 'mp 1/31/2012 14:21:58.285'!
printString

	^ self == SProject current
		ifTrue: [self projectName, ' <current>']
		ifFalse: [self projectName]! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
projectName
	"Answer the value of projectName"

	^ projectName! !

!SProject methodsFor: 'accessing' stamp: 'mp 6/11/2010 15:06'!
projectName: anObject
	"Set the value of projectName"

	projectName := anObject! !

!SProject methodsFor: 'classes' stamp: 'mp 1/2/2012 14:04:35.215'!
removeFromClassesCache: aClass
	classesCache := self allClasses reject: [:each | each = aClass].! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:56'!
resetClassesCache

	classesCache := nil.! !

!SProject methodsFor: 'classes' stamp: 'mp 1/2/2012 13:54:33.425'!
testClasses
	^ self allClasses select: [:each | each inheritsFrom: TestCase]! !

!SProject methodsFor: 'classes' stamp: 'mp 6/11/2010 15:53'!
testClassesOfCategory: aCategory

	^ self testClasses select: [:each | each category = aCategory]! !

!SProject methodsFor: 'buckets' stamp: 'mp 5/2/2013 13:59:01.265'!
typesBucket
	"Answer the value of typesBucket"

	^ self harvestedBuckets 
		at: STypeHarvester asString asSymbol
		ifAbsent: [nil]! !

!SProject methodsFor: 'buckets' stamp: 'mp 5/2/2013 13:59:17.307'!
typesBucket: aTypeBucket

	^ self harvestedBuckets 
		at: STypeHarvester asString asSymbol
		put: aTypeBucket! !

!SProject methodsFor: 'buckets' stamp: 'mp 2/9/2012 13:47:05.149'!
valueRangeBucket
	^ self harvestedBuckets 
		at: SValueRangeHarvester asString asSymbol
		ifAbsent: [nil]! !

!SProject methodsFor: 'accessing' stamp: 'mp 5/28/2013 16:08:54.038'!
views: anObject
	"Do nothing. Compatibility problem with old pathView version..."! !

Object subclass: #SSourceCodeEntityAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

SSourceCodeEntityAdapter subclass: #SCategoryAdapter
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

!SCategoryAdapter class methodsFor: 'instance creation' stamp: 'mp 1/21/2010 10:14'!
on: aCategory

	^ self new
		category: aCategory! !

!SCategoryAdapter methodsFor: 'accessing' stamp: 'mp 1/21/2010 10:13'!
category
	"Answer the value of category"

	^ category! !

!SCategoryAdapter methodsFor: 'accessing' stamp: 'mp 1/21/2010 10:13'!
category: anObject
	"Set the value of category"

	category := anObject! !

!SCategoryAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:14'!
isCategory

	^ true! !

!SCategoryAdapter methodsFor: 'printing' stamp: 'mp 1/21/2010 10:13'!
printString

	^ self category! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:10'!
isCategory

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:12'!
isTestCategory

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:10'!
isTestClass

	^ false! !

!SSourceCodeEntityAdapter methodsFor: 'testing' stamp: 'mp 1/21/2010 10:11'!
isTestMethod

	^ false! !

Object subclass: #STool
	instanceVariableNames: 'windowMorph windowSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools'!

STool subclass: #SCategoryChooser
	instanceVariableNames: 'selectedCategoriesList userOk project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Projects'!

!SCategoryChooser class methodsFor: 'accessing' stamp: 'mp 6/23/2010 11:38'!
allCategories

	| categories |
	categories := Set new.
	Smalltalk allClasses do: [:each | 
		each category ifNotNil: [	categories add: each category]].
	^ categories asSortedCollection asArray! !

!SCategoryChooser class methodsFor: 'instance creation' stamp: 'mp 6/16/2010 21:50'!
on: aProject
	| tool |
	tool := self open.
	tool
		project: aProject;
		setCategoryListFromNames.
	^ tool
! !

!SCategoryChooser class methodsFor: 'instance creation' stamp: 'mp 6/16/2010 21:49'!
open
	| tool |
	tool := super open.
	tool setCategoryListFromNames.
	^ tool! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
allCategoryNames
	^ self selectedCategoriesList collect: [ :each | each key ]! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/21/2010 09:45'!
buildButtonPanelOn: aBuilder

	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #vertical;
		frame: (0.00 @ 0.75 corner: 1.00 @ 1.00);
		children: {
			self buildButtonsWith: aBuilder from: self selectButtons.
			self buildButtonsWith: aBuilder from: self userButtons.
			};
		yourself).! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/21/2010 09:46'!
buildCategoryListOn: aBuilder

	| listSpec |
	listSpec := aBuilder pluggableMultiSelectionListSpec new.
	listSpec
		model: self;
		name: #categoryList;
		list: #allCategoryNames;
		menu: #categoryMenu:;
		getSelectionList: #selectedCategoryAt:;
		setSelectionList: #selectedCategoryAt:put:;
		frame: (0 @ 0 corner: 1 @ 0.75).
	self windowSpec children add: listSpec.
	! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 16:06'!
buildWith: aBuilder 
	
	self
		buildWindowOn: aBuilder;
		buildCategoryListOn: aBuilder;
		buildButtonPanelOn: aBuilder.

	^ super buildWith: aBuilder
! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
cancel

	self userOk: false.
	self windowMorph abandon.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 15:34'!
categoryMenu: aMenu

	^ aMenu
		title: 'Categories';
		add: 'Select all' action: #selectAll;
		add: 'Select inversion' action: #selectInverse;
		add: 'Select none' action: #selectNone;
		yourself.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
getSelectedCategoryNames
	^ (self selectedCategoriesList
		select: [:each | each value]
		thenCollect: [:each | each key]) asArray! !

!SCategoryChooser methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:34'!
initialExtent

	^ 300@300! !

!SCategoryChooser methodsFor: 'initialize-release' stamp: 'mp 7/7/2010 16:55:05.741'!
initialize

	self userOk: false.
	self project: SProject new.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 3/15/2010 16:58'!
label

	^ 'Select Categories'! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 3/8/2011 18:11:29.622'!
ok

	self userOk: true.
	self storeSelectedCategories.
	self changed.
	self windowMorph abandon.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:47'!
project
	"Answer the value of project"

	^ project! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:47'!
project: anObject
	"Set the value of project"

	project := anObject! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectAll

	self selectedCategoriesList do: [:each | each value: true].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 9/1/2010 12:22:24.768'!
selectButtons

	^ #(
		( 'All' #selectAll #alwaysEnabled)
		( 'Inverse' #selectInverse #alwaysEnabled)
		( 'None' #selectNone #alwaysEnabled)	
		)! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectInverse

	self selectedCategoriesList do: [:each | each value: each value not].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 1/20/2010 15:34'!
selectNone

	self selectedCategoriesList do: [:each | each value: false].
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 6/16/2010 21:34'!
selectedCategoriesList
	^ selectedCategoriesList ifNil: [selectedCategoriesList := #()]! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
selectedCategoriesList: anObject
	selectedCategoriesList := anObject! !

!SCategoryChooser methodsFor: 'list commands' stamp: 'mp 1/20/2010 15:34'!
selectedCategoryAt: anIndex 
	^ (self selectedCategoriesList at: anIndex) value! !

!SCategoryChooser methodsFor: 'list commands' stamp: 'mp 1/20/2010 15:50'!
selectedCategoryAt: anIndex put: aBoolean 
	| result |
	result := (self selectedCategoriesList at: anIndex) value: aBoolean.
	self windowMorph changed.
	^ result! !

!SCategoryChooser methodsFor: 'initialize-release' stamp: 'mp 6/16/2010 21:50'!
setCategoryListFromNames

	self selectedCategoriesList: (self class allCategories 
		inject: OrderedCollection new 
		into: [:coll :each | coll 
						add: each -> (self project categories includes: each);
						yourself]).
	self changed: #allCategoryNames.! !

!SCategoryChooser methodsFor: 'actions' stamp: 'mp 6/16/2010 21:51'!
storeSelectedCategories
	self project categories: self getSelectedCategoryNames.! !

!SCategoryChooser methodsFor: 'building' stamp: 'mp 1/20/2010 15:34'!
userButtons

	^ #(
		( 'Ok' #ok #alwaysEnabled)
		( 'Cancel' #cancel #alwaysEnabled)
		).! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
userOk
	^ userOk! !

!SCategoryChooser methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:34'!
userOk: anObject
	userOk := anObject! !

STool subclass: #SConcernChooser
	instanceVariableNames: 'options project selectedConcernItem selectedTestItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Map'!

!SConcernChooser class methodsFor: 'instance creation' stamp: 'mp 2/3/2012 11:42:14.106'!
on: aTraceabilityOptions
	| tool |
	tool := self open.
	tool 
		options: aTraceabilityOptions;
		project: aTraceabilityOptions pathMap project;
		reloadUIData.
	^ tool! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/1/2010 18:37:25.589'!
addConcern
	| concern |
	concern := (UIManager default request: 'Please insert a concern name:').
	(self concernGroups at: self selectedGroup) add: concern.
	self concernColors at: concern put: (Color h: 360 atRandom s: 1.0 v: 1.0).
	self refreshDeselectedConcernTree.

	! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 15:27:23.146'!
addConcernGroup
	| group |
	group := (UIManager default request: 'Please insert concern group name:').
	((self concernGroups keys includes: group) or: [group isEmpty])
		ifTrue: [^ self inform: 'The group name is not allowed.'].
	self concernGroups at: group put: OrderedCollection new.
	self changed: #rootsConcerns.
	! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 3/24/2011 11:05:58.615'!
addMapping
	| tests |
	tests := OrderedCollection new.
	self isTestClassSelected
		ifTrue: [	self selectedTestClass inheritedTestSelectors 
					do: [:each | tests add: (MethodReference 
											class: self selectedTestClass 
											selector: each)].
				tests := tests select: [:each | (self project concerns 
												mappingExisting: self selectedConcern 
												and: each) not]]
		ifFalse: [tests add: self selectedTest].
	tests do: [:each | (self concernMapping 
						at: self selectedConcern 
						ifAbsentPut: [OrderedCollection new]) add: each].

! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/1/2010 12:20:53.209'!
buildButtonsOn: aBuilder

	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #vertical;
		frame: (0.00 @ 0.9 corner: 1.00 @ 1.00);
		children: {self buildButtonsWith: aBuilder from: self concernButtons};
		yourself).! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/2/2010 13:04:31.219'!
buildConcernTreeOn: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #concernTree;
		roots: #rootsConcerns;
		hasChildren: #hasChildrenConcerns:;
		getChildren: #getChildrenConcerns:;
		label: #labelTree:;
		setSelected: #newSelectedConcernItem:;
		icon: #iconForConcernItem:;		
		frame: (0 @ 0 corner: 0.5 @ 0.9).
	self windowSpec children add: treeSpec.! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/2/2010 15:02:21.691'!
buildTestTreeOn: aBuilder
	| treeSpec |
	treeSpec := aBuilder pluggableTreeSpec new.
	treeSpec
		model: self;
		name: #testTree;
		roots: #rootsTestClasses;
		hasChildren: #hasChildrenTest:;
		getChildren: #getChildrenTest:;
		label: #labelTree:;
		setSelected: #newSelectedTestItem:;
		icon: #iconForConcernTestItem:;
		frame: (0.5 @ 0 corner: 1 @ 0.9).
	self windowSpec children add: treeSpec.! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 9/13/2010 19:05:15.178'!
buildWith: aBuilder 
	self 
		buildWindowOn: aBuilder;
		buildConcernTreeOn: aBuilder;
		buildTestTreeOn: aBuilder;
		buildButtonsOn: aBuilder.
	^ super buildWith: aBuilder! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/1/2010 18:37:51.663'!
colorAction
	ColorPickerMorph new
		choseModalityFromPreference;
		sourceHand: self windowMorph activeHand;
		target: self;
		selector: #setIconColorOfSelectedConcern:;
		originalColor: (self concernColors at: self selectedConcern);
		putUpFor: self windowMorph near: self windowMorph fullBoundsInWorld.! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/2/2010 09:20:19.808'!
colorEnabled

	^ self isConcernSelected
! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 09:21:08.885'!
concernButtonAction
	self isConcernGroupSelected
		ifTrue: [self addConcern].
	self isConcernSelected
		ifTrue: [self removeConcern].! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 15:29:16.295'!
concernButtonEnabled
	^ self isConcernGroupSelected or: [self isConcernSelected]
! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 09:20:41.945'!
concernButtonLabel
	self isConcernSelected ifTrue: [^ 'Remove Concern'].
	^ 'Add Concern'! !

!SConcernChooser methodsFor: 'building' stamp: 'mp 5/28/2013 11:10:31.264'!
concernButtons
	^ #(
		( #groupButtonLabel #groupButtonAction #groupButtonEnabled)
		( #concernButtonLabel #concernButtonAction #concernButtonEnabled)
		( 'Choose Color' #colorAction #colorEnabled)
		( #mappingButtonLabel #mappingButtonAction #mappingButtonEnabled)		
		)! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:36.941'!
concernColors
	^ self project concerns colors ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:44.839'!
concernGroups
	^ self project concerns groups ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 15:29:56.591'!
concernMapping
	^ self project concerns mapping ! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 14:19:21.001'!
getChildrenConcerns: aCollection
	"size corresponds to depth of tree"
	"concern groups"
	aCollection size = 1 
		ifTrue: [^ (self concernGroups at: aCollection first) asSortedCollection 
					collect: [:each | {aCollection first. each}]].
	"concerns"
	aCollection size = 2 
		ifTrue: [	^ (self project concerns testClassesOfConcern: aCollection second)
					collect: [:each | {aCollection first. aCollection second. each}]].
	"test classes"
	aCollection size = 3
		ifTrue: [^ (self project concerns 
					testSelectorsOfClass: aCollection third 
					andConcern: aCollection second)
						collect: [:each | {aCollection first. aCollection second. 
										aCollection third. each}]].! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:53.89'!
getChildrenTest: aCollection
	"size corresponds to depth of tree"
	| testRef concerns |
	"test classes"
	aCollection size = 1 
		ifTrue: [ ^ aCollection first inheritedTestSelectors collect: [:each | {aCollection first. each}]].
	"test selectors"
	aCollection size = 2 
		ifTrue: [	testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
				concerns := self project concerns concernsOfTest: testRef.
				^ (self project concerns groupsOfConcerns: concerns)
					collect: [:each | {aCollection first. aCollection second. each}]].
	"concern groups"
	aCollection size = 3
		ifTrue: [	testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
				^ (self project concerns concernsOfGroup: aCollection third andTest: testRef)
					collect: [:each | {aCollection first. aCollection second. 
									aCollection third. each}]].! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 15:16:11.317'!
getIconForConcernFrom: aCollection at: aNumber
	| icon |
	(aCollection size = aNumber) ifFalse: [^ nil].
	(self concernColors includesKey: (aCollection at: aNumber))
		ifTrue: [
			icon := Form extent: 15@15 depth: 32.
			icon fillColor: (self concernColors at: (aCollection at: aNumber)).
			^ icon].
	^ nil! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 09:24:02.229'!
groupButtonAction
	self isConcernGroupSelected
		ifTrue: [self removeConcernGroup]
		ifFalse: [self addConcernGroup].
	
	! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 15:51:53.281'!
groupButtonEnabled

	^ (self selectedConcernItem isNil or: 
		[self isConcernGroupSelected]) or: 
			[self isConcernSelected]! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 9/2/2010 09:23:42.281'!
groupButtonLabel
	self isConcernGroupSelected
		ifTrue: [^ 'Remove Group']
		ifFalse: [^ 'Add Group'].
	! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 14:19:10.794'!
hasChildrenConcerns: aCollection		
	"size corresponds to depth of tree"
	"concern groups"
	aCollection size = 1 
		ifTrue: [^ (self concernGroups at: aCollection first) notEmpty].
	"concerns"
	aCollection size = 2 
		ifTrue: [	(self concernMapping includesKey: aCollection second)
					ifTrue: [^ (self concernMapping at: aCollection second) notEmpty]].	
	"test classes"
	^ aCollection size = 3 ! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:50.509'!
hasChildrenTest: aCollection
	"size corresponds to depth of tree"
	| testRef |
	"test classes"
	aCollection size = 1 
		ifTrue: [^ aCollection first inheritedTestSelectors notEmpty].
	"test selectors"
	aCollection size = 2 
		ifTrue: [testRef := MethodReference 
							class: aCollection first  selector: aCollection second. 
			^ (self project concerns concernsOfTest: testRef) notEmpty].
	"concern groups"
	^ aCollection size = 3! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 15:15:36.516'!
iconForConcernItem: aCollection
	^ self getIconForConcernFrom: aCollection at: 2! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 9/2/2010 15:16:39.3'!
iconForConcernTestItem: aCollection
	^ self getIconForConcernFrom: aCollection at: 4! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/1/2010 11:38:51.286'!
initialExtent

	^ 500@400! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 12:05:27.768'!
isConcernGroupSelected
	^ self selectedConcernItem notNil and: [self selectedConcernItem size = 1]! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 12:06:44.23'!
isConcernSelected
	^ self selectedConcernItem notNil and: [self selectedConcernItem size = 2]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 3/24/2011 11:05:44.091'!
isSelectedMappingExisting
	self isConcernSelected ifFalse: [^ false].
	(self concernMapping includesKey: self selectedConcern) ifFalse: [^ false].
	self isTestClassSelected
		ifTrue: [	^ ((self concernMapping at: self selectedConcern) 
				select: [:each | each actualClass == self selectedTestClass]) size = 
					self selectedTestClass inheritedTestSelectors size].
	self isTestSelectorSelected
		ifTrue: [^ self project concerns 
					mappingExisting: self selectedConcern and: self selectedTest].
	^ false! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 12:07:55.58'!
isTestClassSelected
	^ self selectedTestItem notNil and: [self selectedTestItem size = 1]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 12:08:04.046'!
isTestSelectorSelected
	^ self selectedTestItem notNil and: [self selectedTestItem size = 2]! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/22/2010 18:12:47.742'!
label

	^ 'Concern Mapping'! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 11:59:23.048'!
labelTree: aCollection

	^ aCollection last asString! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:29:37.712'!
mappingButtonAction
	self isSelectedMappingExisting
		ifTrue: [self removeMapping]
		ifFalse: [self addMapping].
	self 
		selectedConcernItem: nil;
		selectedTestItem: nil;
		reloadUIData.! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 09:25:38.111'!
mappingButtonEnabled

	^ self isConcernSelected and: [
		self isTestClassSelected or: [self isTestSelectorSelected]]! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:13:07.302'!
mappingButtonLabel
	self isSelectedMappingExisting
		ifTrue: [^ 'Remove Mapping']
		ifFalse: [^ 'Add Mapping'].
! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 5/22/2013 10:54:20.704'!
newSelectedConcernItem: anObject
	self 
		selectedConcernItem: anObject;
		refreshButtons.! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 5/22/2013 13:26:21.48'!
newSelectedTestItem: anObject
	self 
		selectedTestItem: anObject; 
		refreshButtons.! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 2/3/2012 11:42:28.85'!
options
	"Answer the value of options"

	^ options! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 2/3/2012 11:42:28.866'!
options: anObject
	"Set the value of options"

	options := anObject! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:14:17.165'!
project
	"Answer the value of project"

	^ project! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/1/2010 11:14:17.169'!
project: anObject
	"Set the value of project"

	project := anObject! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 5/28/2013 11:10:37.278'!
refreshButtons
	self
		changed: #groupButtonLabel;
		changed: #groupButtonEnabled;
		changed: #concernButtonLabel;
		changed: #concernButtonEnabled;
		changed: #colorEnabled;
		changed: #mappingButtonLabel;
		changed: #mappingButtonEnabled.! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 12:03:35.778'!
refreshDeselectedConcernTree
	self 
		selectedConcernItem: nil;
		refreshButtons;
		changed: #rootsConcerns.

	! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/2/2010 15:42:58.909'!
refreshDeselectedTestTree
	self 
		selectedTestItem: nil;
		changed: #rootsTestClasses.

	! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 9/1/2010 17:10:35.498'!
reloadUIData

	self 
		changed: #rootsTestClasses;
		changed: #rootsConcerns;
		refreshButtons.
	! !

!SConcernChooser methodsFor: 'concern button' stamp: 'mp 9/2/2010 15:43:13.315'!
removeConcern
	| concerns |
	(UIManager default confirm: 'Remove concern?')
		ifTrue: [	concerns := self concernGroups at: self selectedGroup.
				concerns remove: self selectedConcern.
				self concernColors removeKey: self selectedConcern ifAbsent: [].
				self concernMapping removeKey: self selectedConcern ifAbsent: [].		
				self 
					refreshDeselectedTestTree;
					refreshDeselectedConcernTree].! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 4/1/2011 12:11:22.934'!
removeConcernGroup
	self removeConcernGroup: self selectedGroup.! !

!SConcernChooser methodsFor: 'group button' stamp: 'mp 4/1/2011 12:11:03.29'!
removeConcernGroup: aGroup
	(UIManager default confirm: 'Remove group and all included concerns?')
		ifTrue: [ (self concernGroups at: aGroup) 
					do: [:each | 
						self concernColors removeKey: each ifAbsent: [].
						self concernMapping removeKey: each ifAbsent: []].
				self concernGroups removeKey: aGroup.
				self 
					refreshDeselectedTestTree;
					refreshDeselectedConcernTree].! !

!SConcernChooser methodsFor: 'mapping button' stamp: 'mp 9/2/2010 16:35:01.226'!
removeMapping
	self isTestClassSelected
		ifTrue: [((self concernMapping at: self selectedConcern) 
					select: [:each | each actualClass == self selectedTestClass])
					do: [:each | (self concernMapping at: self selectedConcern) remove: each]]
		ifFalse: [(self concernMapping at: self selectedConcern) remove: self selectedTest]
! !

!SConcernChooser methodsFor: 'concern tree' stamp: 'mp 9/2/2010 12:58:01.373'!
rootsConcerns
	self project ifNil: [^ #()].
	^ self concernGroups keys asSortedCollection collect: [:each | {each}]! !

!SConcernChooser methodsFor: 'test tree' stamp: 'mp 3/24/2011 11:05:28.912'!
rootsTestClasses
	self project ifNil: [^ #()].
	^ (self project testClasses asSortedCollection: [:a :b | a asString <= b asString])
		select: [:each | each inheritedTestSelectors notEmpty] 
		thenCollect: [:each | {each}]! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:06:51.545'!
selectedConcern
	^ self selectedConcernItem second! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.053'!
selectedConcernItem
	"Answer the value of selectedConcernItem"

	^ selectedConcernItem! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.058'!
selectedConcernItem: anObject
	"Set the value of selectedConcernItem"

	selectedConcernItem := anObject! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:06:55.964'!
selectedGroup
	^ self selectedConcernItem first! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:08:14.08'!
selectedTest
	^ MethodReference 
		class: self selectedTestItem first 
		selector: self selectedTestItem second
	
	
	 ! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:08:16.905'!
selectedTestClass
	^ self selectedTestItem first! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.062'!
selectedTestItem
	"Answer the value of selectedTestItem"

	^ selectedTestItem! !

!SConcernChooser methodsFor: 'accessing' stamp: 'mp 9/2/2010 12:02:01.066'!
selectedTestItem: anObject
	"Set the value of selectedTestItem"

	selectedTestItem := anObject! !

!SConcernChooser methodsFor: 'color button' stamp: 'mp 9/2/2010 15:09:23.677'!
setIconColorOfSelectedConcern: aColor
	self selectedConcernItem ifNil: [^ self].
	self concernColors at: self selectedConcern put: aColor.
	self 
		refreshDeselectedConcernTree;
		changed: #rootsTestClasses.! !

!SConcernChooser methodsFor: 'user interface' stamp: 'mp 2/3/2012 11:44:09.868'!
windowIsClosed
	self options concernsHaveChanged.! !

STool subclass: #SPathFinder
	instanceVariableNames: 'callTreeTracer callTreeModel testChooserModel coverageTracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Finder'!

SPathFinder subclass: #SPathDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Finder'!

!SPathDebugger methodsFor: 'building' stamp: 'mp 7/16/2013 17:20:08.289'!
callTreeModelClass
	^ SDebuggerCallTreeModel! !

!SPathDebugger methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:21:29.891'!
indentingListItemClass
	^ SDebuggerCodeExplorerIndentingListItemMorph! !

!SPathDebugger methodsFor: 'building-pluggable-morphs' stamp: 'mp 10/12/2011 12:10:57.757'!
toolName
	^ 'PathFinder'! !

!SPathFinder class methodsFor: 'private' stamp: 'mp 6/23/2010 11:23'!
convertMethodReferenceToString: aMethodReference
	^ aMethodReference classSymbol asString, 
		(aMethodReference classIsMeta ifTrue: [ ' class' ] ifFalse: ['']), 
		'>>', 
		aMethodReference methodSymbol asString! !

!SPathFinder class methodsFor: 'class initialization' stamp: 'mp 3/7/2011 21:49:20.381'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'PathFinder'. {self. #open}}.! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/7/2012 09:45:12.269'!
open
	SProject isNullProjectSelected
		ifTrue: [self inform: 'Please choose a project first and start PathFinder again.'.
				^ SProjectChooser open].
	^ super open.! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/24/2011 09:58:07.381'!
openOn: aTestMethodReference

	| pathFinder |
	pathFinder := self open.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	pathFinder changed: #label.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 7/16/2013 16:55:29.378'!
openOn: aTestMethodReference and: aMethodReference

	| pathFinder |
	pathFinder := self openOn: aTestMethodReference.
	pathFinder callTreeModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 7/16/2013 16:55:32.049'!
openOn: aTestMethodReference and: aMethodReference coverageTracer: aTracer
	| pathFinder |
	pathFinder := self openOn: aTestMethodReference coverageTracer: aTracer.
	pathFinder callTreeModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 3/25/2011 12:29:45.063'!
openOn: aTestMethodReference coverageTracer: aTracer
	| pathFinder |
	pathFinder := self open.
	pathFinder coverageTracer: aTracer.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	pathFinder changed: #label.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 10/31/2010 11:39:45.221'!
openOnCode: aSourceCodeString

	| pathFinder |
	pathFinder := self open.
	pathFinder testChooserModel setCurrentCode: aSourceCodeString.
	^ pathFinder! !

!SPathFinder class methodsFor: 'instance creation' stamp: 'mp 7/16/2013 16:55:34.292'!
openOnCode: aSourceCodeString and: aMethodReference

	| pathFinder |
	pathFinder := self openOnCode: aSourceCodeString.
	pathFinder callTreeModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	^ pathFinder! !

!SPathFinder class methodsFor: 'private' stamp: 'mp 7/16/2013 17:06:25.88'!
openWithPerformanceMeasureOn: aTestMethodReference
	| pathFinder swFindNode |
	swFindNode := Stopwatch new.
	pathFinder := self new.
	ToolBuilder open: pathFinder.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	swFindNode activate.
	(pathFinder callTreeModel tracer getNode: (pathFinder callTreeModel tracer currentId / 2) asInteger) setAsCurrentSelection.
	swFindNode suspend.
	pathFinder windowMorph abandon.
	^ swFindNode duration asMilliSeconds! !

!SPathFinder class methodsFor: 'private' stamp: 'mp 7/16/2013 17:06:12.344'!
openWithPerformanceMeasureOn: aTestMethodReference and: aMethodReference
	| pathFinder swGui swShallowAnalysis swFindNode fullTime |
	Transcript clear.
	swGui := Stopwatch new.
	swShallowAnalysis := Stopwatch new.
	swFindNode := Stopwatch new.
	"Start: Build GUI"
	swGui activate.
	pathFinder := self new.
	ToolBuilder open: pathFinder.
	swGui suspend.
	"End: Build GUI"
	"Start: Shallow Analysis"
	swShallowAnalysis activate.
	pathFinder testChooserModel setCurrentTest: aTestMethodReference.
	swShallowAnalysis suspend.
	"End: Shallow Analysis"
	"Start: Find Node in Tree"
	swFindNode activate.
	pathFinder callTreeModel 
		searchNode: (self convertMethodReferenceToString: aMethodReference);
		changed: #getSearchQuery.
	swFindNode suspend.
	"End: Find Node in Tree"
	"Summary"
	fullTime := swGui duration + swShallowAnalysis duration + swFindNode duration.
	Transcript show: 'GUI: ', swGui duration asString; space; show: ((swGui duration / fullTime) * 100) asInteger asString; show: '%'; cr.	
	Transcript show: 'Shallow Analysis: ', swShallowAnalysis duration asString; space; show: ((swShallowAnalysis duration / fullTime) * 100) asInteger asString; show: '%'; cr.
	Transcript show: 'Find Node: ', swFindNode duration asString; space; show: ((swFindNode duration / fullTime) * 100) asInteger asString; show: '%'; cr.
	Transcript show: 'All: ', (fullTime) asString; cr.
	^ pathFinder! !

!SPathFinder class methodsFor: 'window color' stamp: 'mp 8/14/2013 15:13:59.45'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'PathFinder' 
		brightColor:  #white
		pastelColor: #white
		helpMessage: 'Lightweight Back-in-Time Debugger for Test Cases'! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 7/16/2013 17:00:08.335'!
buildCallTreeOn: aBuilder frame: aRectangle 
	| treeSpec |
	treeSpec := SPluggableTreeSpec new.
	treeSpec
		model: self callTreeModel;
		name: #callTree;
		roots: #rootCallNodes;
		hasChildren: #hasChildren:;
		getChildren: #getChildren:;
		setSelected: #newSelectedItem:;
		getSelectedPath: #getSelectedPath;
		menu: #callTreeMenu:;
		highlightItem: #highlightItem:;
		indentingListItemMorph: self indentingListItemClass;
		icon: #getIcon:;
		frame: aRectangle.
	self windowSpec children add: treeSpec! !

!SPathFinder methodsFor: 'building' stamp: 'mp 4/17/2010 20:45'!
buildCustomMorphs

	self 
		"buildNavigationBarMorphWithFrame: (0.007 @ 0.00 corner: 0.85 @ 0.05);"
		buildTestResultFeedbackMorphWithFrame: (0.008 @ 0.0 corner: 0.047 @ 0.061);
		buildDropDownMorphOn: self testChooserModel
			with: {'Class View' -> #selectClassesView. 
				   'Object View' -> #selectObjectView.
				   'Identity View' -> #selectIdentityView.}
			frame: (0.05 @ 0.0 corner:  0.254 @ 0.061);
		buildDropDownMorphOn: self testChooserModel
			with: {'Without Profiling' -> #normalRun. 
				   'Relative % Profiling' -> #profileRunWithPercentage. 
				   'Absolute ms Profiling' -> #profileRunWithMs.
				   'Call Counts' -> #normalRunWithCounts.}
			frame: (0.256 @ 0.0 corner:  0.46 @ 0.061).! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 7/7/2010 16:45:28.525'!
buildDropDownMorphOn: aModel with: aCollection frame: aRectangle
	| morph |
	morph := SDropDownMorph on: aModel with: aCollection.
	self setFrame: aRectangle in: morph.
	self windowMorph addMorph: morph.! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 7/16/2013 16:55:10.283'!
buildHistoryButtonsOn: aBuilder frame: aRectangle 
	| buttonSpec |
	buttonSpec := self 
		buildButtonsWith: aBuilder
		from: self historyButtons
		model: self callTreeModel.
	buttonSpec frame: aRectangle.
	self windowSpec children add: buttonSpec! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 7/16/2013 17:01:05.514'!
buildPathViewButtonOn: aBuilder frame: aRectangle
	| buttonSpec |
	buttonSpec := self 
		buildButtonsWith: aBuilder
		from: #(('PathView' #openPathViewOnTrace #isTreeAvailable))
		model: self callTreeModel.
	buttonSpec frame: aRectangle.
	self windowSpec children add: buttonSpec! !

!SPathFinder methodsFor: 'building' stamp: 'mp 7/16/2013 16:59:10.296'!
buildPluggableMorphsOn: aBuilder
	self
		buildWindowOn: aBuilder;
		buildHistoryButtonsOn: aBuilder frame: (0.85 @ -0.01 corner: 1.0 @ 0.062);
		buildPathViewButtonOn: aBuilder frame: (0.75 @ -0.01 corner: 0.85 @ 0.062);
		buildSearchFieldOn: aBuilder frame: (0.456 @ -0.01 corner: 0.75 @ 0.062);
		buildCallTreeOn: aBuilder frame: (0.0 @ 0.062 corner: 1.0 @ 1.0).
	super buildWith: aBuilder.! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 7/16/2013 16:55:15.824'!
buildSearchFieldOn: aBuilder frame: aRectangle 
	| inputSpec |
	inputSpec := aBuilder pluggableInputFieldSpec new
		model: self callTreeModel;
		name: #searchInputField;
		getText: #getSearchQuery;
		setText: #searchNode:;
		frame: aRectangle.
	self windowSpec children add: inputSpec! !

!SPathFinder methodsFor: 'building-custom-morphs' stamp: 'mp 3/24/2011 10:03:37.592'!
buildTestResultFeedbackMorphWithFrame: aRectangle
	| testResult |
	testResult := STestResultFeedbackMorph on: self selector: #rerunTest.
	self setFrame: aRectangle in: testResult.
	self windowMorph addMorph: testResult.
	self testChooserModel addDependent: testResult.! !

!SPathFinder methodsFor: 'building' stamp: 'mp 1/20/2010 17:03'!
buildWith: aBuilder 
	
	self 
		createModels;
		buildPluggableMorphsOn: aBuilder;
		buildCustomMorphs;
		resizeWindow.
	^ self windowMorph! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:54:07.683'!
callTreeModel

	^ callTreeModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:54:07.688'!
callTreeModel: anObject

	callTreeModel := anObject! !

!SPathFinder methodsFor: 'building' stamp: 'mp 7/16/2013 17:19:43.384'!
callTreeModelClass
	^ SCallTreeModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:52:41.456'!
callTreeTracer

	^ callTreeTracer! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 7/16/2013 16:52:41.461'!
callTreeTracer: anObject

	callTreeTracer := anObject! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 4/9/2013 09:47:11.463'!
chooseNewTest
	self testChooserModel	setCurrentTest: 
		(UIManager default 
				chooseFrom: (SProject current allTests collect: [:each | each asString])
				values: SProject current allTests
				lines: #() 
				title: 'Choose Test Case') ! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 3/24/2011 10:34:57.774'!
chooseTestAction
	^ UIManager default 
				chooseFrom: {'Rerun current test'. 'Choose new test'}
				values: {#rerun. #newTest}
				lines: #() 
				title: 'Choose test action'

	! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 4/15/2010 15:46'!
clearAnalysis

	self testChooserModel setCurrentTest: nil.! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 3/25/2011 11:30:42.879'!
coverageTracer
	"Answer the value of coverageTracer"

	^ coverageTracer! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 3/25/2011 11:30:42.884'!
coverageTracer: anObject
	"Set the value of coverageTracer"

	coverageTracer := anObject! !

!SPathFinder methodsFor: 'building' stamp: 'mp 7/16/2013 17:19:52.376'!
createModels
	self callTreeTracer: (SCallTreeTracer on: SProject current).
	self callTreeModel: (self callTreeModelClass 
							on: self callTreeTracer
							pathFinder: self).
	self callTreeTracer callTreeModel: self callTreeModel.
	self testChooserModel: (STestChooserModel on: self callTreeTracer).! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 1/20/2010 17:03'!
historyButtons

	^ #(
		( '<<' #historyBack #historyBackButtonEnabled)
		( '>>' #historyPrevious #historyPreviousButtonEnabled)
		).! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/25/2011 12:20:40.322'!
indentingListItemClass
	^ SCodeExplorerIndentingListItemMorph! !

!SPathFinder methodsFor: 'user interface' stamp: 'mp 11/8/2010 17:14:38.535'!
initialExtent

	^ 750@450! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/24/2011 17:43:50.509'!
label
	| subhead |
	subhead := self testChooserModel test 
		ifNil: ['']
		ifNotNil: [
			self testChooserModel test isString
				ifTrue: ['Code Snippet']
				ifFalse: [self testChooserModel test stringVersionDefault]].
	^ self toolName, ': ', subhead! !

!SPathFinder methodsFor: 'actions' stamp: 'mp 5/14/2012 11:08:05.982'!
rerunTest
	| choice |
	self testChooserModel isTestAvailable
		ifTrue: [	choice := self chooseTestAction.
				choice caseOf: {
					[#rerun] -> [self testChooserModel analyzeTest].
					[#newTest] -> [self chooseNewTest]}
					otherwise: [^ self]]
		ifFalse: [self chooseNewTest].
	self changed: #label.

	! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
testChooserModel
	^ testChooserModel! !

!SPathFinder methodsFor: 'accessing' stamp: 'mp 1/20/2010 17:03'!
testChooserModel: anObject 
	testChooserModel := anObject! !

!SPathFinder methodsFor: 'building-pluggable-morphs' stamp: 'mp 3/24/2011 17:44:03.439'!
toolName
	^ 'PathFinder'! !

STool subclass: #SPathView
	instanceVariableNames: 'startClass classDiagramMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-View'!

!SPathView class methodsFor: 'class initialization' stamp: 'ag 12/27/2011 13:55:49.452'!
initialize
	"self initialize"
	
	TheWorldMenu registerOpenCommand: { 'PathView'. { self. #open } }.! !

!SPathView class methodsFor: 'instance creation' stamp: 'ag 12/27/2011 13:55:35.02'!
new
	
	self error: 'Use #open.'! !

!SPathView class methodsFor: 'instance creation' stamp: 'ag 2/19/2012 12:58:27.838'!
open

	^ self openOn: nil! !

!SPathView class methodsFor: 'instance creation' stamp: 'tfel 6/7/2011 14:08:15.132'!
openOn: aClass
	
	^ self basicNew
		initialize;
		startWithClass: aClass;
		yourself! !

!SPathView class methodsFor: 'instance creation' stamp: 'tfel 6/28/2012 12:16:34.13'!
openSaved: aString
	| window diagram |
	window := self open.
	diagram := window classDiagramMorph.
	diagram openSaved: aString.! !

!SPathView class methodsFor: 'window color' stamp: 'mp 8/14/2013 15:16:37.042'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'PathView' 
		brightColor:  #white
		pastelColor: #white
		helpMessage: 'A Model-based Source Code Editor'! !

!SPathView methodsFor: 'building' stamp: 'ag 9/2/2011 16:39:09.985'!
buildButtonsWith: aBuilder
	
	self
		buildButtonsPanelWith: aBuilder
		from: self menuButtons
		model: self classDiagramMorph
		frame: (0.0 @ 0.0 corner: 1 @ 0.05);
		
		buildButtonsPanelWith: aBuilder
		from: self toolbarButtons
		model: self classDiagramMorph
		frame: (0.0 @ 0.05 corner: 1 @ 0.10).! !

!SPathView methodsFor: 'building' stamp: 'tfel 6/28/2012 10:03:22.888'!
buildWindowWith: aBuilder
	
	| pathViewSpec |
	self buildWindowOn: aBuilder.
	self windowSpec
		model: self classDiagramMorph;
		label: #windowLabel;
		closeAction: nil.
	pathViewSpec :=  SPathViewDiagramSpec new
											model: self;
											children: OrderedCollection new;
											frame: (0@0.10 extent: 1@0.90);
											viewAreaMorph: self classDiagramMorph.
	self windowSpec children addAll: { pathViewSpec }.
	self buildButtonsWith: aBuilder.
	super buildWith: aBuilder.! !

!SPathView methodsFor: 'building' stamp: 'tfel 6/28/2012 07:46:57.193'!
buildWith: aBuilder 
	
	self
		buildWindowWith: aBuilder;
		resizeWindow.
	^ self windowMorph! !

!SPathView methodsFor: 'building' stamp: 'ag 12/29/2011 12:22:50.595'!
classDiagramMorph
	
	^ classDiagramMorph ifNil: [
		classDiagramMorph := SClassDiagram new.
		self initialDiagramMorph ifNotNilDo: [ :classMorph |
			classDiagramMorph addMorph: classMorph.
			classMorph optionallyOpenConnectors ].
		classDiagramMorph ]! !

!SPathView methodsFor: 'building' stamp: 'tfel 6/23/2011 12:06:09.366'!
classDiagramMorph: aClassDiagramMorph
	
	classDiagramMorph := aClassDiagramMorph.! !

!SPathView methodsFor: 'building' stamp: 'ag 12/27/2011 14:03:17.149'!
initialDiagramMorph
	
	^ startClass
		ifNotNil: [ | classMorph |
			classMorph := SClassMorph on: startClass.
			classMorph position: ((self initialExtent x / 2) - (classMorph width / 2)) @ 
						((self initialExtent y / 2) - (classMorph height / 2)).
			classMorph ]! !

!SPathView methodsFor: 'initialize-release' stamp: 'ag 12/31/2011 09:39:00.604'!
initialExtent

	^ 800@600! !

!SPathView methodsFor: 'accessing' stamp: 'mp 1/26/2011 11:20:37.433'!
label

	^ 'PathView'! !

!SPathView methodsFor: 'building' stamp: 'tfel 6/28/2012 10:09:22.054'!
menuButtons
	"These buttons represent the menu. They contain meta-actions like saving or opening another view."
	
	^ #(
		('File' #fileMenu #alwaysEnabled)
		('Preferences' #openPreferences #alwaysEnabled)
		)! !

!SPathView methodsFor: 'initialize-release' stamp: 'ag 12/27/2011 13:58:38.446'!
startWithClass: aClass
	
	startClass := aClass.
	ToolBuilder open: self.! !

!SPathView methodsFor: 'building' stamp: 'mp 7/16/2013 11:28:25.049'!
toolbarButtons
	"The model for these button-actions is classDiagramMorph (an SClassDiagram).
	These buttons represent a toolbar; they contain actions for altering the contents of the class-diagram."
	
	^ #(
		('Extend diagram area' #extendArea #alwaysEnabled)
		('Add ...' #addNoteOrClass #alwaysEnabled)
		('Toggle labels' #toggleLabels #alwaysEnabled)
		('Zoom in' #zoomIn #alwaysEnabled)
		('Zoom out' #zoomOut #canZoomOut)
		('Mini-map --' #minimapSmaller #canScaleMinimapSmaller)
		('Mini-map ++' #minimapBigger #canScaleMinimapBigger)
		('Smoothing --' #smoothDown #canSmoothDown)
		('Smoothing ++' #smoothUp #canSmoothUp)
		('Layout' #layoutGraph #alwaysEnabled)
		
"The auto-layout buttons are disabled; when deleting this, also delete all implementation-methods in SClassDiagram and SClassMorph."
"		('Trigger Auto Layout' #startLayouting #isLayoutNotRunning)
		('Lock Auto Layout' #lockLayouting #isLayoutUnlocked)
		('Stop Auto Layout' #stopLayouting #isLayoutRunning)
"
		)! !

STool subclass: #SProjectChooser
	instanceVariableNames: 'selectedProject testMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Projects'!

!SProjectChooser class methodsFor: 'class initialization' stamp: 'mp 3/7/2011 21:50:41.281'!
initialize
	"self initialize"
	TheWorldMenu registerOpenCommand: {'PathProjects'. {self. #open}}.! !

!SProjectChooser class methodsFor: 'window color' stamp: 'mp 8/14/2013 15:15:29.619'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'PathProject' 
		brightColor:  #white
		pastelColor: #white
		helpMessage: 'Definition of the System under Observation'! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/25/2013 17:35:33.466'!
addProject
	| projectName |
	projectName := testMode
		ifTrue: ['PathTestProject']
		ifFalse: [UIManager default request: 'Insert new project name' initialAnswer: ''].
	(projectName notNil and: [projectName notEmpty])
		ifTrue: [
			projectName := projectName asSymbol.
			(SProject projectAt: projectName) 
				ifNotNil: [^ self inform: 'Project name already exists.'].
			selectedProject := SProject 
									projectAt: projectName 
									put: (SProject name: projectName categories: #())].
	self 
		changed: #allRegisteredProjects;
		changed: #selectedProject;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 7/7/2010 16:55:20.267'!
allRegisteredProjects

	^ SProject allProjectsWithoutNull asSortedCollection: [:a :b | 
		a projectName < b projectName]! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 6/15/2010 22:33'!
buildProjectListOn: aBuilder frame: aRectangle
	| listSpec |
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: #projectList;
		list: #allRegisteredProjects;
		getSelected: #selectedProject;
		setSelected: #selectedProject:;
		frame: aRectangle.
	self windowSpec children add: listSpec.! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 6/16/2010 14:23'!
buildSelectedCategoriesListOn: aBuilder frame: aRectangle
	| listSpec |
	listSpec := aBuilder pluggableListSpec new.
	listSpec
		model: self;
		name: #selectedCategoriesList;
		list: #selectedCategoriesOfProject;
		frame: aRectangle.
	self windowSpec children add: listSpec.
! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 2/3/2012 11:28:57.791'!
buildWith: aBuilder 
	
	self
		buildWindowOn: aBuilder;
		buildButtonsPanelWith: aBuilder 
			from: self projectControlButtons 
			model: self 
			frame: (0.0 @ 0.0 corner: 1.0 @ 0.1325);
		buildProjectListOn: aBuilder frame: (0.0 @ 0.1325 corner: 0.5 @ 1.0);
		buildSelectedCategoriesListOn: aBuilder frame: (0.5 @ 0.1325 corner: 1.0 @ 1.0).

	^ super buildWith: aBuilder! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/25/2013 17:41:04.19'!
chooseCategories

	| chooser |
	chooser := SCategoryChooser on: selectedProject.
	chooser addDependent: self.
	selectedProject resetClassesCache.
	^ chooser! !

!SProjectChooser methodsFor: 'accessing' stamp: 'mp 3/25/2013 17:34:02.811'!
enableTestMode

	testMode := true.! !

!SProjectChooser methodsFor: 'user interface' stamp: 'mp 2/3/2012 11:30:25.696'!
initialExtent

	^ 600@215! !

!SProjectChooser methodsFor: 'initialize-release' stamp: 'mp 3/25/2013 17:34:09.817'!
initialize

	selectedProject := SProject current.
	testMode := false.! !

!SProjectChooser methodsFor: 'user interface' stamp: 'mp 6/16/2010 09:46'!
isProjectSelected

	^ selectedProject notNil ! !

!SProjectChooser methodsFor: 'accessing' stamp: 'mp 3/7/2011 21:43:07.163'!
label

	^ 'PathProjects'! !

!SProjectChooser methodsFor: 'building' stamp: 'mp 3/8/2011 20:29:02.126'!
projectControlButtons

	^ #(
		( 'Set Current' #selectCurrentProject #alwaysEnabled)
		( 'Add Project' #addProject #alwaysEnabled)
		( 'Choose Categories...' #chooseCategories #isProjectSelected)
		( 'Remove Project' #removeSelectedProject #isProjectSelected)
		( 'Reset Cache' #resetCacheOfSelectedProject #isProjectSelected)
		).! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 7/7/2010 16:55:29.145'!
removeSelectedProject

	SProject removeProjectAt: selectedProject projectName.
	selectedProject := SProject current.
	self 
		changed: #allRegisteredProjects;
		changed: #selectedProject;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 11:09'!
resetCacheOfSelectedProject

	selectedProject resetClassesCache.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 3/8/2011 19:42:40.308'!
selectCurrentProject
	selectedProject 
		ifNil: [SProject setNullProjectAsCurrent]
		ifNotNil: [SProject setCurrentProject: selectedProject].
	selectedProject resetClassesCache.
	self changed: #allRegisteredProjects.! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 1/2/2012 14:17:07.161'!
selectedCategoriesOfProject

	^ selectedProject
		ifNil: [#()]
		ifNotNil: [selectedProject categories]! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 09:47'!
selectedProject

	^ selectedProject! !

!SProjectChooser methodsFor: 'project commands' stamp: 'mp 6/16/2010 14:25'!
selectedProject: aProject

	selectedProject := aProject.
	self 
		changed: #isProjectSelected;
		changed: #selectedCategoriesOfProject.! !

!SProjectChooser methodsFor: 'updating' stamp: 'mp 3/8/2011 18:11:56.975'!
update: aCategoryChooser

	self changed: #selectedCategoriesOfProject.! !

!STool class methodsFor: 'instance creation' stamp: 'tfel 2/14/2012 13:31:27.413'!
open
	| tool |
	tool := self new.
	ToolBuilder open: tool.
	^ tool! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:29:37.094'!
setFrame: aRectangle in: aMorph
	
	^ self
		setLayoutFrame: (LayoutFrame fractions: aRectangle)
		of: aMorph! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:29:54.625'!
setFrame: aRectangle offset: anotherRectangle in: aMorph
	
	^ self
		setLayoutFrame: (LayoutFrame fractions: anotherRectangle offsets: aRectangle)
		of: aMorph! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:29:05.315'!
setLayoutFrame: aLayoutFrame of: aMorph
	
	^ aMorph
		layoutFrame: aLayoutFrame;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself! !

!STool class methodsFor: 'layouting' stamp: 'ag 12/27/2011 14:30:18.794'!
setOffsetFrame: aRectangle in: aMorph
	
	^ self
		setLayoutFrame: (LayoutFrame offsets: aRectangle)
		of: aMorph! !

!STool methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:33'!
alwaysDisabled

	^ false! !

!STool methodsFor: 'user interface' stamp: 'mp 1/20/2010 15:33'!
alwaysEnabled

	^ true! !

!STool methodsFor: 'building' stamp: 'mp 3/8/2011 17:46:44.008'!
buildButtonsPanelWith: aBuilder from: anArray model: aModel frame: aRect
	
	self windowSpec children add: (aBuilder pluggablePanelSpec new
		layout: #horizontal;
		frame: aRect;
		children: {
			self buildButtonsWith: aBuilder from: anArray model: aModel.
			};
		yourself).! !

!STool methodsFor: 'building' stamp: 'mp 1/20/2010 15:33'!
buildButtonsWith: aBuilder from: anArray

	^ self buildButtonsWith: aBuilder from: anArray model: self! !

!STool methodsFor: 'building' stamp: 'mp 1/20/2010 16:04'!
buildButtonsWith: aBuilder from: anArray model: aModel

	^ aBuilder pluggablePanelSpec new
		model: aModel;
		layout: #horizontal;
		children: (anArray collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: aModel; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!STool methodsFor: 'building' stamp: 'mp 2/3/2012 11:38:49.459'!
buildWindowOn: aBuilder

	self windowSpec: aBuilder pluggableWindowSpec new.
	self windowSpec
		model: self;
		label: #label;
		children: OrderedCollection new;
		closeAction: #windowIsClosed! !

!STool methodsFor: 'building' stamp: 'mp 3/4/2010 15:20'!
buildWith: aBuilder

	self windowMorph: (aBuilder build: self windowSpec).
	^ self windowMorph
	! !

!STool methodsFor: 'user interface' stamp: 'mp 1/19/2012 14:37:27.202'!
hideAllToolsDuring: aBlock
	| windows |
	windows := (SystemWindow allSubInstances select: [:each | each visible]).
	windows do: [:each | each hide].
	World restoreDisplay.
	^ aBlock 
		ensure: [
			windows do: [:each | each show].
			World restoreDisplay.].! !

!STool methodsFor: 'user interface' stamp: 'mp 1/19/2012 14:37:23.008'!
hideToolDuring: aBlock
	self windowMorph hide.
	World restoreDisplay.
	^ aBlock 
		ensure: [self windowMorph show.
			World restoreDisplay].! !

!STool methodsFor: 'user interface' stamp: 'mp 1/31/2013 17:40:54.487'!
initialExtent

	self subclassResponsibility.! !

!STool methodsFor: 'accessing' stamp: 'mp 6/15/2010 21:52'!
label

	^ 'tool title'! !

!STool methodsFor: 'user interface' stamp: 'mp 1/31/2013 17:40:34.737'!
resizeWindow

	self windowMorph extent: self initialExtent.! !

!STool methodsFor: 'building' stamp: 'mp 1/22/2011 14:56:58.095'!
setFrame: aRectangle in: aMorph

	| frame |
	frame := LayoutFrame new
				leftFraction: aRectangle left; 
				rightFraction: aRectangle right; 
				topFraction: aRectangle top; 
				bottomFraction: aRectangle bottom.
	aMorph layoutFrame: frame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.! !

!STool methodsFor: 'user interface' stamp: 'mp 7/16/2013 09:58:11.69'!
windowIsClosed
	"Can be overwritten by subclasses"! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowMorph
	^ windowMorph! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowMorph: anObject
	windowMorph := anObject! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowSpec
	^ windowSpec! !

!STool methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:33'!
windowSpec: anObject
	windowSpec := anObject! !

Object subclass: #STracer
	instanceVariableNames: 'entryPoints wrappers active project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

STracer subclass: #SStateViewTracer
	instanceVariableNames: 'observedClass instVarName valueDict gatheredValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Browser'!

!SStateViewTracer class methodsFor: 'instance creation' stamp: 'mp 1/24/2011 17:07:53.882'!
onClass: aClass instVarName: aSymbol
	^ (super 
		on: SProject current 
		entryPoints: (SProject current allTestsAsEntryPoints))
		observedClass: aClass;
		instVarName: aSymbol;
		yourself! !

!SStateViewTracer methodsFor: 'wrapper events' stamp: 'mp 9/29/2010 22:41:40.35'!
addValue: anObject

	self gatheredValues add: anObject.! !

!SStateViewTracer methodsFor: 'running' stamp: 'mp 9/29/2010 22:45:30.73'!
endExecutionOf: anEntryPoint withResult: anObject

	self gatheredValues ifNotEmpty: [
		self valueDict 
			at: anEntryPoint
			put: self gatheredValues].
	self reset.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.161'!
gatheredValues
	"Answer the value of gatheredValues"

	^ gatheredValues! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:10.166'!
gatheredValues: anObject
	"Set the value of gatheredValues"

	gatheredValues := anObject! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 9/29/2010 22:52:01.306'!
getWrapperClass

	^ SStateWrapper! !

!SStateViewTracer methodsFor: 'wrapper instrumentation' stamp: 'mp 8/9/2013 13:26:54.44'!
getWrapperOn: aSelector inClass: aClass
	
	self instVarName "self"
		ifNil: [(aClass = self observedClass)
				ifTrue: [^ super getWrapperOn: aSelector inClass: aClass]
				ifFalse: [^ nil]]
		ifNotNil: [
			((aClass whichSelectorsAccess: self instVarName) includes: aSelector)
				ifTrue: [	^ super getWrapperOn: aSelector inClass: aClass]
				ifFalse: [^ nil]]! !

!SStateViewTracer methodsFor: 'initialize-release' stamp: 'mp 9/29/2010 22:39:31.28'!
initialize
	super initialize.
	self valueDict: Dictionary new.
	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.497'!
instVarName
	"Answer the value of instVarName"

	^ instVarName! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:22:25.501'!
instVarName: anObject
	"Set the value of instVarName"

	instVarName := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.809'!
observedClass
	"Answer the value of observedClass"

	^ observedClass! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:52:26.814'!
observedClass: anObject
	"Set the value of observedClass"

	observedClass := anObject! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:39:47.398'!
reset

	self gatheredValues: OrderedCollection new.! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 21:58:58.701'!
selectedClasses

	^ {self observedClass}! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.472'!
valueDict
	"Answer the value of valueDict"

	^ valueDict! !

!SStateViewTracer methodsFor: 'accessing' stamp: 'mp 9/29/2010 22:27:24.476'!
valueDict: anObject
	"Set the value of valueDict"

	valueDict := anObject! !

!SStateViewTracer methodsFor: 'public api' stamp: 'mp 9/30/2010 10:46:18.705'!
valuesAsSet
	| resultSet |
	resultSet := Set new.
	self valueDict valuesDo: [:coll | 
		coll do: [:each | resultSet add: each]].
	^ resultSet sorted! !

!STracer class methodsFor: 'constants' stamp: 'mp 5/2/2012 10:47:49.924'!
ignoredPragmas
	^ #()! !

!STracer class methodsFor: 'instance creation' stamp: 'mp 1/24/2011 17:11:13.983'!
on: aProject
	^ self on: aProject entryPoints: aProject allTestsAsEntryPoints! !

!STracer class methodsFor: 'instance creation' stamp: 'mp 7/12/2010 13:49:56.027'!
on: aProject entryPoints: aCollection
	^ self new
		project: aProject;
		entryPoints: aCollection;
		yourself! !

!STracer methodsFor: 'accessing' stamp: 'mp 3/23/2011 16:38:36.756'!
activate
	self active: true.! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:00:52.702'!
active
	"Answer the value of active"

	^ active ifNil: [active := false]! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:59:23.159'!
active: anObject
	"Set the value of active"

	active := anObject! !

!STracer methodsFor: 'running' stamp: 'mp 7/12/2010 13:20:53.66'!
beginExecutionOf: anEntryPoint

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'accessing' stamp: 'mp 5/14/2013 14:57:30.581'!
blacklist

	^  {STracer -> #isActive. SContract class -> #result}
! !

!STracer methodsFor: 'running' stamp: 'mp 7/16/2013 11:29:52.758'!
checkForInitializingTestResourcesFor: anEntryPoint and: aTestClass
	| lastClass |
	lastClass := aTestClass.									
	anEntryPoint isTestCase
		ifTrue: [
			(lastClass notNil and: 
				[lastClass ~= anEntryPoint testClass])
					ifTrue: [self resetTestResourcesOf: lastClass.
							lastClass := nil].
			lastClass 
				ifNil: [self initializeTestResourceOf: anEntryPoint testClass.
					lastClass := anEntryPoint testClass]].
	^ lastClass! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 3/20/2013 15:53:30.95'!
createWrapperOn: aClass and: aSelector
	| wrapper |
	(self blacklist includes: aClass -> aSelector)
		ifFalse: [wrapper := self getWrapperOn: aSelector inClass: aClass.
				wrapper 
					ifNotNil: [self wrappers add: wrapper.
							 wrapper install]].! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 11/19/2010 20:11:43.228'!
createWrappers
	self selectedClasses do: [:klass | 
			klass selectors do: [:selector | 
				self createWrapperOn: klass and: selector].		
			klass class selectors do: [:selector | 
				self createWrapperOn: klass class and: selector]].! !

!STracer methodsFor: 'accessing' stamp: 'mp 3/23/2011 16:38:42.169'!
deactivate
	self active: false.! !

!STracer methodsFor: 'helper' stamp: 'mp 1/24/2012 15:23:00.504'!
disableTimeoutOfEntryPoints
	self entryPoints do: [:each | each disableTimeout].! !

!STracer methodsFor: 'running' stamp: 'mp 7/12/2010 13:21:16.932'!
endExecutionOf: anEntryPoint withResult: anObject

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.746'!
entryPoints
	"Answer the value of entryPoints"

	^ entryPoints! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.75'!
entryPoints: anObject
	"Set the value of entryPoints"

	entryPoints := anObject! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/12/2010 13:33:44.599'!
getWrapperClass
	"Wrapper should be a subclass of SWrapper 
	otherwise overwrite #getWrapperOn:inClass:"
	^ SWrapper! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/13/2010 16:07:00.628'!
getWrapperOn: aSelector inClass: aClass

	^ self getWrapperClass on: aSelector inClass: aClass with: self! !

!STracer methodsFor: 'helper' stamp: 'mp 1/24/2012 14:50:39.053'!
hideAllToolsDuring: aBlock
	| windows |
	windows := (SystemWindow allSubInstances select: [:each | each visible]).
	windows do: [:each | each hide].
	World restoreDisplay.
	^ aBlock 
		ensure: [
			windows do: [:each | each show].
			World restoreDisplay.].! !

!STracer methodsFor: 'helper' stamp: 'mp 5/2/2012 10:47:09.743'!
ignorePragmaMarkedEntryPoints
	self entryPoints: (self entryPoints select: [:each | 
		self class ignoredPragmas 
			allSatisfy: [:pragma | (each compiledMethod pragmaAt: pragma) isNil]]).! !

!STracer methodsFor: 'test resources' stamp: 'mp 4/19/2013 11:13:05.914'!
initializeTestResourceOf: aTestClass
	aTestClass resources do: [:each |
		each isAvailable ifFalse: [each signalInitializationError]].! !

!STracer methodsFor: 'testing' stamp: 'mp 7/12/2010 12:59:46.127'!
isActive

	^ self active! !

!STracer methodsFor: 'public api' stamp: 'mp 3/25/2011 11:55:58.04'!
pathFinderTool
	^ SPathFinder! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 12:45:26.775'!
postProcessing

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 12:44:53.329'!
preProcessing

	"Can be overwritten in subclasses"! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:49:11.915'!
project

	^ project! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 13:49:23.782'!
project: anObject
	"Set the value of project"

	project := anObject! !

!STracer methodsFor: 'wrapper instrumentation' stamp: 'mp 7/13/2010 14:36:10.856'!
removeWrappers

	self wrappers do: [:each | each uninstall].
	self wrappers: nil.
	Smalltalk garbageCollect.! !

!STracer methodsFor: 'test resources' stamp: 'mp 4/19/2013 11:13:24.599'!
resetTestResourcesOf: aTestClass
	aTestClass resources do: [:each | each reset]! !

!STracer methodsFor: 'public api' stamp: 'mp 9/22/2011 15:16:12.578'!
run
	| begin |
	[self preProcessing.
	begin := DateAndTime now.
	self
		createWrappers;
		runEntryPoints] 
	ensure: [self removeWrappers].
	Transcript show: DateAndTime now - begin; cr.
	self postProcessing.! !

!STracer methodsFor: 'running' stamp: 'mp 11/19/2010 18:00:44.938'!
runEntryPoint: anEntryPoint
	| result |
	self beginExecutionOf: anEntryPoint.
	self startTracing.
	result := anEntryPoint execute.
	self stopTracing.
	self endExecutionOf: anEntryPoint withResult: result.! !

!STracer methodsFor: 'running' stamp: 'mp 7/16/2013 11:29:59.303'!
runEntryPoints
	| size lastTestCaseClass |
	lastTestCaseClass := nil.
	size := self entryPoints size.
	[self entryPoints 
		do: [:each | 
			lastTestCaseClass := self checkForInitializingTestResourcesFor: each 
										and: lastTestCaseClass.
			self runEntryPoint: each	] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', size asString, ' Entry Points.']]
		ensure: [lastTestCaseClass 
					ifNotNil: [self resetTestResourcesOf: lastTestCaseClass.]].! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:48:03.01'!
selectedClasses

	^ self project allClasses! !

!STracer methodsFor: 'helper' stamp: 'mp 1/24/2012 14:48:27.776'!
setOnlyPassingTestsAsEntryPoints
	| size passingTests |
	size := self entryPoints size.
	passingTests := OrderedCollection new.
	self entryPoints 
		do: [:each | each execute hasPassed
					ifTrue: [passingTests add: each]] 
		displayingProgress: [:each | 
			'Processing ', each asString, ' out of ', size asString, ' Entry Points.'].
	self entryPoints: passingTests.! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 13:41:19.462'!
startTracing
	"Can be overwritten in subclasses"
	self active: true.! !

!STracer methodsFor: 'tracing' stamp: 'mp 7/12/2010 13:41:22.317'!
stopTracing
	"Can be overwritten in subclasses"
	self active: false.! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:42:26.035'!
wrappers
	"Answer the value of wrappers"

	^ wrappers ifNil: [wrappers := OrderedCollection new]! !

!STracer methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:23.758'!
wrappers: anObject
	"Set the value of wrappers"

	wrappers := anObject! !

Object subclass: #STreeModel
	instanceVariableNames: 'selectedItem highlightedItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Models'!

!STreeModel methodsFor: 'public api' stamp: 'mp 12/11/2009 13:56'!
clearHighlightedItems

	self highlightedItems: nil.
	self changed: #highlightItem:.! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 14:07'!
getChildren: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 13:57'!
getIcon: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'private' stamp: 'mp 12/11/2009 13:58'!
getIconWithColor: aColor

	^ (Form extent: 10@10 depth: 32)
				fillColor: aColor! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 14:07'!
hasChildren: aNode

	self subclassResponsibility.! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 1/13/2010 19:06'!
hasSelectedItem

	^ self selectedItem notNil! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 12/11/2009 13:59'!
highlightItem: aNode

	^ self highlightedItems includes: aNode! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
highlightedItems
	^ highlightedItems ifNil: [highlightedItems := Set new]! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
highlightedItems: anObject
	highlightedItems := anObject! !

!STreeModel methodsFor: 'spec commands' stamp: 'mp 1/21/2010 11:15'!
newSelectedItem: aNode

	self selectedItem: aNode.! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
selectedItem
	^ selectedItem! !

!STreeModel methodsFor: 'accessing' stamp: 'mp 12/11/2009 13:52'!
selectedItem: anObject
	selectedItem := anObject! !

TestRunner subclass: #SPathMapTestRunner
	instanceVariableNames: 'windowMorph pathMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Map'!

!SPathMapTestRunner class methodsFor: 'initialization' stamp: 'mp 7/8/2010 18:34:13.166'!
initialize
	"self initialize"
	self registerInWorldMenu.! !

!SPathMapTestRunner class methodsFor: 'instance-creation' stamp: 'mp 3/7/2012 09:44:14.092'!
open
	SProject isNullProjectSelected
		ifTrue: [self inform: 'Please choose a project first and start PathMap again.'.
				^ SProjectChooser open].
	^ super open.! !

!SPathMapTestRunner class methodsFor: 'initialization' stamp: 'mp 3/7/2011 21:49:49.479'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'PathMap' 
			with: (Array
				with: self
				with: #open)) ].! !

!SPathMapTestRunner class methodsFor: 'window color' stamp: 'mp 8/14/2013 15:07:03.923'!
windowColorSpecification

	^ WindowColorSpec 
		classSymbol: self name 
		wording: 'PathMap - Test Runner' 
		brightColor:  #white
		pastelColor: #white
		helpMessage: 'PathMap - Extended Test Runner Feedback for SUnit'! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 9/21/2010 13:51:38.749'!
addColorLegendOn: aModel to: aSymbol inFrame: aRectangle
	| flap colorLegend |
	flap := self getFlap: aSymbol.
	colorLegend := SColorLegendMorph on: aModel.
	aModel 
		colorLegend: colorLegend;
		refreshColorLegend.
	self setFrame: aRectangle in: colorLegend.
	flap addMorph: colorLegend.
	colorLegend hide.

! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 7/16/2013 11:25:40.008'!
addDropDownSelectionListTo: aSymbol on: aModel with: aCollection inFrame: aRectangle
	| flap dropDownList |
	flap := self getFlap: aSymbol.
	dropDownList := SDropDownMorph on: aModel with: aCollection.
	flap addMorph: dropDownList.
	self setFrame: aRectangle in: dropDownList.
	dropDownList 
		cornerStyle: #rounded;
		hResizing: #rigid;
		hide.
	^ dropDownList! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 7/16/2013 11:26:10.301'!
addDropDownSelectionListTo: aSymbol on: aModel with: aCollection inFrame: aRectangle entriesChanged: aMessage
	| dropDownList |
	dropDownList := self 
						addDropDownSelectionListTo: aSymbol 
						on: aModel 
						with: aCollection 
						inFrame: aRectangle.
	aModel addDependent: dropDownList.
	dropDownList entriesChangedSelector: aMessage.
	^ dropDownList! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 8/14/2013 09:51:46.541'!
addTitle: aString toFlap: aSymbol inFrame: aRectangle
	| title flap |
	flap := self getFlap: aSymbol.
	title := SLabelMorph label: aString.
	title labelMorphs do: [:each | 
		each
			fontName: Preferences standardDefaultTextFont familyName 
			size: 100].
	self setFrame: aRectangle in: title.
	flap addMorph: title.
	title 
		hResizing: #rigid;
		width: 145; "ToDo: Change this hard value!!"
		hide.

! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 1/20/2010 15:29'!
alwaysEnabled

	^ true! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 3/15/2010 17:02'!
buildButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #vertical;
		children: (self buttons collect: [ :each |
			aBuilder pluggableButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				enabled: each third;
				yourself ]);
		yourself.! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 1/20/2012 09:45:23.194'!
buildCustomMorphs

	self 
		buildPathMapMorphFrame: (0.224 @ 0.045 corner: 0.996 @ 0.944);
		buildTestQualityFlapCustomMorphs;
		buildProfilingFlapCustomMorphs;
		buildFaultLocalizationFlapCustomMorphs;
		buildInductiveAnalysisCustomMorphs;
		buildTraceabilityFlapCustomMorphs;
		buildOptionsFlapCustomMorphs.
! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 10/31/2010 10:02:10.841'!
buildFaultLocalizationFlapCustomMorphs
	| id options |
	id := #faultLocalization.
	options := self pathMap options at: id.
	self 
		addTitle: 'Fault Localization' 
			toFlap: id 
			inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.0825);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.19 corner: 1.0 @ 0.725);
		addDropDownSelectionListTo: id
			on: options
			with: {{'Ochiai'. #setFormula:. {#ochiai}}.
				   {'Tarantula'. #setFormula:. {#tarantula}}.
				   {'Jaccard'. #setFormula:. {#jaccard}}}
			inFrame: (0.0 @ 0.09 corner: 1.0 @ 0.18).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 8/14/2013 09:34:32.486'!
buildFaultLocalizationFlapWith: aBuilder
	| id |
	id := #faultLocalization.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SPathToolsIcons radiobugIcon;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.73 corner: 1.0 @ 0.821);
					label: 'Single Fault';
					action: #switchSinglePointOfFault;
					state: #singlePointOfFault;
					yourself).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.821 corner: 1.0 @ 0.912);
					label: 'Highscore';
					action: #showHighscore;
					yourself ).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.912 corner: 1.0 @ 1.0);
					label: 'Developer Ranking';
					action: #authorRanking;
					yourself ).
				};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 8/14/2013 09:50:30.118'!
buildInductiveAnalysisCustomMorphs
	| id options |
	id := #inductive.
	options := self pathMap options at: id.
	self 
		addTitle: 'Induction' 
			toFlap: #inductive 
			inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.09);
		addColorLegendOn: options
			to: id
			inFrame: (0.0 @ 0.2 corner: 1.0 @ 0.79);
		addDropDownSelectionListTo: id
			on: options
			with: SHarvester createAListOfAllHarvester
			inFrame: (0.0 @ 0.1 corner: 1.0 @ 0.1975).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 8/13/2013 17:33:28.155'!
buildInductiveAnalysisFlapWith: aBuilder
	| id |
	id := #inductive.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SPathToolsIcons collapseIcon;
		model: self;
		children: {(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8 corner: 1.0 @ 0.8975);
					label: 'Add Contracts';
					action: #addContracts;
					enabled: #isAddingContractsPossible;
					yourself).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8975 corner: 1.0 @ 1.0);
					label: 'Remove Contracts';
					action: #removeContracts;
					enabled: #isRemovingContractsPossible;
					yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 5/10/2012 12:55:31.655'!
buildOptionsFlapCustomMorphs
	self 
		addTitle: 'Global Options' 
		toFlap: #globalOptions 
		inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.15).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 8/13/2013 17:35:24.562'!
buildOptionsFlapWith: aBuilder
	| id |
	id := #globalOptions.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SPathToolsIcons setupIcon;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.16 corner: 1.0 @ 0.32);
					label: 'Show Meth. Categories';
					action: #switchShowMethodCategories;
					state: #showMethodCategories;
					yourself).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.32 corner: 1.0 @ 0.48);
					label: 'Show All Methods';
					action: #switchShowAllMethods;
					state: #showAllMethods;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.48 corner: 1.0 @ 0.64);
					label: 'Ignore Setup Code';
					action: #switchIgnoreTracingOfSetUpAndTearDownMethods;
					state: #ignoreTracingOfSetUpAndTearDownMethods;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.64 corner: 1.0 @ 0.8);
					label: 'Visualize Inter-Steps';
					action: #switchVisualizeIntermediateSteps;
					state: #visualizeIntermediateSteps;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8 corner: 1.0 @ 0.96);
					label: 'Show Test Results';
					action: #switchShowTestResults;
					state: #showTestResults;
					yourself )};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 1/2/2012 14:55:37.585'!
buildPathMapMorphFrame: aRectangle
	| root |
	root := self pathMap rootMorph.
	self setFrame: aRectangle in: root.
	self windowMorph addMorph: root.! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 8/13/2013 17:55:11.751'!
buildPluggableMorphsOn: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; 
		label: self label; 
		extent: self extent;
		children: (OrderedCollection new 		
			add: ((self buildClassesWith: aBuilder)
				frame: (0.0 @ 0.00 corner: 0.22 @ 0.775 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.22 @ 0.00 corner: 1.00 @ 0.04);
				yourself);
			add: ((self buildProjectStatisticWith: aBuilder)
				frame: (0.22 @ 0.946 corner: 1.00 @ 1.00);
				yourself);
			add: ((self buildButtonsWith: aBuilder)
				frame: (0.00 @ 0.775 corner: 0.22 @ 1.00);
				yourself);
			add: ((self buildTestQualityFlapWith: aBuilder)
				frame: (1.0 @ -0.0075 corner: 1.3 @ 0.4795);
				yourself);
			add: ((self buildProfilingFlapWith: aBuilder)
				frame: (1.0 @ 0.064 corner: 1.3 @ 0.564);
				yourself);
			add: ((self buildFaultLocalizationFlapWith: aBuilder)
				frame: (1.0 @ 0.137 corner: 1.3 @ 0.687);
				yourself);
			add: ((self buildInductiveAnalysisFlapWith: aBuilder)	
				frame: (1.0 @ 0.208 corner: 1.3 @ 0.708);
				yourself);											
			add: ((self buildTraceabilityFlapWith: aBuilder)
				frame: (1.0 @ 0.281 corner: 1.3 @ 0.881);
				yourself);
			add: ((self buildOptionsFlapWith: aBuilder)
				frame: (1.0 @ 0.352 corner: 1.3 @ 0.669);
				yourself);												
			yourself);
		yourself.
	self windowMorph: (aBuilder build: window).
	^ self windowMorph! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 8/14/2013 09:53:33.937'!
buildProfilingFlapCustomMorphs
	| id options |
	id := #profiling.
	options := self pathMap options at: id.	
	self 
		addTitle: '  Profiling  ' toFlap: #profiling inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.09);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.305 corner: 1.0 @ 0.895);
		addDropDownSelectionListTo: id
			on: options
			with: {{'Method Calls'. #setKindOfProfiling:. {#numberOfMethodCalls}}.
				   {'# Instances'. #setKindOfProfiling:. {#numberOfInstances}}.
				   {'Run-time'. #setKindOfProfiling:. {#runtime}}.
				   {'Run-time / Call'. #setKindOfProfiling:. {#runtimePerCall}}}
			inFrame: (0.0 @ 0.1 corner: 1.0 @ 0.1975).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 8/13/2013 17:34:57.81'!
buildProfilingFlapWith: aBuilder
	| id |
	id := #profiling.
	^ aBuilder pluggableFlapSpec new
		name: #profiling;
		icon: SPathToolsIcons dashboardIcon;
		model: self;
		children: {(aBuilder pluggableCheckBoxSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.2 corner: 1.0 @ 0.2975);
					label: 'Profile Leafs';
					action: #switchLeafProfilingRuntime;
					state: #leafProfiling;
					enabled: #isRuntimeProfilingSelected;
					yourself).
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.8975 corner: 1.0 @ 1.0);
					label: 'Highscore';
					action: #showHighscore;
					yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 7/8/2010 18:13:25.231'!
buildProjectStatisticWith: aBuilder

	^ aBuilder pluggableInputFieldSpec new
		model: self pathMap;
		getText: #projectStatisticText;
		yourself.! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 8/14/2013 09:48:23.648'!
buildTestQualityFlapCustomMorphs
	| id options |
	id := #testQuality.
	options := self pathMap options at: id.
	self 
		addTitle: 'Test Quality' toFlap: id inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.095);
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.43 corner: 1.0 @ 1.0);
		addDropDownSelectionListTo: id
			on: options
			with: {'Methods' -> #methodCoverage. 
				   'Test Intensity' -> #intensityCoverage.
				   'Statements' -> #statementCoverage.}
			inFrame: (0.0 @ 0.32 corner: 1.0 @ 0.425)	;
		addDropDownSelectionListTo: id
			on: options
			with: {'No Static Metric' -> #staticMetricNone. 
				   'Authors' -> #staticMetricAuthors.
				   'Last Changes' -> #staticMetricLastChanges.
				   'Lines of Code' -> #staticMetricLinesOfCode.
				   'Complexity' -> #staticMetricComplexity.
				   'Variables Access' -> #staticMetricAccessedVariables.}
			inFrame: (0.0 @ 0.1 corner: 1.0 @ 0.205).

! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 8/13/2013 17:34:45.782'!
buildTestQualityFlapWith: aBuilder
	| id |
	id := #testQuality.
	^ aBuilder pluggableFlapSpec new
		name: id;
		icon: SPathToolsIcons premiumIcon;
		model: self;
		children: {
				(aBuilder pluggableButtonSpec new
					model: (self pathMap options at: id); 
					frame: (0.0 @ 0.21 corner: 1.0 @ 0.3075);
					label: 'Sort Methods by Metric';
					action: #sortMethodsToStaticMetric;
					enabled: #sortMethodsIsEnabled;
					yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building-customs' stamp: 'mp 2/3/2012 12:15:21.557'!
buildTraceabilityFlapCustomMorphs
	| id options |
	id := #traceability.
	options := self pathMap options at: id.
	self 
		addTitle: 'Traceability' toFlap: #traceability inFrame: (0.0 @ 0.0 corner: 1.0 @ 0.075);
		addDropDownSelectionListTo: id
			on: options
			with: (self pathMap project concerns groups keys 
					collect: [:each | {each. #setConcernGroup:. {each}}])
			inFrame: (0.0 @ 0.083 corner: 1.0 @ 0.166)
			entriesChanged: #newConcernGroups;
		addColorLegendOn: options
			to: id 
			inFrame: (0.0 @ 0.659 corner: 1.0 @ 0.825).! !

!SPathMapTestRunner methodsFor: 'building-flaps' stamp: 'mp 8/13/2013 17:35:10.55'!
buildTraceabilityFlapWith: aBuilder
	| id options |
	id := #traceability.
	options := self pathMap options at: id.
	^ aBuilder pluggableFlapSpec new
		name: #traceability;
		icon: SPathToolsIcons piramidIcon;
		model: self;
		children: {(SPluggableMultiSelectionListSpec new
					model: options;
					name: #concernList;
					list: #allConcerns;
					itemColor: #concernColorAt:;
					getSelectionList: #selectedConcernAt:;
					setSelectionList: #selectedConcernAt:put:;
					frame: (0.0 @ 0.1725 corner: 1.0 @ 0.5575);
					yourself ).
				(aBuilder pluggableButtonSpec new
					model: options;
					frame: (0.0 @ 0.5675 corner: 1.0 @ 0.65);
					label: 'Concerns...';
					action: #chooseConcerns;
					yourself).
				(aBuilder pluggableCheckBoxSpec new
					model: options; 
					frame: (0.0 @ 0.83 corner: 1.0 @ 0.913);
					label: 'Specific Only';
					action: #switchSpecificConcernMethodsOnly;
					state: #specificConcernMethodsOnly;
					yourself ).
				(aBuilder pluggableCheckBoxSpec new
					model: options; 
					frame: (0.0 @ 0.913 corner: 1.0 @ 1.0);
					label: 'Multiple Colors';
					action: #switchMultipleColorsPerMethod;
					state: #multipleColorsPerMethod;
					yourself ).};
		yourself! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 9/13/2010 19:09:46.801'!
buildWith: aBuilder
	self 
		buildPluggableMorphsOn: aBuilder;
		buildCustomMorphs.
	^ self windowMorph! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 3/14/2012 17:38:44.95'!
buttons
	"label action enabled"
	^ #(( 'Run Selected' #runAll #hasRunnable )
		( 'Run with Contracts' #runAllWithContracts #hasContracts )
		( 'Run Failures' #runFailures #hasFailures )
		( 'Run Errors' #runErrors #hasErrors ) )
! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/23/2012 10:21:31.119'!
errorListPure
	^ errorList! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 3/16/2010 14:09'!
extent

	^ 650 @ 580! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/23/2012 10:21:17.432'!
failedListPure
	^ failedList! !

!SPathMapTestRunner methodsFor: 'utilities' stamp: 'mp 3/20/2013 14:04:24.975'!
findCategories
	| foundedCategories |
	foundedCategories := super findCategories.
	^ foundedCategories select: [:each | self project categories includes: each]! !

!SPathMapTestRunner methodsFor: 'utilities' stamp: 'mp 3/2/2010 17:13'!
findClassesForCategories: aCollection

	| items |
	aCollection isEmpty 
		ifTrue: [ ^ #() ].
	items := aCollection gather: [ :category |
		((Smalltalk organization listAtCategoryNamed: category)
			collect: [ :each | Smalltalk at: each ])
			select: [ :each | each includesBehavior: self baseClass ] ].
	^ items asSet.! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 9/16/2010 11:50:05.225'!
getFlap: aSymbol
	^ self windowMorph paneMorphs 
		detect: [:each | each externalName asSymbol == aSymbol]! !

!SPathMapTestRunner methodsFor: 'utilities' stamp: 'mp 5/8/2012 11:22:28.952'!
getOpenedAnalysisFlap
	self flag: #mpe. "Refactor the fragile code without morphic methods!!"
	^ self windowMorph paneMorphs 
		detect: [:each | (each isKindOf: SPluggableFlapMorph) and: [each isExpanded]] 
		ifNone: [nil].! !

!SPathMapTestRunner methodsFor: 'testing' stamp: 'mp 3/14/2012 17:40:02.626'!
hasContracts
	^ self hasRunnable and: [self pathMap project hasContracts]! !

!SPathMapTestRunner methodsFor: 'initialization' stamp: 'mp 7/16/2013 11:27:02.396'!
initialize
	super initialize.
	"self suitesAt: 1 put: true. ""Select all tests"
	self pathMap: (SPMPathMap on: self).
	self addDependent: self pathMap.
	self update. "Changed does not work'"
	self pathMap project includesTests
		ifFalse: [self inform: 'The current project does not include any test case.', 
							String cr, 
							'PathMap will be limited to static analysis only.'].! !

!SPathMapTestRunner methodsFor: 'accessing-ui' stamp: 'mp 7/9/2010 09:53:13.247'!
label
	^ 'PathMap'! !

!SPathMapTestRunner methodsFor: 'user interface' stamp: 'mp 1/2/2012 14:58:06.184'!
modelWakeUp
	self pathMap isDirty
		ifTrue: [self pathMap rebuildPathMapWithSortByMetric].! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/8/2010 18:12:23.231'!
pathMap
	"Answer the value of pathMap"

	^ pathMap! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 7/8/2010 18:12:23.235'!
pathMap: anObject
	"Set the value of pathMap"

	pathMap := anObject! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 3/20/2013 13:55:29.727'!
project
	^ (self pathMap isNil or: [self pathMap project isNil])
		ifTrue: [SProject current]
		ifFalse: [self pathMap project].! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 5/8/2012 11:51:52.671'!
run: aSymbol
	| flap |
	flap := self getOpenedAnalysisFlap. 
	(flap isNil or: [flap externalName asSymbol == #globalOptions])
		ifTrue: [self pathMap runTests: aSymbol]
		ifFalse: [self pathMap runTests: aSymbol with: flap externalName asSymbol].! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 5/8/2012 11:52:20.578'!
runAll
	self run: #suiteAll.! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 5/14/2013 15:00:48.186'!
runAllWithContracts
	| violations |
	violations := Dictionary new.
	[[self runAll] runWithContracts: self pathMap project projectName]
		on: SContractViolation
		do: [:exception | (violations 
							at: exception methodReference
							ifAbsentPut: [Bag new]) add: exception.		
						exception resume].
	self pathMap 
		violations: violations;
		addViolations.! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 5/8/2012 11:52:58.28'!
runErrors
	self run: #suiteErrors.! !

!SPathMapTestRunner methodsFor: 'actions' stamp: 'mp 5/8/2012 11:52:52.122'!
runFailures
	self run: #suiteFailures.! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 3/20/2013 13:56:30.811'!
selectedClasses

	^ Smalltalk allClasses select: [:aClass | 
		(self project categories includes: aClass category) 
		and: [(aClass inheritsFrom: TestCase) not]]! !

!SPathMapTestRunner methodsFor: 'building' stamp: 'mp 9/15/2010 17:31:24.77'!
setFrame: aRectangle in: aMorph

	| frame |
	frame := LayoutFrame new
				leftFraction: aRectangle left; 
				rightFraction: aRectangle right; 
				topFraction: aRectangle top; 
				bottomFraction: aRectangle bottom.
	aMorph layoutFrame: frame.
	aMorph hResizing: #spaceFill; vResizing: #spaceFill.! !

!SPathMapTestRunner methodsFor: 'updating' stamp: 'mp 5/27/2010 13:22'!
updateCategories
	categories := self findCategories.
	categoriesSelected := categories.
	self changed: #categoryList; changed: #categorySelected.! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:29'!
windowMorph
	^ windowMorph! !

!SPathMapTestRunner methodsFor: 'accessing' stamp: 'mp 1/20/2010 15:29'!
windowMorph: anObject
	windowMorph := anObject! !

!TestResource class methodsFor: '*Path-Core' stamp: 'mp 4/19/2013 10:42:06.277'!
isInitialized
	"Return if the singleton object has already been created or not. 
	#isAvailable includes a side effect that always creates the singleton."
	^ current notNil! !

MwMethodWrapper subclass: #SWrapper
	instanceVariableNames: 'tracer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tracer'!

SWrapper subclass: #SStateWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Path-Core-Tools-Browser'!

!SStateWrapper methodsFor: 'evaluating' stamp: 'mp 8/9/2013 13:46:38.467'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| value |
	self beforeMethod.
	^ [
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [self afterMethod.
			self tracer isActive
				ifTrue: [
					self tracer deactivate.
					value := self tracer instVarName
						ifNil: [anObject]
						ifNotNil: [anObject instVarNamed: self tracer instVarName].
					self tracer addValue: value asString.
					self tracer activate]]! !

!SWrapper class methodsFor: 'instance creation' stamp: 'mp 5/28/2013 11:04:23.997'!
canWrap: aSymbol inClass: aClass
	| selectors |
	(super canWrap: aSymbol inClass: aClass) ifFalse: [^ false].
	(aClass == SClassA) ifTrue: [^ false]. "Required for SBeforeWrapperTest"
	selectors := #( #addToCoveredMethods: #coveredMethods #coveredMethods:).
	(aClass == SPMTRCoverageTracer and: [selectors includes: aSymbol]) ifTrue: [^ false].
	((aClass == STracer) and: [aSymbol == #active]) ifTrue: [^ false].
	((aClass == SPMTRProfilingTracer) or: [aClass inheritsFrom: SPMTRProfilingTracer]) 
		ifTrue: [^ false].
	^ true! !

!SWrapper class methodsFor: 'class initialization' stamp: 'mp 7/12/2010 12:38:44.486'!
initialize
	"doIt: [self initialize]"

	super initialize.! !

!SWrapper class methodsFor: 'instance creation' stamp: 'mp 11/19/2010 16:28:44.67'!
on: aSymbol inClass: aClass with: aTracer
	| wrapper |
	wrapper := (self on: aSymbol inClass: aClass).
	wrapper ifNotNil: [wrapper tracer: aTracer].
	^ wrapper! !

!SWrapper methodsFor: 'converting' stamp: 'mp 7/12/2010 15:45:00.131'!
asMethodReference

	^ MethodReference class: self wrappedClass selector: self clientSelector! !

!SWrapper methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:18.786'!
tracer
	"Answer the value of tracer"

	^ tracer! !

!SWrapper methodsFor: 'accessing' stamp: 'mp 7/12/2010 12:38:18.79'!
tracer: anObject
	"Set the value of tracer"

	tracer := anObject! !
SBrowser initialize!
SProject initialize!
SPathFinder initialize!
SPathView initialize!
SProjectChooser initialize!
SPathMapTestRunner initialize!
SWrapper initialize!
